# NonlinearSolve.jl

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/NonlinearSolve/stable/)
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.10397607.svg)](https://doi.org/10.5281/zenodo.10397607)

[![codecov](https://codecov.io/gh/SciML/NonlinearSolve.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/SciML/NonlinearSolve.jl)
[![Build Status](https://github.com/SciML/NonlinearSolve.jl/workflows/CI/badge.svg)](https://github.com/SciML/NonlinearSolve.jl/actions?query=workflow%3ACI)
[![Build status](https://badge.buildkite.com/413dc8df7d555cc14c262aba066503a9e7a42023f9cfb75a55.svg?branch=master)](https://buildkite.com/julialang/nonlinearsolve-dot-jl)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

Fast implementations of root finding algorithms in Julia that satisfy the SciML common interface.

For information on using the package,
[see the stable documentation](https://docs.sciml.ai/NonlinearSolve/stable/). Use the
[in-development documentation](https://docs.sciml.ai/NonlinearSolve/dev/) for the version of
the documentation which contains the unreleased features.

## High Level Examples

```julia
using NonlinearSolve, StaticArrays

f(u, p) = u .* u .- 2
u0 = @SVector[1.0, 1.0]
prob = NonlinearProblem(f, u0)
sol = solve(prob)

## Bracketing Methods

f(u, p) = u .* u .- 2.0
u0 = (1.0, 2.0) # brackets
prob = IntervalNonlinearProblem(f, u0)
sol = solve(prob)
```

## Citation

If you found this library to be useful in academic work, then please cite:

```bibtex
@article{pal2024nonlinearsolve,
  author = {Pal, Avik and Holtorf, Flemming and Larsson, Axel and Loman, Torkel and Utkarsh and Sch\"{a}fer, Frank and Qu, Qingyu and Edelman, Alan and Rackauckas, Chris},
  title = {NonlinearSolve.jl: High-Performance and Robust Solvers for Systems of Nonlinear Equations in Julia},
  year = {2025},
  publisher = {Association for Computing Machinery},
  address = {New York, NY, USA},
  issn = {0098-3500},
  url = {https://doi.org/10.1145/3779117},
  doi = {10.1145/3779117},
  abstract = {Efficiently solving nonlinear equations underpins numerous scientific and engineering disciplines, yet scaling these solutions for challenging system models remains a challenge. This paper presents NonlinearSolve.jl – a suite of high-performance open-source nonlinear equation solvers implemented natively in the Julia programming language. NonlinearSolve.jl distinguishes itself by offering a unified API that accommodates a diverse range of solver specifications alongside features such as automatic algorithm selection based on runtime analysis, support for static array kernels for improved GPU computation on smaller problems, and the utilization of sparse automatic differentiation and Jacobian-free Krylov methods for large-scale problem-solving. Through rigorous comparison with established tools such as PETSc SNES, Sundials KINSOL, and MINPACK, NonlinearSolve.jl demonstrates robustness and efficiency, achieving significant advancements in solving nonlinear equations while being implemented in a high-level programming language. The capabilities of NonlinearSolve.jl unlock new potentials in modeling and simulation across various domains, making it a valuable addition to the computational toolkit of researchers and practitioners alike.},
  note = {Just Accepted},
  journal = {ACM Trans. Math. Softw.},
  month = dec,
  keywords = {Nonlinear Systems, Root Finding, Sparsity Detection, Automatic Differentiation, JuliaLang}
}
```

using NonlinearSolveBase, SciMLBase, StableRNGs, ForwardDiff, Random, LinearAlgebra

true_function(x, θ) = @. θ[1] * exp(θ[2] * x) * cos(θ[3] * x + θ[4])
true_function(y, x, θ) = (@. y = θ[1] * exp(θ[2] * x) * cos(θ[3] * x + θ[4]))

θ_true = [1.0, 0.1, 2.0, 0.5]
x = [-1.0, -0.5, 0.0, 0.5, 1.0]

const y_target = true_function(x, θ_true)

function loss_function(θ, p)
    ŷ = true_function(p, θ)
    return ŷ .- y_target
end

function loss_function(resid, θ, p)
    true_function(resid, p, θ)
    resid .= resid .- y_target
    return resid
end

θ_init = θ_true .+ randn!(StableRNG(0), similar(θ_true)) * 0.1

function vjp(v, θ, p)
    resid = zeros(length(p))
    J = ForwardDiff.jacobian((resid, θ) -> loss_function(resid, θ, p), resid, θ)
    return vec(v' * J)
end

function vjp!(Jv, v, θ, p)
    resid = zeros(length(p))
    J = ForwardDiff.jacobian((resid, θ) -> loss_function(resid, θ, p), resid, θ)
    mul!(vec(Jv), transpose(J), v)
    return nothing
end

prob_oop = NonlinearLeastSquaresProblem{false}(loss_function, θ_init, x)
prob_iip = NonlinearLeastSquaresProblem{true}(
    NonlinearFunction(loss_function; resid_prototype = zero(y_target)), θ_init, x
)
prob_oop_vjp = NonlinearLeastSquaresProblem(
    NonlinearFunction{false}(loss_function; vjp), θ_init, x
)
prob_iip_vjp = NonlinearLeastSquaresProblem(
    NonlinearFunction{true}(loss_function; resid_prototype = zero(y_target), vjp = vjp!),
    θ_init, x
)

export prob_oop, prob_iip, prob_oop_vjp, prob_iip_vjp
export true_function, θ_true, x, y_target, loss_function, θ_init

@testitem "NLLS Analytic Jacobian" tags = [:core] begin
    dataIn = 1:10
    f(x, p) = x[1] * dataIn .^ 2 .+ x[2] * dataIn .+ x[3]
    dataOut = f([1, 2, 3], nothing) + 0.1 * randn(10, 1)

    resid(x, p) = f(x, p) - dataOut
    jac(x, p) = [dataIn .^ 2 dataIn ones(10, 1)]
    x0 = [1, 1, 1]

    prob = NonlinearLeastSquaresProblem(resid, x0)
    sol1 = solve(prob)

    nlfunc = NonlinearFunction(resid; jac)
    prob = NonlinearLeastSquaresProblem(nlfunc, x0)
    sol2 = solve(prob)

    @test sol1.u ≈ sol2.u
end

@testitem "Basic PolyAlgorithms" tags = [:nopre] begin
    f(u, p) = u .* u .- 2
    u0 = [1.0, 1.0]

    prob = NonlinearProblem(f, u0)

    polyalgs = (
        RobustMultiNewton(), FastShortcutNonlinearPolyalg(), nothing, missing,
        NonlinearSolvePolyAlgorithm((Broyden(), LimitedMemoryBroyden())),
    )

    @testset "Direct Solve" begin
        @testset for alg in polyalgs
            alg = alg === missing ? () : (alg,)
            sol = solve(prob, alg...; abstol = 1.0e-9)
            @test SciMLBase.successful_retcode(sol)
            err = maximum(abs, f(sol.u, 2.0))
            @test err < 1.0e-9
        end
    end

    @testset "Caching Interface" begin
        @testset for alg in polyalgs
            alg = alg === missing ? () : (alg,)
            cache = init(prob, alg...; abstol = 1.0e-9)
            solver = solve!(cache)
            @test SciMLBase.successful_retcode(solver)
            SciMLBase.reinit!(cache, u0)
        end
    end

    @testset "Step Interface" begin
        @testset for alg in polyalgs
            alg = alg === missing ? () : (alg,)
            cache = init(prob, alg...; abstol = 1.0e-9)
            for i in 1:10000
                step!(cache)
                cache.force_stop && break
            end
            @test SciMLBase.successful_retcode(cache.retcode)
        end
    end
end

@testitem "PolyAlgorithm Type Inference" tags = [:core] begin
    f_oop(u, p) = u .* u .- 2
    f_iip(du, u, p) = (du .= u .* u .- 2)

    u0 = [1.0, 1.0]
    prob_oop = NonlinearProblem(f_oop, u0)
    prob_iip = NonlinearProblem(f_iip, u0)

    polyalgs = (
        FastShortcutNonlinearPolyalg(),
        RobustMultiNewton(),
        NonlinearSolvePolyAlgorithm((NewtonRaphson(), Broyden())),
    )

    @testset "solve() inference" begin
        # Default algorithm (polyalgorithm)
        @test_nowarn @inferred solve(prob_oop)
        @test_nowarn @inferred solve(prob_iip)

        @testset for alg in polyalgs
            @test_nowarn @inferred solve(prob_oop, alg)
            @test_nowarn @inferred solve(prob_iip, alg)
        end
    end

    @testset "solve!() inference" begin
        # Default algorithm (polyalgorithm)
        cache = init(prob_oop)
        @test_nowarn @inferred solve!(cache)

        cache = init(prob_iip)
        @test_nowarn @inferred solve!(cache)

        @testset for alg in polyalgs
            cache = init(prob_oop, alg)
            @test_nowarn @inferred solve!(cache)

            cache = init(prob_iip, alg)
            @test_nowarn @inferred solve!(cache)
        end
    end
end

@testitem "PolyAlgorithms Autodiff" tags = [:nopre] begin
    cache = zeros(2)
    function f(du, u, p)
        cache .= u .* u
        du .= cache .- 2
    end
    u0 = [1.0, 1.0]
    probN = NonlinearProblem{true}(f, u0)

    custom_polyalg = NonlinearSolvePolyAlgorithm(
        (
            Broyden(; autodiff = AutoFiniteDiff()), LimitedMemoryBroyden(),
        )
    )

    # Uses the `__solve` function
    @test_throws MethodError solve(probN; abstol = 1.0e-9)
    @test_throws MethodError solve(probN, RobustMultiNewton())

    sol = solve(probN, RobustMultiNewton(; autodiff = AutoFiniteDiff()))
    @test SciMLBase.successful_retcode(sol)

    sol = solve(
        probN, FastShortcutNonlinearPolyalg(; autodiff = AutoFiniteDiff()); abstol = 1.0e-9
    )
    @test SciMLBase.successful_retcode(sol)

    quadratic_f(u::Float64, p) = u^2 - p

    prob = NonlinearProblem(quadratic_f, 2.0, 4.0)

    @test_throws MethodError solve(prob)
    @test_throws MethodError solve(prob, RobustMultiNewton())

    sol = solve(prob, RobustMultiNewton(; autodiff = AutoFiniteDiff()))
    @test SciMLBase.successful_retcode(sol)
end

@testitem "PolyAlgorithm Aliasing" tags = [:core] begin
    using NonlinearProblemLibrary

    # Use a problem that the initial solvers cannot solve and cause the initial value to
    # diverge. If we don't alias correctly, all the subsequent algorithms will also fail.
    prob = NonlinearProblemLibrary.nlprob_23_testcases["Generalized Rosenbrock function"].prob
    u0 = copy(prob.u0)
    prob = remake(prob; u0 = copy(u0))

    # If aliasing is not handled properly this will diverge
    sol = solve(
        prob; abstol = 1.0e-6, alias_u0 = true,
        termination_condition = AbsNormTerminationMode(Base.Fix1(maximum, abs))
    )

    @test sol.u === prob.u0
    @test SciMLBase.successful_retcode(sol.retcode)

    prob = remake(prob; u0 = copy(u0))

    cache = init(
        prob; abstol = 1.0e-6, alias_u0 = true,
        termination_condition = AbsNormTerminationMode(Base.Fix1(maximum, abs))
    )
    sol = solve!(cache)

    @test sol.u === prob.u0
    @test SciMLBase.successful_retcode(sol.retcode)
end

@testitem "Ensemble Nonlinear Problems" tags = [:nopre] begin
    prob_func(prob, i, repeat) = remake(prob; u0 = prob.u0[:, i])

    prob_nls_oop = NonlinearProblem((u, p) -> u .* u .- p, rand(4, 128), 2.0)
    prob_nls_iip = NonlinearProblem((du, u, p) -> du .= u .* u .- p, rand(4, 128), 2.0)
    prob_nlls_oop = NonlinearLeastSquaresProblem((u, p) -> u .^ 2 .- p, rand(4, 128), 2.0)
    prob_nlls_iip = NonlinearLeastSquaresProblem(
        NonlinearFunction{true}((du, u, p) -> du .= u .^ 2 .- p; resid_prototype = rand(4)),
        rand(4, 128), 2.0
    )

    for prob in (prob_nls_oop, prob_nls_iip, prob_nlls_oop, prob_nlls_iip)
        ensembleprob = EnsembleProblem(prob; prob_func)

        for ensemblealg in (EnsembleThreads(), EnsembleSerial())
            sim = solve(ensembleprob, nothing, ensemblealg; trajectories = size(prob.u0, 2))
            @test all(SciMLBase.successful_retcode, sim.u)
        end
    end
end

@testitem "BigFloat Support" tags = [:core] begin
    using LinearAlgebra

    fn_iip = NonlinearFunction{true}((du, u, p) -> du .= u .* u .- p)
    fn_oop = NonlinearFunction{false}((u, p) -> u .* u .- p)

    u0 = BigFloat[1.0, 1.0, 1.0]
    prob_iip_bf = NonlinearProblem{true}(fn_iip, u0, BigFloat(2))
    prob_oop_bf = NonlinearProblem{false}(fn_oop, u0, BigFloat(2))

    for alg in (NewtonRaphson(), Broyden(), Klement(), DFSane(), TrustRegion())
        sol = solve(prob_oop_bf, alg)
        @test norm(sol.resid, Inf) < 1.0e-6
        @test SciMLBase.successful_retcode(sol.retcode)

        sol = solve(prob_iip_bf, alg)
        @test norm(sol.resid, Inf) < 1.0e-6
        @test SciMLBase.successful_retcode(sol.retcode)
    end
end

@testitem "Singular Exception: Issue #153" tags = [:core] begin
    function f(du, u, p)
        s1, s1s2, s2 = u
        k1, c1, Δt = p

        du[1] = -0.25 * c1 * k1 * s1 * s2
        du[2] = 0.25 * c1 * k1 * s1 * s2
        du[3] = -0.25 * c1 * k1 * s1 * s2
    end

    prob = NonlinearProblem(f, [2.0, 2.0, 2.0], [1.0, 2.0, 2.5])
    sol = solve(prob; abstol = 1.0e-9)
    @test SciMLBase.successful_retcode(sol)
end

@testitem "Simple Scalar Problem: Issue #187" tags = [:core] begin
    using NaNMath

    # https://github.com/SciML/NonlinearSolve.jl/issues/187
    # If we use a General Nonlinear Solver the solution might go out of the domain!
    ff_interval(u, p) = 0.5 / 1.5 * NaNMath.log.(u ./ (1.0 .- u)) .- 2.0 * u .+ 1.0

    uspan = (0.02, 0.1)
    prob = IntervalNonlinearProblem(ff_interval, uspan)
    sol = solve(prob; abstol = 1.0e-9)
    @test SciMLBase.successful_retcode(sol)

    u0 = 0.06
    p = 2.0
    prob = NonlinearProblem(ff_interval, u0, p)
    sol = solve(prob; abstol = 1.0e-9)
    @test SciMLBase.successful_retcode(sol)
end

# Shooting Problem: Taken from BoundaryValueDiffEq.jl
# Testing for Complex Valued Root Finding. For Complex valued inputs we drop some of the
# algorithms which dont support those.
# Note: ForwardDiff doesn't support complex numbers, so we use FiniteDiff instead.
# Trust region methods also don't work with complex numbers (they use extrema internally).
@testitem "Complex Valued Problems: Single-Shooting" tags = [:downstream] begin
    using OrdinaryDiffEqTsit5
    using SciMLLogging: SciMLLogging

    function ode_func!(du, u, p, t)
        du[1] = u[2]
        du[2] = -u[1]
        return nothing
    end

    function objective_function!(resid, u0, p)
        odeprob = ODEProblem{true}(ode_func!, u0, (0.0, 100.0), p)
        sol = solve(
            odeprob, Tsit5(), abstol = 1.0e-9, reltol = 1.0e-9, verbose = SciMLLogging.None()
        )
        resid[1] = sol(0.0)[1]
        resid[2] = sol(100.0)[1] - 1.0
        return nothing
    end

    prob = NonlinearProblem{true}(objective_function!, [0.0, 1.0] .+ 1im)
    # Use NewtonRaphson with AutoFiniteDiff since:
    # 1. ForwardDiff doesn't support complex numbers
    # 2. Trust region methods use extrema which doesn't work with complex numbers
    sol = solve(prob, NewtonRaphson(; autodiff = AutoFiniteDiff()); abstol = 1.0e-10)
    @test SciMLBase.successful_retcode(sol)
    # This test is not meant to return success but test that Newton-based solvers can handle
    # complex valued problems
    @test_nowarn solve(
        prob, NewtonRaphson(; autodiff = AutoFiniteDiff()); abstol = 1.0e-19, maxiters = 10
    )
end

@testitem "No AD" tags = [:core] begin
    no_ad_fast = FastShortcutNonlinearPolyalg(autodiff = AutoFiniteDiff())
    no_ad_robust = RobustMultiNewton(autodiff = AutoFiniteDiff())
    no_ad_algs = Set([no_ad_fast, no_ad_robust, no_ad_fast.algs..., no_ad_robust.algs...])

    @testset "Inplace" begin
        f_iip = Base.Experimental.@opaque (du, u, p) -> du .= u .* u .- p
        u0 = [0.5]
        prob = NonlinearProblem(f_iip, u0, 1.0)
        for alg in no_ad_algs
            sol = solve(prob, alg)
            @test isapprox(only(sol.u), 1.0)
            @test SciMLBase.successful_retcode(sol.retcode)
        end
    end

    @testset "Out of Place" begin
        f_oop = Base.Experimental.@opaque (u, p) -> u .* u .- p
        u0 = [0.5]
        prob = NonlinearProblem{false}(f_oop, u0, 1.0)
        for alg in no_ad_algs
            sol = solve(prob, alg)
            @test isapprox(only(sol.u), 1.0)
            @test SciMLBase.successful_retcode(sol.retcode)
        end
    end
end

@testitem "Infeasible" tags = [:core] begin
    using LinearAlgebra, StaticArrays

    # this is infeasible
    function f1_infeasible!(out, u, p)
        μ = 3.986004415e14
        x = 7000.0e3
        y = -6.970561549987071e-9
        z = -3.784706123246018e-9
        v_x = 8.550491684548064e-12 + u[1]
        v_y = 6631.60076191005 + u[2]
        v_z = 3600.665431405663 + u[3]
        r = @SVector [x, y, z]
        v = @SVector [v_x, v_y, v_z]
        h = cross(r, v)
        ev = cross(v, h) / μ - r / norm(r)
        i = acos(h[3] / norm(h))
        e = norm(ev)
        a = 1 / (2 / norm(r) - (norm(v)^2 / μ))
        out .= [a - 42.0e6, e - 1.0e-5, i - 1.0e-5]
        return nothing
    end

    function f1_infeasible(u, p)
        μ = 3.986004415e14
        x = 7000.0e3
        y = -6.970561549987071e-9
        z = -3.784706123246018e-9
        v_x = 8.550491684548064e-12 + u[1]
        v_y = 6631.60076191005 + u[2]
        v_z = 3600.665431405663 + u[3]
        r = [x, y, z]
        v = [v_x, v_y, v_z]
        h = cross(r, v)
        ev = cross(v, h) / μ - r / norm(r)
        i = acos(h[3] / norm(h))
        e = norm(ev)
        a = 1 / (2 / norm(r) - (norm(v)^2 / μ))
        return [a - 42.0e6, e - 1.0e-5, i - 1.0e-5]
    end

    u0 = [0.0, 0.0, 0.0]
    prob = NonlinearProblem(f1_infeasible!, u0)
    sol = solve(prob)

    @test all(!isnan, sol.u)
    @test !SciMLBase.successful_retcode(sol.retcode)
    @inferred solve(prob)

    u0 = [0.0, 0.0, 0.0]
    prob = NonlinearProblem(f1_infeasible, u0)
    sol = solve(prob)

    @test all(!isnan, sol.u)
    @test !SciMLBase.successful_retcode(sol.retcode)
    @inferred solve(prob)

    u0 = @SVector [0.0, 0.0, 0.0]
    prob = NonlinearProblem(f1_infeasible, u0)

    sol = solve(prob)
    @test all(!isnan, sol.u)
    @test !SciMLBase.successful_retcode(sol.retcode)
end

@testitem "NoInit Caching" tags = [:core] begin
    using LinearAlgebra

    solvers = [
        SimpleNewtonRaphson(), SimpleTrustRegion(), SimpleDFSane(),
    ]

    prob = NonlinearProblem((u, p) -> u .^ 2 .- p, [0.1, 0.3], 2.0)

    for alg in solvers
        cache = init(prob, alg)
        sol = solve!(cache)
        @test SciMLBase.successful_retcode(sol)
        @test norm(sol.resid, Inf) ≤ 1.0e-6

        reinit!(cache; p = 5.0)
        @test cache.prob.p == 5.0
        sol = solve!(cache)
        @test SciMLBase.successful_retcode(sol)
        @test norm(sol.resid, Inf) ≤ 1.0e-6
        @test norm(sol.u .^ 2 .- 5.0, Inf) ≤ 1.0e-6
    end
end

@testitem "Out-of-place Matrix Resizing" tags = [:nopre] begin
    using StableRNGs

    ff(u, p) = u .* u .- p
    u0 = rand(StableRNG(0), 2, 2)
    p = 2.0
    vecprob = NonlinearProblem(ff, vec(u0), p)
    prob = NonlinearProblem(ff, u0, p)

    for alg in (
            NewtonRaphson(), TrustRegion(), LevenbergMarquardt(),
            PseudoTransient(), RobustMultiNewton(), FastShortcutNonlinearPolyalg(),
            Broyden(), Klement(), LimitedMemoryBroyden(; threshold = 2),
        )
        @test vec(solve(prob, alg).u) == solve(vecprob, alg).u
    end
end

@testitem "Inplace Matrix Resizing" tags = [:nopre] begin
    using StableRNGs

    fiip(du, u, p) = (du .= u .* u .- p)
    u0 = rand(StableRNG(0), 2, 2)
    p = 2.0
    vecprob = NonlinearProblem(fiip, vec(u0), p)
    prob = NonlinearProblem(fiip, u0, p)

    for alg in (
            NewtonRaphson(), TrustRegion(), LevenbergMarquardt(),
            PseudoTransient(), RobustMultiNewton(), FastShortcutNonlinearPolyalg(),
            Broyden(), Klement(), LimitedMemoryBroyden(; threshold = 2),
        )
        @test vec(solve(prob, alg).u) == solve(vecprob, alg).u
    end
end

@testitem "Singular Systems -- Auto Linear Solve Switching" tags = [:core] begin
    using LinearAlgebra

    function f!(du, u, p)
        du[1] = 2u[1] - 2
        du[2] = (u[1] - 4u[2])^2 + 0.1
    end

    u0 = [0.0, 0.0] # Singular Jacobian at u0

    prob = NonlinearProblem(f!, u0)

    sol = solve(prob) # This doesn't have a root so let's just test the switching
    @test sol.u ≈ [1.0, 0.25] atol = 1.0e-3 rtol = 1.0e-3

    function nlls!(du, u, p)
        du[1] = 2u[1] - 2
        du[2] = (u[1] - 4u[2])^2 + 0.1
        du[3] = 0
    end

    u0 = [0.0, 0.0]

    prob = NonlinearProblem(NonlinearFunction(nlls!, resid_prototype = zeros(3)), u0)

    solve(prob)
    @test sol.u ≈ [1.0, 0.25] atol = 1.0e-3 rtol = 1.0e-3
end

@testitem "No PolyesterForwardDiff for SArray" tags = [:core] begin
    using StaticArrays, PolyesterForwardDiff

    f_oop(u, p) = u .* u .- p

    N = 4
    u0 = SVector{N, Float64}(ones(N) .+ randn(N) * 0.01)

    nlprob = NonlinearProblem(f_oop, u0, 2.0)

    @test !(solve(nlprob, NewtonRaphson()).alg.autodiff isa AutoPolyesterForwardDiff)
end

@testitem "NonlinearLeastSquares ReturnCode" tags = [:core] begin
    f(u, p) = [1.0]
    nlf = NonlinearFunction(f; resid_prototype = zeros(1))
    prob = NonlinearLeastSquaresProblem(nlf, [1.0])
    sol = solve(prob)
    @test SciMLBase.successful_retcode(sol)
    @test sol.retcode == ReturnCode.StalledSuccess
end

@testitem "Default Algorithm Singular Handling" tags = [:nopre] begin
    f(u, p) = [u[1]^2 - 2u[1] + 1, sum(u)]
    prob = NonlinearProblem(f, [1.0, 1.0])
    sol = solve(prob)
    @test SciMLBase.successful_retcode(sol)
end

@testitem "NonNumberEltype error" tags = [:core] begin
    u0_broken = [rand(2), rand(2)]
    f(u, p) = u
    prob = NonlinearProblem(f, u0_broken)
    @test_throws SciMLBase.NonNumberEltypeError solve(prob)
end

@testitem "LinearSolve Preconditioner Interface" tags = [:core] begin
    using LinearAlgebra
    f(u, p) = -(u .- 0.1) .^ 3
    prob = NonlinearProblem(f, [0.0, 0.0], 0)
    mutable struct DummyPreconditioners
        i::Int
        reinit_check::Int
    end
    function (precs::DummyPreconditioners)(W, p = nothing)
        # Here we test that NonlinearSolve actually passes the parameters through
        # LinearSolve into the preconditioner constructor.
        @test p isa NonlinearSolveBase.LinearSolveParameters
        @test p.p == precs.reinit_check # p.p is the p of the nonlinear problem
        # By incrementing this variable we make sure that this function has been called at least once.
        precs.i += 1
        return LinearAlgebra.I, LinearAlgebra.I
    end
    # Check if it works in principle
    precs = DummyPreconditioners(0, 0)
    iter = init(prob, NewtonRaphson(linsolve = KrylovJL_GMRES(precs = precs), concrete_jac = false))
    iinit = precs.i
    solve!(iter)
    @test precs.i > 0
    iprev = precs.i
    # Reinit with u0
    precs.i = 0
    precs.reinit_check = 1
    reinit!(iter; u0 = [0.0, 0.0], p = precs.reinit_check)
    ireinit = precs.i
    solve!(iter)
    @test precs.i - ireinit == iprev - iinit
    # Reinit without passing u0
    precs.i = 0
    precs.reinit_check = 2
    reinit!(iter; p = precs.reinit_check)
    @test precs.i == 0
    solve!(iter)
    @test precs.i == 1
end

@testitem "CUDA Tests" tags = [:cuda] skip = :(!isempty(VERSION.prerelease)) begin
    using CUDA, NonlinearSolve, LinearSolve, StableRNGs, ADTypes

    if CUDA.functional()
        CUDA.allowscalar(false)

        A = cu(rand(StableRNG(0), 4, 4))
        u0 = cu(rand(StableRNG(0), 4))
        b = cu(rand(StableRNG(0), 4))

        linear_f(du, u, p) = (du .= A * u .+ b)

        prob = NonlinearProblem(linear_f, u0)

        # ForwardDiff uses scalar indexing which doesn't work on GPU
        # Use AutoFiniteDiff for GPU-compatible Jacobian computation
        fd_autodiff = AutoFiniteDiff()

        SOLVERS = (
            NewtonRaphson(; autodiff = fd_autodiff),
            LevenbergMarquardt(; linsolve = QRFactorization(), autodiff = fd_autodiff),
            LevenbergMarquardt(; linsolve = KrylovJL_GMRES(), autodiff = fd_autodiff),
            PseudoTransient(; autodiff = fd_autodiff),
            Klement(),
            Broyden(; linesearch = LiFukushimaLineSearch()),
            LimitedMemoryBroyden(; threshold = 2, linesearch = LiFukushimaLineSearch()),
            DFSane(),
            TrustRegion(; linsolve = QRFactorization(), autodiff = fd_autodiff),
            TrustRegion(; linsolve = KrylovJL_GMRES(), concrete_jac = true, autodiff = fd_autodiff),  # Needed if Zygote not loaded
        )

        @testset "[IIP] GPU Solvers" begin
            @testset "$(nameof(typeof(alg)))" for alg in SOLVERS
                @test_nowarn sol = solve(prob, alg; abstol = 1.0f-5, reltol = 1.0f-5)
            end
        end

        linear_f(u, p) = A * u .+ b

        prob = NonlinearProblem{false}(linear_f, u0)

        @testset "[OOP] GPU Solvers" begin
            @testset "$(nameof(typeof(alg)))" for alg in SOLVERS
                @test_nowarn sol = solve(prob, alg; abstol = 1.0f-5, reltol = 1.0f-5)
            end
        end
    end
end

@testitem "Termination Conditions: Allocations" tags = [:cuda] skip = :(!isempty(VERSION.prerelease)) begin
    using CUDA, NonlinearSolveBase, Test, LinearAlgebra

    if CUDA.functional()
        CUDA.allowscalar(false)
        du = cu(rand(4))
        u = cu(rand(4))
        uprev = cu(rand(4))
        TERMINATION_CONDITIONS = [
            RelTerminationMode, AbsTerminationMode,
        ]
        NORM_TERMINATION_CONDITIONS = [
            AbsNormTerminationMode, RelNormTerminationMode, RelNormSafeTerminationMode,
            AbsNormSafeTerminationMode, RelNormSafeBestTerminationMode, AbsNormSafeBestTerminationMode,
        ]

        @testset begin
            @testset "Mode: $(tcond)" for tcond in TERMINATION_CONDITIONS
                @test_nowarn NonlinearSolveBase.check_convergence(
                    tcond(), du, u, uprev, 1.0e-3, 1.0e-3
                )
            end

            @testset "Mode: $(tcond)" for tcond in NORM_TERMINATION_CONDITIONS
                for nfn in (
                        Base.Fix1(maximum, abs), Base.Fix2(norm, 2), Base.Fix2(norm, Inf),
                    )
                    @test_nowarn NonlinearSolveBase.check_convergence(
                        tcond(nfn), du, u, uprev, 1.0e-3, 1.0e-3
                    )
                end
            end
        end
    end
end

module NonlinearSolveNLsolveExt

using LineSearches: Static
using NLsolve: NLsolve, NonDifferentiable, OnceDifferentiable, nlsolve

using NonlinearSolveBase: NonlinearSolveBase, Utils, TraceMinimal, is_fw_wrapped, get_raw_f
using NonlinearSolve: NonlinearSolve, NLsolveJL
using SciMLBase: SciMLBase, NonlinearProblem, ReturnCode
using Setfield: @set

function SciMLBase.__solve(
        prob::NonlinearProblem, alg::NLsolveJL, args...;
        abstol = nothing, maxiters = 1000, alias = SciMLBase.NonlinearAliasSpecifier(alias_u0 = false),
        termination_condition = nothing, trace_level = TraceMinimal(),
        store_trace::Val = Val(false), show_trace::Val = Val(false), kwargs...
    )
    # Unwrap AutoSpecialize — external packages do their own AD
    if is_fw_wrapped(prob.f.f)
        prob = @set prob.f.f = get_raw_f(prob.f.f)
    end

    if haskey(kwargs, :alias_u0)
        alias = SciMLBase.NonlinearAliasSpecifier(alias_u0 = kwargs[:alias_u0])
    end
    alias_u0 = alias.alias_u0
    NonlinearSolveBase.assert_extension_supported_termination_condition(
        termination_condition, alg
    )

    f!, u0, resid = NonlinearSolveBase.construct_extension_function_wrapper(prob; alias_u0)

    # Anderson and Broyden do not use a Jacobian — use NonDifferentiable to avoid
    # allocating a dense N×N Jacobian (matches NLsolve.nlsolve's own behavior).
    if alg.method in (:anderson, :broyden)
        df = NonDifferentiable(f!, Utils.safe_vec(u0), Utils.safe_vec(resid); inplace = true)
    elseif prob.f.jac === nothing && alg.autodiff isa Symbol
        df = OnceDifferentiable(f!, u0, resid; alg.autodiff)
    else
        autodiff = alg.autodiff isa Symbol ? nothing : alg.autodiff
        jac! = NonlinearSolveBase.construct_extension_jac(prob, alg, u0, resid; autodiff)
        if prob.f.jac_prototype === nothing
            J = similar(
                u0, promote_type(eltype(u0), eltype(resid)), length(u0), length(resid)
            )
        else
            J = zero(prob.f.jac_prototype)
        end
        df = OnceDifferentiable(f!, jac!, Utils.safe_vec(u0), Utils.safe_vec(resid), J)
    end

    abstol = NonlinearSolveBase.get_tolerance(abstol, eltype(u0))
    show_trace = show_trace isa Val{true}
    store_trace = store_trace isa Val{true}
    extended_trace = !(trace_level.trace_mode isa Val{:minimal})

    linesearch = alg.linesearch === missing ? Static() : alg.linesearch

    original = nlsolve(
        df, vec(u0);
        ftol = abstol, iterations = maxiters, alg.method, store_trace, extended_trace,
        linesearch, alg.linsolve, alg.factor, alg.autoscale, alg.m, alg.beta, show_trace
    )

    f!(vec(resid), original.zero)
    u = prob.u0 isa Number ? original.zero[1] : reshape(original.zero, size(prob.u0))
    resid = prob.u0 isa Number ? resid[1] : resid

    retcode = original.x_converged || original.f_converged ? ReturnCode.Success :
        ReturnCode.Failure
    stats = SciMLBase.NLStats(
        original.f_calls, original.g_calls, original.g_calls,
        original.g_calls, original.iterations
    )

    return SciMLBase.build_solution(prob, alg, u, resid; retcode, original, stats)
end

end

# Put in a separate page so it can be used by SciMLDocs.jl

pages = [
    "index.md",
    "Getting Started with Nonlinear Rootfinding in Julia" => "tutorials/getting_started.md",
    "Tutorials" => Any[
        "tutorials/bound_constraints.md",
        "tutorials/code_optimization.md",
        "tutorials/large_systems.md",
        "tutorials/modelingtoolkit.md",
        "tutorials/small_compile.md",
        "tutorials/iterator_interface.md",
        "tutorials/optimizing_parameterized_ode.md",
        "tutorials/nonlinear_solve_gpus.md",
        "tutorials/snes_ex2.md",
    ],
    "Basics" => Any[
        "basics/nonlinear_problem.md",
        "basics/nonlinear_functions.md",
        "basics/solve.md",
        "basics/nonlinear_solution.md",
        "basics/autodiff.md",
        "basics/termination_condition.md",
        "basics/diagnostics_api.md",
        "basics/sparsity_detection.md",
        "basics/faq.md",
        "basics/verbosity.md",
    ],
    "Solver Summaries and Recommendations" => Any[
        "solvers/nonlinear_system_solvers.md",
        "solvers/bracketing_solvers.md",
        "solvers/steady_state_solvers.md",
        "solvers/nonlinear_least_squares_solvers.md",
        "solvers/fixed_point_solvers.md",
    ],
    "Native Functionalities" => Any[
        "native/solvers.md",
        "native/simplenonlinearsolve.md",
        "native/bracketingnonlinearsolve.md",
        "native/steadystatediffeq.md",
        "native/descent.md",
        "native/globalization.md",
        "native/diagnostics.md",
    ],
    "Wrapped Solver APIs" => Any[
        "api/fastlevenbergmarquardt.md",
        "api/fixedpointacceleration.md",
        "api/leastsquaresoptim.md",
        "api/minpack.md",
        "api/nlsolve.md",
        "api/nlsolvers.md",
        "api/petsc.md",
        "api/scipy.md",
        "api/siamfanlequations.md",
        "api/speedmapping.md",
        "api/sundials.md",
        "api/homotopycontinuation.md",
    ],
    "Sub-Packages" => Any[
        "api/SciMLJacobianOperators.md",
    ],
    "Development Documentation" => [
        "devdocs/internal_interfaces.md",
        "devdocs/linear_solve.md",
        "devdocs/jacobian.md",
        "devdocs/operators.md",
        "devdocs/algorithm_helpers.md",
    ],
    "Release Notes" => "release_notes.md",
    "References" => "references.md",
]

using NonlinearSolveBase, SciMLBase

const TERMINATION_CONDITIONS = [
    NormTerminationMode(Base.Fix1(maximum, abs)),
    RelTerminationMode(),
    RelNormTerminationMode(Base.Fix1(maximum, abs)),
    RelNormSafeTerminationMode(Base.Fix1(maximum, abs)),
    RelNormSafeBestTerminationMode(Base.Fix1(maximum, abs)),
    AbsTerminationMode(),
    AbsNormTerminationMode(Base.Fix1(maximum, abs)),
    AbsNormSafeTerminationMode(Base.Fix1(maximum, abs)),
    AbsNormSafeBestTerminationMode(Base.Fix1(maximum, abs)),
]

quadratic_f(u, p) = u .* u .- p
quadratic_f!(du, u, p) = (du .= u .* u .- p)
quadratic_f2(u, p) = @. p[1] * u * u - p[2]

function newton_fails(u, p)
    return 0.010000000000000002 .+
        10.000000000000002 ./ (
        1 .+
            (
            0.21640425613334457 .+
                216.40425613334457 ./ (
                1 .+
                    (
                    0.21640425613334457 .+
                        216.40425613334457 ./ (1 .+ 0.0006250000000000001(u .^ 2.0))
                ) .^ 2.0
            )
        ) .^
            2.0
    ) .- 0.0011552453009332421u .- p
end

function solve_oop(f, u0, p = 2.0; solver, kwargs...)
    prob = NonlinearProblem{false}(f, u0, p)
    return solve(prob, solver; abstol = 1.0e-9, kwargs...)
end

function solve_iip(f, u0, p = 2.0; solver, kwargs...)
    prob = NonlinearProblem{true}(f, u0, p)
    return solve(prob, solver; abstol = 1.0e-9, kwargs...)
end

function nlprob_iterator_interface(f, p_range, isinplace, solver)
    probN = NonlinearProblem{isinplace}(f, isinplace ? [0.5] : 0.5, p_range[begin])
    cache = init(probN, solver; maxiters = 100, abstol = 1.0e-10)
    sols = zeros(length(p_range))
    for (i, p) in enumerate(p_range)
        reinit!(cache, isinplace ? [cache.u[1]] : cache.u; p = p)
        sol = solve!(cache)
        sols[i] = isinplace ? sol.u[1] : sol.u
    end
    return sols
end

export TERMINATION_CONDITIONS
export quadratic_f, quadratic_f!, quadratic_f2, newton_fails
export solve_oop, solve_iip
export nlprob_iterator_interface

module NonlinearSolveSpeedMappingExt

using SpeedMapping: speedmapping

using NonlinearSolveBase: NonlinearSolveBase, is_fw_wrapped, get_raw_f
using NonlinearSolve: NonlinearSolve, SpeedMappingJL
using SciMLBase: SciMLBase, NonlinearProblem, ReturnCode
using Setfield: @set

function SciMLBase.__solve(
        prob::NonlinearProblem, alg::SpeedMappingJL, args...;
        abstol = nothing, maxiters = 1000, alias = SciMLBase.NonlinearAliasSpecifier(alias_u0 = false),
        maxtime = nothing, store_trace::Val = Val(false),
        termination_condition = nothing, kwargs...
    )
    # Unwrap AutoSpecialize — external packages do their own AD
    if is_fw_wrapped(prob.f.f)
        prob = @set prob.f.f = get_raw_f(prob.f.f)
    end

    if haskey(kwargs, :alias_u0)
        alias = SciMLBase.NonlinearAliasSpecifier(alias_u0 = kwargs[:alias_u0])
    end
    alias_u0 = alias.alias_u0
    NonlinearSolveBase.assert_extension_supported_termination_condition(
        termination_condition, alg
    )

    m!, u,
        resid = NonlinearSolveBase.construct_extension_function_wrapper(
        prob; alias_u0, make_fixed_point = Val(true)
    )
    tol = NonlinearSolveBase.get_tolerance(abstol, eltype(u))

    time_limit = ifelse(maxtime === nothing, 1000, maxtime)

    sol = speedmapping(
        u; m!, abstol = tol, pnorm = Inf, maps_limit = maxiters,
        orders = Tuple(alg.orders),
        initial_learning_rate = alg.σ_min == 0.0 ? 1.0 : alg.σ_min,
        store_trace = store_trace isa Val{true},
        time_limit
    )
    res = prob.u0 isa Number ? first(sol.minimizer) : sol.minimizer
    resid = NonlinearSolveBase.Utils.evaluate_f(prob, res)

    return SciMLBase.build_solution(
        prob, alg, res, resid;
        original = sol, stats = SciMLBase.NLStats(sol.maps, 0, 0, 0, sol.maps),
        retcode = ifelse(sol.status == :first_order, ReturnCode.Success, ReturnCode.Failure)
    )
end

end

@testitem "Correct Best Solution: #565" tags = [:core] begin
    using NonlinearSolve, StableRNGs

    x = collect(0:0.1:10)

    line_fct(x, p) = p[1] .+ p[2] .* x

    y_line = line_fct(x, [1, 3])
    y_line_n = line_fct(x, [1, 3]) + randn(StableRNG(0), length(x))

    res(β, (x, y)) = line_fct(x, β) .- y

    prob = NonlinearLeastSquaresProblem(res, [1, 3], p = (x, y_line_n))
    sol1 = solve(prob; maxiters = 1000)

    prob = NonlinearLeastSquaresProblem(res, [1, 5], p = (x, y_line_n))
    sol2 = solve(prob; maxiters = 1000)

    @test sol1.u ≈ sol2.u
end

@testitem "Polyalgorithm Fallback Path: CurveFit.jl#76" tags = [:core] begin
    using NonlinearSolve

    # This test ensures the polyalgorithm fallback path works correctly.
    # Previously, when all sub-algorithms failed to converge early, the code
    # tried to access `cache.resid` which doesn't exist (caches have `fu`).
    # This caused "type GeneralizedFirstOrderAlgorithmCache has no field resid".

    # Create a problem that's hard to converge with very few iterations,
    # forcing all polyalgorithm sub-algorithms to fail and trigger the fallback path.
    function hard_problem(u, p)
        # Stiff problem that's hard to converge quickly
        return @. u^10 - p
    end

    prob = NonlinearLeastSquaresProblem(hard_problem, [100.0, 200.0], [1.0, 1.0])

    # Use very few iterations to force all algorithms to fail early convergence
    sol = solve(prob; maxiters = 3)

    # The key test: this should not error with "no field resid"
    # The solution should have a valid structure even if not converged
    @test sol.u isa AbstractVector
    @test sol.resid isa AbstractVector
    @test sol.retcode == ReturnCode.MaxIters
end

@testitem "Polyalgorithm Cache solve!: Issue #779" tags = [:core] begin
    using NonlinearSolve

    # This test ensures the polyalgorithm cache-based solve! works correctly.
    # Issue #779: PR #773 changed line 386 to use get_fu(cache) to extract residuals,
    # but line 391 still called findmin_caches(cache.prob, fus) with the residual
    # vectors. Since findmin_caches internally calls get_fu() expecting cache objects,
    # this caused "MethodError: no method matching get_fu(::Vector{Float64})".
    # The fix uses findmin_resids directly since fus already contains residual vectors.

    function hard_problem(u, p)
        return @. u^10 - p
    end

    prob = NonlinearLeastSquaresProblem(hard_problem, [100.0, 200.0], [1.0, 1.0])

    # Initialize cache and use solve! to exercise the cache-based code path
    # The key test: this should not error with "no method matching get_fu(::Vector{Float64})"
    cache = init(prob; maxiters = 3)
    sol = solve!(cache)

    @test sol.u isa AbstractVector
    @test sol.resid isa AbstractVector
    @test SciMLBase.successful_retcode(sol) || sol.retcode == ReturnCode.MaxIters
end

@testitem "Modeling Toolkit Cache Indexing" tags = [:downstream] begin
    using ModelingToolkit
    using ModelingToolkit: t_nounits as t
    using SymbolicIndexingInterface
    import NonlinearSolveBase, NonlinearSolveFirstOrder

    @parameters p d
    @variables X(t)
    eqs = [0 ~ sin(X + p) - d * sqrt(X + 1)]
    @mtkcompile nlsys = System(eqs, [X], [p, d])

    # Creates an integrator.
    nlprob = NonlinearProblem(nlsys, [X => 1.0], [p => 2.0, d => 3.0])

    @testset "$integtype" for (alg, integtype) in [
            (NewtonRaphson(), NonlinearSolveFirstOrder.GeneralizedFirstOrderAlgorithmCache),
            (
                FastShortcutNonlinearPolyalg(),
                NonlinearSolveBase.NonlinearSolvePolyAlgorithmCache,
            ),
            (SimpleNewtonRaphson(), NonlinearSolveBase.NonlinearSolveNoInitCache),
        ]
        nint = init(nlprob, alg)
        @test nint isa integtype

        @test_nowarn state_values(nint)
        @test_nowarn parameter_values(nint)

        for (i, sym) in enumerate([X, nlsys.X, :X])
            # test both getindex and setindex!
            nint[sym] = 1.5i
            @test nint[sym] == 1.5i
        end

        for (i, sym) in enumerate([p, nlsys.p, :p])
            # test both getindex and setindex!
            nint.ps[sym] = 2.5i
            @test nint.ps[sym] == 2.5i
        end
    end
end

using ReTestItems, Hwloc, InteractiveUtils, Pkg

@info sprint(InteractiveUtils.versioninfo)

function parse_test_args()
    test_args_from_env = @isdefined(TEST_ARGS) ? TEST_ARGS : ARGS
    test_args = Dict{String, String}()
    for arg in test_args_from_env
        if contains(arg, "=")
            key, value = split(arg, "="; limit = 2)
            test_args[key] = value
        end
    end
    @info "Parsed test args" test_args
    return test_args
end

const PARSED_TEST_ARGS = parse_test_args()

function get_from_test_args_or_env(key, default)
    haskey(PARSED_TEST_ARGS, key) && return PARSED_TEST_ARGS[key]
    return get(ENV, key, default)
end

const GROUP = lowercase(get_from_test_args_or_env("GROUP", "all"))

# Disable Enzyme on Julia 1.12+ due to compatibility issues
# To re-enable: change condition to `true` or `VERSION < v"1.13"`
const ENZYME_ENABLED = VERSION < v"1.13"

if GROUP != "trim"
    using NonlinearSolve  # trimming uses NonlinearSolve from a custom environment

    const EXTRA_PKGS = Pkg.PackageSpec[]
    if GROUP == "all" || GROUP == "downstream"
        push!(EXTRA_PKGS, Pkg.PackageSpec("ModelingToolkit"))
        push!(EXTRA_PKGS, Pkg.PackageSpec("SymbolicIndexingInterface"))
        push!(EXTRA_PKGS, Pkg.PackageSpec("OrdinaryDiffEqTsit5"))
    end
    if GROUP in ("all", "nopre", "bounds")
        # Only add Enzyme for specific groups if not on prerelease Julia and if enabled
        if isempty(VERSION.prerelease) && ENZYME_ENABLED
            push!(EXTRA_PKGS, Pkg.PackageSpec("Enzyme"))
            push!(EXTRA_PKGS, Pkg.PackageSpec("Mooncake"))
            push!(EXTRA_PKGS, Pkg.PackageSpec("SciMLSensitivity"))
        end
    end
    if GROUP == "all" || GROUP == "cuda"
        # Only add CUDA for cuda group if not on prerelease Julia
        if isempty(VERSION.prerelease)
            push!(EXTRA_PKGS, Pkg.PackageSpec("CUDA"))
        end
    end
    length(EXTRA_PKGS) ≥ 1 && Pkg.add(EXTRA_PKGS)

    # Use sequential execution for wrapper tests to avoid parallel initialization issues
    const RETESTITEMS_NWORKERS = if GROUP == "wrappers"
        0  # Sequential execution for wrapper tests
    else
        tmp = get(ENV, "RETESTITEMS_NWORKERS", "")
        isempty(tmp) &&
            (tmp = string(min(ifelse(Sys.iswindows(), 0, Hwloc.num_physical_cores()), 4)))
        parse(Int, tmp)
    end
    const RETESTITEMS_NWORKER_THREADS = begin
        tmp = get(ENV, "RETESTITEMS_NWORKER_THREADS", "")
        isempty(tmp) &&
            (tmp = string(max(Hwloc.num_virtual_cores() ÷ max(RETESTITEMS_NWORKERS, 1), 1)))
        parse(Int, tmp)
    end

    @info "Running tests for group: $(GROUP) with $(RETESTITEMS_NWORKERS) workers"

    ReTestItems.runtests(
        NonlinearSolve; tags = (GROUP == "all" ? nothing : [Symbol(GROUP)]),
        nworkers = RETESTITEMS_NWORKERS, nworker_threads = RETESTITEMS_NWORKER_THREADS,
        testitem_timeout = 3600
    )
elseif GROUP == "trim" && VERSION >= v"1.12.0-rc1"  # trimming has been introduced in julia 1.12
    Pkg.activate(joinpath(dirname(@__FILE__), "trim"))
    Pkg.instantiate()
    include("trim/runtests.jl")
end

@testitem "Default Algorithm for AbstractSteadyStateProblem" tags = [:core] begin
    using SciMLBase, StaticArrays

    # Test with in-place function
    function f_iip(du, u, p, t)
        du[1] = 2 - 2u[1]
        du[2] = u[1] - 4u[2]
    end

    u0 = zeros(2)
    prob_iip = SteadyStateProblem(f_iip, u0)

    @testset "In-place SteadyStateProblem" begin
        # Test with default algorithm (nothing)
        sol = solve(prob_iip)
        @test SciMLBase.successful_retcode(sol.retcode)
        @test maximum(abs, sol.resid) < 1.0e-6

        # Test with explicit nothing
        sol = solve(prob_iip, nothing)
        @test SciMLBase.successful_retcode(sol.retcode)
        @test maximum(abs, sol.resid) < 1.0e-6

        # Test init interface
        cache = init(prob_iip)
        sol = solve!(cache)
        @test SciMLBase.successful_retcode(sol.retcode)
        @test maximum(abs, sol.resid) < 1.0e-6

        # Test init with nothing
        cache = init(prob_iip, nothing)
        sol = solve!(cache)
        @test SciMLBase.successful_retcode(sol.retcode)
        @test maximum(abs, sol.resid) < 1.0e-6
    end

    # Test with out-of-place function
    f_oop(u, p, t) = [2 - 2u[1], u[1] - 4u[2]]
    u0 = zeros(2)
    prob_oop = SteadyStateProblem(f_oop, u0)

    @testset "Out-of-place SteadyStateProblem" begin
        # Test with default algorithm (nothing)
        sol = solve(prob_oop)
        @test SciMLBase.successful_retcode(sol.retcode)
        @test maximum(abs, sol.resid) < 1.0e-6

        # Test with explicit nothing
        sol = solve(prob_oop, nothing)
        @test SciMLBase.successful_retcode(sol.retcode)
        @test maximum(abs, sol.resid) < 1.0e-6

        # Test init interface
        cache = init(prob_oop)
        sol = solve!(cache)
        @test SciMLBase.successful_retcode(sol.retcode)
        @test maximum(abs, sol.resid) < 1.0e-6

        # Test init with nothing
        cache = init(prob_oop, nothing)
        sol = solve!(cache)
        @test SciMLBase.successful_retcode(sol.retcode)
        @test maximum(abs, sol.resid) < 1.0e-6
    end

    # Test that SteadyStateProblem conversion works
    @testset "Problem conversion" begin
        # Create equivalent NonlinearProblem
        function f_nl(u, p)
            [2 - 2u[1], u[1] - 4u[2]]
        end

        prob_nl = NonlinearProblem(f_nl, u0)

        # Convert SteadyStateProblem to NonlinearProblem
        prob_converted = NonlinearProblem(prob_oop)

        # Both should solve to the same solution
        sol_nl = solve(prob_nl)
        sol_converted = solve(prob_converted)

        @test sol_nl.u ≈ sol_converted.u atol = 1.0e-10
    end

    # Test with StaticArrays
    @testset "StaticArrays support" begin
        f_static(u, p, t) = @SVector [2 - 2u[1], u[1] - 4u[2]]
        u0_static = @SVector [0.0, 0.0]
        prob_static = SteadyStateProblem(f_static, u0_static)

        sol = solve(prob_static)
        @test SciMLBase.successful_retcode(sol.retcode)
        @test maximum(abs, sol.resid) < 1.0e-6
    end

    # Test that solve works with various problem types
    @testset "Mixed problem types" begin
        # Regular arrays
        prob1 = SteadyStateProblem(f_oop, [0.5, 0.5])
        sol1 = solve(prob1)
        @test SciMLBase.successful_retcode(sol1.retcode)

        # With parameters
        f_param(u, p, t) = [p[1] - 2u[1], u[1] - 4u[2]]
        prob2 = SteadyStateProblem(f_param, [0.5, 0.5], [2.0])
        sol2 = solve(prob2)
        @test SciMLBase.successful_retcode(sol2.retcode)
    end
end

# This file only include the algorithm struct to be exported by NonlinearSolve.jl. The main
# functionality is implemented as package extensions
"""
    LeastSquaresOptimJL(alg = :lm; linsolve = nothing, autodiff::Symbol = :central)

Wrapper over [LeastSquaresOptim.jl](https://github.com/matthieugomez/LeastSquaresOptim.jl)
for solving `NonlinearLeastSquaresProblem`.

### Arguments

  - `alg`: Algorithm to use. Can be `:lm` or `:dogleg`.

### Keyword Arguments

  - `linsolve`: Linear solver to use. Can be `:qr`, `:cholesky` or `:lsmr`. If `nothing`,
    then `LeastSquaresOptim.jl` will choose the best linear solver based on the Jacobian
    structure.
  - `autodiff`: Automatic differentiation / Finite Differences. Can be `:central` or
    `:forward`.

!!! note

    This algorithm is only available if `LeastSquaresOptim.jl` is installed and loaded.
"""
@concrete struct LeastSquaresOptimJL <: AbstractNonlinearSolveAlgorithm
    autodiff
    alg::Symbol
    linsolve <: Union{Symbol, Nothing}
    name::Symbol
end

function LeastSquaresOptimJL(alg = :lm; linsolve = nothing, autodiff = :central)
    @assert alg in (:lm, :dogleg)
    @assert linsolve === nothing || linsolve in (:qr, :cholesky, :lsmr)
    autodiff isa Symbol && @assert autodiff in (:central, :forward)

    if Base.get_extension(@__MODULE__, :NonlinearSolveLeastSquaresOptimExt) === nothing
        error("`LeastSquaresOptimJL` requires `LeastSquaresOptim.jl` to be loaded")
    end

    return LeastSquaresOptimJL(autodiff, alg, linsolve, :LeastSquaresOptimJL)
end

"""
    FastLevenbergMarquardtJL(
        linsolve::Symbol = :cholesky;
        factor = 1e-6, factoraccept = 13.0, factorreject = 3.0, factorupdate = :marquardt,
        minscale = 1e-12, maxscale = 1e16, minfactor = 1e-28, maxfactor = 1e32,
        autodiff = nothing
    )

Wrapper over [FastLevenbergMarquardt.jl](https://github.com/kamesy/FastLevenbergMarquardt.jl)
for solving `NonlinearLeastSquaresProblem`. For details about the other keyword arguments
see the documentation for `FastLevenbergMarquardt.jl`.

### Arguments

  - `linsolve`: Linear solver to use. Can be `:qr` or `:cholesky`.

### Keyword Arguments

  - `autodiff`: determines the backend used for the Jacobian. Note that this argument is
    ignored if an analytical Jacobian is passed, as that will be used instead. Defaults to
    `nothing` which means that a default is selected according to the problem specification!

!!! note

    This algorithm is only available if `FastLevenbergMarquardt.jl` is installed and loaded.
"""
@concrete struct FastLevenbergMarquardtJL <: AbstractNonlinearSolveAlgorithm
    autodiff
    linsolve::Symbol
    factor
    factoraccept
    factorreject
    factorupdate::Symbol
    minscale
    maxscale
    minfactor
    maxfactor
    name::Symbol
end

function FastLevenbergMarquardtJL(
        linsolve::Symbol = :cholesky; factor = 1.0e-6, factoraccept = 13.0,
        factorreject = 3.0, factorupdate = :marquardt, minscale = 1.0e-12,
        maxscale = 1.0e16, minfactor = 1.0e-28, maxfactor = 1.0e32, autodiff = nothing
    )
    @assert linsolve in (:qr, :cholesky)
    @assert factorupdate in (:marquardt, :nielson)

    if Base.get_extension(@__MODULE__, :NonlinearSolveFastLevenbergMarquardtExt) === nothing
        error("`FastLevenbergMarquardtJL` requires `FastLevenbergMarquardt.jl` to be loaded")
    end

    return FastLevenbergMarquardtJL(
        autodiff, linsolve, factor, factoraccept, factorreject,
        factorupdate, minscale, maxscale, minfactor, maxfactor, :FastLevenbergMarquardtJL
    )
end

"""
    CMINPACK(; method::Symbol = :auto, autodiff = missing)

### Keyword Arguments

  - `method`: the choice of method for the solver.
  - `autodiff`: Defaults to `missing`, which means we will default to letting `MINPACK`
    construct the jacobian if `f.jac` is not provided. In other cases, we use it to generate
    a jacobian similar to other NonlinearSolve solvers.

### Submethod Choice

The keyword argument `method` can take on different value depending on which method of
`fsolve` you are calling. The standard choices of `method` are:

  - `:hybr`: Modified version of Powell's algorithm. Uses MINPACK routine
    [`hybrd1`](https://github.com/devernay/cminpack/blob/d1f5f5a273862ca1bbcf58394e4ac060d9e22c76/hybrd1.c)
  - `:lm`: Levenberg-Marquardt. Uses MINPACK routine
    [`lmdif1`](https://github.com/devernay/cminpack/blob/d1f5f5a273862ca1bbcf58394e4ac060d9e22c76/lmdif1.c)
  - `:lmdif`: Advanced Levenberg-Marquardt (more options available with `; kwargs...`). See
    MINPACK routine [`lmdif`](https://github.com/devernay/cminpack/blob/d1f5f5a273862ca1bbcf58394e4ac060d9e22c76/lmdif.c)
    for more information
  - `:hybrd`: Advanced modified version of Powell's algorithm (more options available with
    `; kwargs...`). See MINPACK routine
    [`hybrd`](https://github.com/devernay/cminpack/blob/d1f5f5a273862ca1bbcf58394e4ac060d9e22c76/hybrd.c)
    for more information

If a Jacobian is supplied as part of the [`NonlinearFunction`](@ref nonlinearfunctions),
then the following methods are allowed:

  - `:hybr`: Advanced modified version of Powell's algorithm with user supplied Jacobian.
    Additional arguments are available via `; kwargs...`. See MINPACK routine
    [`hybrj`](https://github.com/devernay/cminpack/blob/d1f5f5a273862ca1bbcf58394e4ac060d9e22c76/hybrj.c)
    for more information
  - `:lm`: Advanced Levenberg-Marquardt with user supplied Jacobian. Additional arguments
    are available via `; kwargs...`. See MINPACK routine
    [`lmder`](https://github.com/devernay/cminpack/blob/d1f5f5a273862ca1bbcf58394e4ac060d9e22c76/lmder.c)
    for more information

The default choice of `:auto` selects `:hybr` for NonlinearProblem and `:lm` for
NonlinearLeastSquaresProblem.

!!! note

    This algorithm is only available if `MINPACK.jl` is installed and loaded.
"""
@concrete struct CMINPACK <: AbstractNonlinearSolveAlgorithm
    method::Symbol
    autodiff
    name::Symbol
end

function CMINPACK(; method::Symbol = :auto, autodiff = missing)
    if Base.get_extension(@__MODULE__, :NonlinearSolveMINPACKExt) === nothing
        error("`CMINPACK` requires `MINPACK.jl` to be loaded")
    end
    return CMINPACK(method, autodiff, :CMINPACK)
end

"""
    NLsolveJL(;
        method = :trust_region, autodiff = :central, linesearch = Static(),
        linsolve = (x, A, b) -> copyto!(x, A\\b), factor = one(Float64), autoscale = true,
        m = 10, beta = one(Float64)
    )

### Keyword Arguments

  - `method`: the choice of method for solving the nonlinear system.
  - `autodiff`: the choice of method for generating the Jacobian. Defaults to `:central` or
    central differencing via FiniteDiff.jl. The other choices are `:forward` or `ADTypes`
    similar to other solvers in NonlinearSolve.
  - `linesearch`: the line search method to be used within the solver method. The choices
    are line search types from
    [LineSearches.jl](https://github.com/JuliaNLSolvers/LineSearches.jl).
  - `linsolve`: a function `linsolve(x, A, b)` that solves `Ax = b`.
  - `factor`: determines the size of the initial trust region. This size is set to the
    product of factor and the euclidean norm of `u0` if nonzero, or else to factor itself.
  - `autoscale`: if true, then the variables will be automatically rescaled. The scaling
    factors are the norms of the Jacobian columns.
  - `m`: the amount of history in the Anderson method. Naive "Picard"-style iteration can be
    achieved by setting m=0, but that isn't advisable for contractions whose Lipschitz
    constants are close to 1. If convergence fails, though, you may consider lowering it.
  - `beta`: It is also known as DIIS or Pulay mixing, this method is based on the
    acceleration of the fixed-point iteration xₙ₊₁ = xₙ + beta*f(xₙ), where by default
    beta = 1.

!!! warning

    Line Search Algorithms from [`LineSearch.jl`](https://github.com/SciML/LineSearch.jl)
    aren't supported by `NLsolveJL`. Instead, use the line search algorithms from
    [`LineSearches.jl`](https://github.com/JuliaNLSolvers/LineSearches.jl).

### Submethod Choice

Choices for methods in `NLsolveJL`:

  - `:anderson`: Anderson-accelerated fixed-point iteration
  - `:broyden`: Broyden's quasi-Newton method
  - `:newton`: Classical Newton method with an optional line search
  - `:trust_region`: Trust region Newton method (the default choice)

For more information on these arguments, consult the
[NLsolve.jl documentation](https://github.com/JuliaNLSolvers/NLsolve.jl).

!!! note

    This algorithm is only available if `NLsolve.jl` is installed and loaded.
"""
@concrete struct NLsolveJL <: AbstractNonlinearSolveAlgorithm
    method::Symbol
    autodiff
    linesearch
    linsolve
    factor
    autoscale::Bool
    m::Int
    beta
    name::Symbol
end

function NLsolveJL(;
        method = :trust_region, autodiff = :central, linesearch = missing, beta = 1.0,
        linsolve = (x, A, b) -> copyto!(x, A \ b), factor = 1.0, autoscale = true, m = 10
    )
    if Base.get_extension(@__MODULE__, :NonlinearSolveNLsolveExt) === nothing
        error("`NLsolveJL` requires `NLsolve.jl` to be loaded")
    end

    if autodiff isa Symbol && autodiff !== :central && autodiff !== :forward
        error("`autodiff` must be `:central` or `:forward`.")
    end

    return NLsolveJL(
        method, autodiff, linesearch, linsolve, factor, autoscale, m, beta, :NLsolveJL
    )
end

"""
    NLSolversJL(method; autodiff = nothing)
    NLSolversJL(; method, autodiff = nothing)

Wrapper over NLSolvers.jl Nonlinear Equation Solvers. We automatically construct the
jacobian function and supply it to the solver.

### Arguments

  - `method`: the choice of method for solving the nonlinear system. See the documentation
    for NLSolvers.jl for more information.
  - `autodiff`: the choice of method for generating the Jacobian. Defaults to `nothing`
    which means that a default is selected according to the problem specification. Can be
    any valid ADTypes.jl autodiff type (conditional on that backend being supported in
    NonlinearSolve.jl).
"""
struct NLSolversJL{M, AD} <: AbstractNonlinearSolveAlgorithm
    method::M
    autodiff::AD
    name::Symbol

    function NLSolversJL(method, autodiff)
        if Base.get_extension(@__MODULE__, :NonlinearSolveNLSolversExt) === nothing
            error("NLSolversJL requires NLSolvers.jl to be loaded")
        end

        return new{typeof(method), typeof(autodiff)}(method, autodiff, :NLSolversJL)
    end
end

NLSolversJL(method; autodiff = nothing) = NLSolversJL(method, autodiff)
NLSolversJL(; method, autodiff = nothing) = NLSolversJL(method, autodiff)

"""
    SpeedMappingJL(;
        σ_min = 0.0, stabilize::Bool = false, check_obj::Bool = false,
        orders::Vector{Int} = [3, 3, 2]
    )

Wrapper over [SpeedMapping.jl](https://github.com/NicolasL-S/SpeedMapping.jl) for solving
Fixed Point Problems. We allow using this algorithm to solve root finding problems as well.

### Keyword Arguments

  - `σ_min`: Setting to `1` may avoid stalling (see [lepage2021alternating](@cite)).
  - `stabilize`: performs a stabilization mapping before extrapolating. Setting to `true`
    may improve the performance for applications like accelerating the EM or MM algorithms
    (see [lepage2021alternating](@cite)).
  - `check_obj`: In case of NaN or Inf values, the algorithm restarts at the best past
    iterate.
  - `orders`: determines ACX's alternating order. Must be between `1` and `3` (where `1`
    means no extrapolation). The two recommended orders are `[3, 2]` and `[3, 3, 2]`, the
    latter being potentially better for highly non-linear applications (see
    [lepage2021alternating](@cite)).

!!! note

    This algorithm is only available if `SpeedMapping.jl` is installed and loaded.
"""
@concrete struct SpeedMappingJL <: AbstractNonlinearSolveAlgorithm
    σ_min
    stabilize::Bool
    check_obj::Bool
    orders::Vector{Int}
    name::Symbol
end

function SpeedMappingJL(;
        σ_min = 0.0, stabilize::Bool = false, check_obj::Bool = false,
        orders::Vector{Int} = [3, 3, 2]
    )
    if Base.get_extension(@__MODULE__, :NonlinearSolveSpeedMappingExt) === nothing
        error("`SpeedMappingJL` requires `SpeedMapping.jl` to be loaded")
    end

    return SpeedMappingJL(σ_min, stabilize, check_obj, orders, :SpeedMappingJL)
end

"""
    FixedPointAccelerationJL(;
        algorithm = :Anderson, m = missing, condition_number_threshold = missing,
        extrapolation_period = missing, replace_invalids = :NoAction
    )

Wrapper over [FixedPointAcceleration.jl](https://s-baumann.github.io/FixedPointAcceleration.jl/)
for solving Fixed Point Problems. We allow using this algorithm to solve root finding
problems as well.

### Keyword Arguments

  - `algorithm`: The algorithm to use. Can be `:Anderson`, `:MPE`, `:RRE`, `:VEA`, `:SEA`,
    `:Simple`, `:Aitken` or `:Newton`.
  - `m`: The number of previous iterates to use for the extrapolation. Only valid for
    `:Anderson`.
  - `condition_number_threshold`: The condition number threshold for Least Squares Problem.
    Only valid for `:Anderson`.
  - `extrapolation_period`: The number of iterates between extrapolations. Only valid for
    `:MPE`, `:RRE`, `:VEA` and `:SEA`. Defaults to `7` for `:MPE` & `:RRE`, and `6` for
    `:SEA` and `:VEA`. For `:SEA` and `:VEA`, this must be a multiple of `2`.
  - `replace_invalids`: The method to use for replacing invalid iterates. Can be
    `:ReplaceInvalids`, `:ReplaceVector` or `:NoAction`.

!!! note

    This algorithm is only available if `FixedPointAcceleration.jl` is installed and loaded.
"""
@concrete struct FixedPointAccelerationJL <: AbstractNonlinearSolveAlgorithm
    algorithm::Symbol
    extrapolation_period::Int
    replace_invalids::Symbol
    dampening
    m::Int
    condition_number_threshold
    name::Symbol
end

function FixedPointAccelerationJL(;
        algorithm = :Anderson, m = missing, condition_number_threshold = missing,
        extrapolation_period = missing, replace_invalids = :NoAction, dampening = 1.0
    )
    if Base.get_extension(@__MODULE__, :NonlinearSolveFixedPointAccelerationExt) === nothing
        error("`FixedPointAccelerationJL` requires `FixedPointAcceleration.jl` to be loaded")
    end

    @assert algorithm in (:Anderson, :MPE, :RRE, :VEA, :SEA, :Simple, :Aitken, :Newton)
    @assert replace_invalids in (:ReplaceInvalids, :ReplaceVector, :NoAction)

    if algorithm !== :Anderson
        @assert condition_number_threshold === missing "`condition_number_threshold` is only valid for Anderson acceleration"
        @assert m === missing "`m` is only valid for Anderson acceleration"
    end
    condition_number_threshold === missing && (condition_number_threshold = 1.0e3)
    m === missing && (m = 10)

    if algorithm !== :MPE && algorithm !== :RRE && algorithm !== :VEA && algorithm !== :SEA
        @assert extrapolation_period === missing "`extrapolation_period` is only valid for MPE, RRE, VEA and SEA"
    end
    if extrapolation_period === missing
        extrapolation_period = algorithm === :SEA || algorithm === :VEA ? 6 : 7
    else
        if (algorithm === :SEA || algorithm === :VEA) && extrapolation_period % 2 != 0
            throw(AssertionError("`extrapolation_period` must be multiples of 2 for SEA and VEA"))
        end
    end

    return FixedPointAccelerationJL(
        algorithm, extrapolation_period, replace_invalids,
        dampening, m, condition_number_threshold, :FixedPointAccelerationJL
    )
end

"""
    SIAMFANLEquationsJL(;
        method = :newton, delta = 1e-3, linsolve = nothing, autodiff = missing
    )

### Keyword Arguments

  - `method`: the choice of method for solving the nonlinear system.
  - `delta`: initial pseudo time step, default is 1e-3.
  - `linsolve` : JFNK linear solvers, choices are `gmres` and `bicgstab`.
  - `m`: Depth for Anderson acceleration, default as 0 for Picard iteration.
  - `beta`: Anderson mixing parameter, change f(x) to (1-beta)x+beta*f(x),
    equivalent to accelerating damped Picard iteration.
  - `autodiff`: Defaults to `missing`, which means we will default to letting
    `SIAMFANLEquations` construct the jacobian if `f.jac` is not provided. In other cases,
    we use it to generate a jacobian similar to other NonlinearSolve solvers.

### Submethod Choice

  - `:newton`: Classical Newton method.
  - `:pseudotransient`: Pseudo transient method.
  - `:secant`: Secant method for scalar equations.
  - `:anderson`: Anderson acceleration for fixed point iterations.

!!! note

    This algorithm is only available if `SIAMFANLEquations.jl` is installed and loaded.
"""
@concrete struct SIAMFANLEquationsJL <: AbstractNonlinearSolveAlgorithm
    method::Symbol
    delta
    linsolve <: Union{Symbol, Nothing}
    m::Int
    beta
    autodiff
    name::Symbol
end

function SIAMFANLEquationsJL(;
        method = :newton, delta = 1.0e-3, linsolve = nothing, m = 0, beta = 1.0,
        autodiff = missing
    )
    if Base.get_extension(@__MODULE__, :NonlinearSolveSIAMFANLEquationsExt) === nothing
        error("`SIAMFANLEquationsJL` requires `SIAMFANLEquations.jl` to be loaded")
    end
    return SIAMFANLEquationsJL(
        method, delta, linsolve, m, beta, autodiff, :SIAMFANLEquationsJL
    )
end

"""
    PETScSNES(; petsclib = missing, autodiff = nothing, mpi_comm = missing, kwargs...)

Wrapper over [PETSc.jl](https://github.com/JuliaParallel/PETSc.jl) SNES solvers.

### Keyword Arguments

  - `petsclib`: PETSc library to use. If set to `missing`, then we will use the first
    available PETSc library in `PETSc.petsclibs` based on the problem element type.
  - `autodiff`: the choice of method for generating the Jacobian. Defaults to `nothing`
    which means that a default is selected according to the problem specification. Can be
    any valid ADTypes.jl autodiff type (conditional on that backend being supported in
    NonlinearSolve.jl). If set to `missing`, then PETSc computes the Jacobian using finite
    differences.
  - `mpi_comm`: MPI communicator to use. If set to `missing`, then we will use
    `MPI.COMM_SELF`.
  - `kwargs`: Keyword arguments to be passed to the PETSc SNES solver. See [PETSc SNES
    documentation](https://petsc.org/release/manual/snes/) and
    [SNESSetFromOptions](https://petsc.org/release/manualpages/SNES/SNESSetFromOptions)
    for more information.

### Options via `CommonSolve.solve`

These options are forwarded from `solve` to the PETSc SNES solver. If these are provided to
`kwargs`, then they will be ignored.

| `solve` option | PETSc SNES option |
|:-------------- |:----------------- |
| `atol`         | `snes_atol`       |
| `rtol`         | `snes_rtol`       |
| `maxiters`     | `snes_max_it`     |
| `show_trace`   | `snes_monitor`    |

!!! note

    This algorithm is only available if `PETSc.jl` is installed and loaded.
"""
@concrete struct PETScSNES <: AbstractNonlinearSolveAlgorithm
    petsclib
    mpi_comm
    autodiff
    snes_options
end

function PETScSNES(; petsclib = missing, autodiff = nothing, mpi_comm = missing, kwargs...)
    if Base.get_extension(@__MODULE__, :NonlinearSolvePETScExt) === nothing
        error("`PETScSNES` requires `PETSc.jl` to be loaded")
    end
    return PETScSNES(petsclib, mpi_comm, autodiff, kwargs)
end

@testitem "Adjoint Tests" tags = [:nopre] begin
    # Skip adjoint tests on Julia 1.12+ due to Enzyme/SciMLSensitivity compatibility issues
    # To re-enable: change condition to `false` or `VERSION >= v"1.13"`
    @static if VERSION < v"1.12"
        using ForwardDiff, ReverseDiff, SciMLSensitivity, Tracker, Zygote, Enzyme, Mooncake

        ff(u, p) = u .^ 2 .- p

        function solve_nlprob(p)
            prob = NonlinearProblem{false}(ff, [1.0, 2.0], p)
            sol = solve(prob, NewtonRaphson())
            res = sol isa AbstractArray ? sol : sol.u
            return sum(abs2, res)
        end

        p = [3.0, 2.0]

        ∂p_zygote = only(Zygote.gradient(solve_nlprob, p))
        ∂p_forwarddiff = ForwardDiff.gradient(solve_nlprob, p)
        ∂p_tracker = Tracker.data(only(Tracker.gradient(solve_nlprob, p)))
        ∂p_reversediff = ReverseDiff.gradient(solve_nlprob, p)
        ∂p_enzyme = Enzyme.gradient(Enzyme.set_runtime_activity(Enzyme.Reverse), solve_nlprob, p)[1]

        cache = Mooncake.prepare_gradient_cache(solve_nlprob, p)
        ∂p_mooncake = Mooncake.value_and_gradient!!(cache, solve_nlprob, p)[2][2]

        @test ∂p_zygote ≈ ∂p_tracker ≈ ∂p_reversediff ≈ ∂p_enzyme
        @test ∂p_zygote ≈ ∂p_forwarddiff ≈ ∂p_tracker ≈ ∂p_reversediff ≈ ∂p_enzyme
        @test ∂p_forwarddiff ≈ ∂p_mooncake
    else
        @info "Skipping adjoint tests on Julia $(VERSION) - Enzyme/SciMLSensitivity not compatible with 1.12+"
    end
end

"""
    FastShortcutNonlinearPolyalg(
        ::Type{T} = Float64;
        concrete_jac = nothing,
        linsolve = nothing,
        must_use_jacobian::Val = Val(false),
        prefer_simplenonlinearsolve::Val = Val(false),
        autodiff = nothing, vjp_autodiff = nothing, jvp_autodiff = nothing,
        u0_len::Union{Int, Nothing} = nothing
    ) where {T}

A polyalgorithm focused on balancing speed and robustness. It first tries less robust methods
for more performance and then tries more robust techniques if the faster ones fail.

### Arguments

  - `T`: The eltype of the initial guess. It is only used to check if some of the algorithms
    are compatible with the problem type. Defaults to `Float64`.

### Keyword Arguments

  - `u0_len`: The length of the initial guess. If this is `nothing`, then the length of the
    initial guess is not checked. If this is an integer and it is less than `25`, we use
    jacobian based methods.
"""
function FastShortcutNonlinearPolyalg(
        ::Type{T} = Float64;
        concrete_jac = nothing,
        linsolve = nothing,
        must_use_jacobian::Val = Val(false),
        prefer_simplenonlinearsolve::Val = Val(false),
        autodiff = nothing, vjp_autodiff = nothing, jvp_autodiff = nothing,
        u0_len::Union{Int, Nothing} = nothing
    ) where {T}
    start_index = 1
    common_kwargs = (; concrete_jac, linsolve, autodiff, vjp_autodiff, jvp_autodiff)
    common_kwargs_nocj = (; linsolve, autodiff, vjp_autodiff, jvp_autodiff)
    if must_use_jacobian isa Val{true}
        if T <: Complex
            algs = (NewtonRaphson(; common_kwargs...),)
        else
            algs = (
                NewtonRaphson(; common_kwargs...),
                TrustRegion(; common_kwargs...),
                TrustRegion(; common_kwargs..., radius_update_scheme = RUS.Bastin),
                LevenbergMarquardt(; common_kwargs_nocj...),
            )
        end
    else
        # SimpleNewtonRaphson and SimpleTrustRegion are not robust to singular Jacobians
        # and thus are not included in the polyalgorithm
        if prefer_simplenonlinearsolve isa Val{true}
            if T <: Complex
                algs = (
                    SimpleBroyden(),
                    SimpleKlement(),
                    NewtonRaphson(; common_kwargs...),
                )
            else
                start_index = u0_len !== nothing ? (u0_len ≤ 25 ? 3 : 1) : 1
                algs = (
                    SimpleBroyden(),
                    SimpleKlement(),
                    NewtonRaphson(; common_kwargs...),
                    TrustRegion(; common_kwargs...),
                    TrustRegion(; common_kwargs..., radius_update_scheme = RUS.Bastin),
                    LevenbergMarquardt(; common_kwargs_nocj...),
                )
            end
        else
            if T <: Complex
                algs = (
                    Broyden(; autodiff),
                    Klement(; linsolve, autodiff),
                    NewtonRaphson(; common_kwargs...),
                )
            else
                # TODO: This number requires a bit rigorous testing
                start_index = u0_len !== nothing ? (u0_len ≤ 25 ? 3 : 1) : 1
                algs = (
                    Broyden(; autodiff),
                    Klement(; linsolve, autodiff),
                    NewtonRaphson(; common_kwargs...),
                    TrustRegion(; common_kwargs...),
                    TrustRegion(; common_kwargs..., radius_update_scheme = RUS.Bastin),
                    LevenbergMarquardt(; common_kwargs_nocj...),
                )
            end
        end
    end
    return NonlinearSolvePolyAlgorithm(algs; start_index)
end

@testitem "Aqua" tags = [:misc] begin
    using NonlinearSolve, SimpleNonlinearSolve, Aqua

    Aqua.test_all(
        NonlinearSolve; ambiguities = false, piracies = false,
        stale_deps = false, deps_compat = false, persistent_tasks = false
    )
    Aqua.test_ambiguities(NonlinearSolve; recursive = false)
    Aqua.test_stale_deps(SimpleNonlinearSolve; ignore = [:SciMLJacobianOperators])
    Aqua.test_deps_compat(SimpleNonlinearSolve; ignore = [:SciMLJacobianOperators])
    Aqua.test_piracies(
        NonlinearSolve,
        treat_as_own = [
            NonlinearProblem, NonlinearLeastSquaresProblem, SciMLBase.AbstractNonlinearProblem,
            SimpleNonlinearSolve.AbstractSimpleNonlinearSolveAlgorithm,
        ]
    )
end

@testitem "Explicit Imports" tags = [:misc] begin
    using NonlinearSolve, ADTypes, SimpleNonlinearSolve, SciMLBase
    import FastLevenbergMarquardt, FixedPointAcceleration, LeastSquaresOptim, MINPACK,
        NLsolve, NLSolvers, SIAMFANLEquations, SpeedMapping

    using ExplicitImports

    @test check_no_implicit_imports(NonlinearSolve; skip = (Base, Core)) === nothing
    @test check_no_stale_explicit_imports(NonlinearSolve) === nothing
    @test check_all_qualified_accesses_via_owners(NonlinearSolve) === nothing
end

module NonlinearSolveNLSolversExt

using DifferentiationInterface: DifferentiationInterface, Constant
using FastClosures: @closure

using NLSolvers: NLSolvers, NEqOptions, NEqProblem

using NonlinearSolveBase: NonlinearSolveBase, is_fw_wrapped, get_raw_f
using NonlinearSolve: NonlinearSolve, NLSolversJL
using SciMLBase: SciMLBase, NonlinearProblem, ReturnCode
using Setfield: @set

const DI = DifferentiationInterface

function SciMLBase.__solve(
        prob::NonlinearProblem, alg::NLSolversJL, args...;
        abstol = nothing, reltol = nothing, maxiters = 1000, alias = SciMLBase.NonlinearAliasSpecifier(alias_u0 = false),
        termination_condition = nothing, kwargs...
    )
    # Unwrap AutoSpecialize — external packages do their own AD
    if is_fw_wrapped(prob.f.f)
        prob = @set prob.f.f = get_raw_f(prob.f.f)
    end

    if haskey(kwargs, :alias_u0)
        alias = SciMLBase.NonlinearAliasSpecifier(alias_u0 = kwargs[:alias_u0])
    end
    alias_u0 = alias.alias_u0
    NonlinearSolveBase.assert_extension_supported_termination_condition(
        termination_condition, alg
    )

    abstol = NonlinearSolveBase.get_tolerance(abstol, eltype(prob.u0))
    reltol = NonlinearSolveBase.get_tolerance(reltol, eltype(prob.u0))

    options = NEqOptions(; maxiter = maxiters, f_abstol = abstol, f_reltol = reltol)

    if prob.u0 isa Number
        f_scalar = Base.Fix2(prob.f, prob.p)
        autodiff = NonlinearSolveBase.select_jacobian_autodiff(prob, alg.autodiff)

        prep = DifferentiationInterface.prepare_derivative(
            prob.f, autodiff, prob.u0, Constant(prob.p)
        )

        fj_scalar = @closure (
            Jx,
            x,
        ) -> begin
            return DifferentiationInterface.value_and_derivative(
                prob.f, prep, autodiff, x, Constant(prob.p)
            )
        end

        prob_obj = NLSolvers.ScalarObjective(; f = f_scalar, fg = fj_scalar)
        prob_nlsolver = NEqProblem(prob_obj; inplace = false)
        res = NLSolvers.solve(prob_nlsolver, prob.u0, alg.method, options)

        retcode = ifelse(
            maximum(abs, res.info.best_residual) ≤ abstol,
            ReturnCode.Success, ReturnCode.MaxIters
        )
        stats = SciMLBase.NLStats(-1, -1, -1, -1, res.info.iter)

        return SciMLBase.build_solution(
            prob, alg, res.info.solution, res.info.best_residual;
            retcode, original = res, stats
        )
    end

    f!, u0, resid = NonlinearSolveBase.construct_extension_function_wrapper(prob; alias_u0)
    jac! = NonlinearSolveBase.construct_extension_jac(prob, alg, u0, resid; alg.autodiff)

    FJ_vector! = @closure (Fx, Jx, x) -> begin
        f!(Fx, x)
        jac!(Jx, x)
        return Fx, Jx
    end

    prob_obj = NLSolvers.VectorObjective(; F = f!, FJ = FJ_vector!)
    prob_nlsolver = NEqProblem(prob_obj)

    res = NLSolvers.solve(prob_nlsolver, u0, alg.method, options)

    retcode = ifelse(
        maximum(abs, res.info.best_residual) ≤ abstol,
        ReturnCode.Success, ReturnCode.MaxIters
    )
    stats = SciMLBase.NLStats(-1, -1, -1, -1, res.info.iter)

    return SciMLBase.build_solution(
        prob, alg, res.info.solution, res.info.best_residual;
        retcode, original = res, stats
    )
end

end

module MyModule
    include("./optimization_trimmable.jl")
end

function (@main)(argv::Vector{String})::Cint
    λ = parse(Float64, argv[1])
    sol = MyModule.TestModuleTrimmable.minimize(λ)
    println(Core.stdout, sum(sol.u))
    return 0
end

module NonlinearSolveLeastSquaresOptimExt

using LeastSquaresOptim: LeastSquaresOptim

using NonlinearSolveBase: NonlinearSolveBase, TraceMinimal, is_fw_wrapped, get_raw_f
using NonlinearSolve: NonlinearSolve, LeastSquaresOptimJL
using SciMLBase: SciMLBase, AbstractNonlinearProblem, ReturnCode
using Setfield: @set

const LSO = LeastSquaresOptim

function SciMLBase.__solve(
        prob::AbstractNonlinearProblem, alg::LeastSquaresOptimJL, args...;
        alias_u0 = false, abstol = nothing, reltol = nothing, maxiters = 1000,
        trace_level = TraceMinimal(), termination_condition = nothing,
        show_trace::Val = Val(false), store_trace::Val = Val(false), kwargs...
    )
    # Unwrap AutoSpecialize — external packages do their own AD
    if is_fw_wrapped(prob.f.f)
        prob = @set prob.f.f = get_raw_f(prob.f.f)
    end

    NonlinearSolveBase.assert_extension_supported_termination_condition(
        termination_condition, alg
    )

    f!, u, resid = NonlinearSolveBase.construct_extension_function_wrapper(prob; alias_u0)
    abstol = NonlinearSolveBase.get_tolerance(abstol, eltype(u))
    reltol = NonlinearSolveBase.get_tolerance(reltol, eltype(u))

    if prob.f.jac === nothing && alg.autodiff isa Symbol
        lsoprob = LSO.LeastSquaresProblem(;
            x = u, f!, y = resid, alg.autodiff, J = prob.f.jac_prototype,
            output_length = length(resid)
        )
    else
        g! = NonlinearSolveBase.construct_extension_jac(prob, alg, u, resid; alg.autodiff)
        lsoprob = LSO.LeastSquaresProblem(;
            x = u, f!, y = resid, g!, J = prob.f.jac_prototype,
            output_length = length(resid)
        )
    end

    linsolve = alg.linsolve === :qr ? LSO.QR() :
        (
            alg.linsolve === :cholesky ? LSO.Cholesky() :
            (alg.linsolve === :lsmr ? LSO.LSMR() : nothing)
        )

    lso_solver = if alg.alg === :lm
        LSO.LevenbergMarquardt(linsolve)
    elseif alg.alg === :dogleg
        LSO.Dogleg(linsolve)
    else
        throw(ArgumentError("Unknown LeastSquaresOptim Algorithm: $(Meta.quot(alg.alg))"))
    end

    allocated_prob = LSO.LeastSquaresProblemAllocated(lsoprob, lso_solver)
    res = LSO.optimize!(
        allocated_prob;
        x_tol = reltol, f_tol = abstol, g_tol = abstol, iterations = maxiters,
        show_trace = show_trace isa Val{true}, store_trace = store_trace isa Val{true},
        show_every = trace_level.print_frequency
    )

    retcode = res.x_converged || res.f_converged || res.g_converged ? ReturnCode.Success :
        (
            res.iterations ≥ maxiters ? ReturnCode.MaxIters :
            ReturnCode.ConvergenceFailure
        )
    stats = SciMLBase.NLStats(res.f_calls, res.g_calls, -1, -1, res.iterations)

    f!(resid, res.minimizer)

    return SciMLBase.build_solution(
        prob, alg, res.minimizer, resid; retcode, original = res, stats
    )
end

end

using Documenter, DocumenterCitations, DocumenterInterLinks

using Sundials
using NonlinearSolveBase, SciMLBase
using SimpleNonlinearSolve, BracketingNonlinearSolve
using NonlinearSolveFirstOrder, NonlinearSolveQuasiNewton, NonlinearSolveSpectralMethods
using NonlinearSolveHomotopyContinuation, NonlinearSolveSciPy
using SciMLJacobianOperators, LineSearch
using NonlinearSolve, SteadyStateDiffEq

cp(
    joinpath(@__DIR__, "Manifest.toml"),
    joinpath(@__DIR__, "src/assets/Manifest.toml");
    force = true
)
cp(
    joinpath(@__DIR__, "Project.toml"),
    joinpath(@__DIR__, "src/assets/Project.toml");
    force = true
)

include("pages.jl")

bib = CitationBibliography(joinpath(@__DIR__, "src", "refs.bib"))

interlinks = InterLinks(
    "ADTypes" => "https://docs.sciml.ai/ADTypes/dev/",
    "LineSearch" => "https://docs.sciml.ai/LineSearch/dev/"
)

makedocs(;
    sitename = "NonlinearSolve.jl",
    authors = "SciML",
    modules = [
        NonlinearSolveBase, SciMLBase,
        SimpleNonlinearSolve, BracketingNonlinearSolve,
        NonlinearSolveFirstOrder, NonlinearSolveQuasiNewton, NonlinearSolveSpectralMethods,
        NonlinearSolveHomotopyContinuation,
        Sundials, LineSearch,
        SciMLJacobianOperators, NonlinearSolveSciPy,
        NonlinearSolve, SteadyStateDiffEq,
    ],
    clean = true,
    doctest = false,
    linkcheck = true,
    linkcheck_ignore = [
        "https://twitter.com/ChrisRackauckas/status/1544743542094020615",
        "https://link.springer.com/article/10.1007/s40096-020-00339-4",
        "https://dl.acm.org/doi/10.1145/210089.210111",
        "https://www.sciencedirect.com/science/article/abs/pii/S0045782523007156",
        "https://github.com/devernay/cminpack/blob/d1f5f5a273862ca1bbcf58394e4ac060d9e22c76/hybrd.c",
        "https://github.com/devernay/cminpack/blob/d1f5f5a273862ca1bbcf58394e4ac060d9e22c76/hybrj.c",
        "https://github.com/devernay/cminpack/blob/d1f5f5a273862ca1bbcf58394e4ac060d9e22c76/lmder.c",
        "https://net-informations.com/faq/net/stack-heap.htm",  # Unreliable external site
    ],
    checkdocs = :exports,
    warnonly = [:missing_docs],
    plugins = [bib, interlinks],
    format = Documenter.HTML(
        assets = ["assets/favicon.ico", "assets/citations.css"],
        canonical = "https://docs.sciml.ai/NonlinearSolve/stable/"
    ),
    pages
)

deploydocs(repo = "github.com/SciML/NonlinearSolve.jl.git"; push_preview = true)

@testsetup module WrapperNLLSSetup

include("../../common/common_nlls_testing.jl")

end

@testitem "LeastSquaresOptim.jl" setup = [WrapperNLLSSetup] tags = [:wrappers] begin
    import LeastSquaresOptim

    nlls_problems = [prob_oop, prob_iip]

    solvers = []
    for alg in (:lm, :dogleg),
            autodiff in (nothing, AutoForwardDiff(), AutoFiniteDiff(), :central, :forward)

        push!(solvers, LeastSquaresOptimJL(alg; autodiff))
    end

    for prob in nlls_problems, solver in solvers

        sol = solve(prob, solver; maxiters = 10000, abstol = 1.0e-8)
        @test SciMLBase.successful_retcode(sol)
        @test maximum(abs, sol.resid) < 1.0e-6
    end
end

@testitem "FastLevenbergMarquardt.jl + CMINPACK: Jacobian Provided" setup = [WrapperNLLSSetup] tags = [:wrappers] begin
    import FastLevenbergMarquardt, MINPACK
    using ForwardDiff

    function jac!(J, θ, p)
        resid = zeros(length(p))
        ForwardDiff.jacobian!(J, (resid, θ) -> loss_function(resid, θ, p), resid, θ)
        return J
    end

    jac(θ, p) = ForwardDiff.jacobian(θ -> loss_function(θ, p), θ)

    probs = [
        NonlinearLeastSquaresProblem(
            NonlinearFunction{true}(
                loss_function; resid_prototype = zero(y_target), jac = jac!
            ),
            θ_init, x
        ),
        NonlinearLeastSquaresProblem(
            NonlinearFunction{false}(
                loss_function; resid_prototype = zero(y_target), jac = jac
            ),
            θ_init, x
        ),
        NonlinearLeastSquaresProblem(
            NonlinearFunction{false}(loss_function; jac), θ_init, x
        ),
    ]

    solvers = Any[FastLevenbergMarquardtJL(linsolve) for linsolve in (:cholesky, :qr)]
    Sys.isapple()||push!(solvers, CMINPACK())

    for solver in solvers, prob in probs

        sol = solve(prob, solver; maxiters = 10000, abstol = 1.0e-8)
        @test maximum(abs, sol.resid) < 1.0e-6
    end
end

@testitem "FastLevenbergMarquardt.jl + CMINPACK: Jacobian Not Provided" setup = [WrapperNLLSSetup] tags = [:wrappers] begin
    import FastLevenbergMarquardt, MINPACK

    probs = [
        NonlinearLeastSquaresProblem(
            NonlinearFunction{true}(loss_function; resid_prototype = zero(y_target)),
            θ_init, x
        ),
        NonlinearLeastSquaresProblem(
            NonlinearFunction{false}(loss_function; resid_prototype = zero(y_target)),
            θ_init, x
        ),
        NonlinearLeastSquaresProblem(NonlinearFunction{false}(loss_function), θ_init, x),
    ]

    solvers = []
    for linsolve in (:cholesky, :qr),
            autodiff in (nothing, AutoForwardDiff(), AutoFiniteDiff())

        push!(solvers, FastLevenbergMarquardtJL(linsolve; autodiff))
    end
    if !Sys.isapple()
        for method in (:auto, :lm, :lmdif)
            push!(solvers, CMINPACK(; method))
        end
    end

    for solver in solvers, prob in probs

        sol = solve(prob, solver; maxiters = 10000, abstol = 1.0e-8)
        @test maximum(abs, sol.resid) < 1.0e-6
    end
end

@testitem "FastLevenbergMarquardt.jl + StaticArrays" setup = [WrapperNLLSSetup] tags = [:wrappers] begin
    using StaticArrays, FastLevenbergMarquardt

    x_sa = SA[-1.0, -0.5, 0.0, 0.5, 1.0]

    const y_target_sa = true_function(x_sa, θ_true)

    function loss_function_sa(θ, p)
        ŷ = true_function(p, θ)
        return ŷ .- y_target_sa
    end

    θ_init_sa = SVector{4}(θ_init)
    prob_sa = NonlinearLeastSquaresProblem{false}(loss_function_sa, θ_init_sa, x)

    sol = solve(prob_sa, FastLevenbergMarquardtJL())
    @test maximum(abs, sol.resid) < 1.0e-6
end

module NonlinearSolveFixedPointAccelerationExt

using FixedPointAcceleration: FixedPointAcceleration, fixed_point

using NonlinearSolveBase: NonlinearSolveBase, is_fw_wrapped, get_raw_f
using NonlinearSolve: NonlinearSolve, FixedPointAccelerationJL
using SciMLBase: SciMLBase, NonlinearProblem, ReturnCode
using Setfield: @set

function SciMLBase.__solve(
        prob::NonlinearProblem, alg::FixedPointAccelerationJL, args...;
        abstol = nothing, maxiters = 1000, alias = SciMLBase.NonlinearAliasSpecifier(alias_u0 = false),
        show_trace::Val = Val(false), termination_condition = nothing, kwargs...
    )
    # Unwrap AutoSpecialize — external packages do their own AD
    if is_fw_wrapped(prob.f.f)
        prob = @set prob.f.f = get_raw_f(prob.f.f)
    end

    if haskey(kwargs, :alias_u0)
        alias = SciMLBase.NonlinearAliasSpecifier(alias_u0 = kwargs[:alias_u0])
    end
    alias_u0 = alias.alias_u0
    NonlinearSolveBase.assert_extension_supported_termination_condition(
        termination_condition, alg
    )

    f, u0,
        resid = NonlinearSolveBase.construct_extension_function_wrapper(
        prob; alias_u0, make_fixed_point = Val(true), force_oop = Val(true)
    )

    tol = NonlinearSolveBase.get_tolerance(abstol, eltype(u0))

    sol = fixed_point(
        f, u0; Algorithm = alg.algorithm, MaxIter = maxiters, MaxM = alg.m,
        ConvergenceMetricThreshold = tol, ExtrapolationPeriod = alg.extrapolation_period,
        Dampening = alg.dampening, PrintReports = show_trace isa Val{true},
        ReplaceInvalids = alg.replace_invalids,
        ConditionNumberThreshold = alg.condition_number_threshold, quiet_errors = true
    )

    if sol.FixedPoint_ === missing
        u0 = prob.u0 isa Number ? u0[1] : u0
        resid = NonlinearSolveBase.Utils.evaluate_f(prob, u0)
        res = u0
        converged = false
    else
        res = prob.u0 isa Number ? first(sol.FixedPoint_) :
            reshape(sol.FixedPoint_, size(prob.u0))
        resid = NonlinearSolveBase.Utils.evaluate_f(prob, res)
        converged = maximum(abs, resid) ≤ tol
    end

    return SciMLBase.build_solution(
        prob, alg, res, resid; original = sol,
        retcode = converged ? ReturnCode.Success : ReturnCode.Failure,
        stats = SciMLBase.NLStats(sol.Iterations_, 0, 0, 0, sol.Iterations_)
    )
end

end

module NonlinearSolveFastLevenbergMarquardtExt

using FastClosures: @closure

using ArrayInterface: ArrayInterface
using FastLevenbergMarquardt: FastLevenbergMarquardt
using StaticArraysCore: SArray

using NonlinearSolveBase: NonlinearSolveBase, is_fw_wrapped, get_raw_f
using NonlinearSolve: NonlinearSolve, FastLevenbergMarquardtJL
using SciMLBase: SciMLBase, AbstractNonlinearProblem, ReturnCode
using Setfield: @set

const FastLM = FastLevenbergMarquardt

function SciMLBase.__solve(
        prob::AbstractNonlinearProblem, alg::FastLevenbergMarquardtJL, args...;
        alias_u0 = false, abstol = nothing, reltol = nothing, maxiters = 1000,
        termination_condition = nothing, kwargs...
    )
    # Unwrap AutoSpecialize — external packages do their own AD
    if is_fw_wrapped(prob.f.f)
        prob = @set prob.f.f = get_raw_f(prob.f.f)
    end

    NonlinearSolveBase.assert_extension_supported_termination_condition(
        termination_condition, alg
    )

    f_wrapped, u,
        resid = NonlinearSolveBase.construct_extension_function_wrapper(
        prob; alias_u0, can_handle_oop = Val(prob.u0 isa SArray)
    )
    f = if prob.u0 isa SArray
        @closure (u, p) -> f_wrapped(u)
    else
        @closure (du, u, p) -> f_wrapped(du, u)
    end

    abstol = NonlinearSolveBase.get_tolerance(abstol, eltype(u))
    reltol = NonlinearSolveBase.get_tolerance(reltol, eltype(u))

    jac_fn_wrapped = NonlinearSolveBase.construct_extension_jac(
        prob, alg, u, resid; alg.autodiff, can_handle_oop = Val(prob.u0 isa SArray)
    )
    jac_fn = if prob.u0 isa SArray
        @closure (u, p) -> jac_fn_wrapped(u)
    else
        @closure (J, u, p) -> jac_fn_wrapped(J, u)
    end

    solver_kwargs = (;
        xtol = reltol, ftol = reltol, gtol = abstol, maxit = maxiters,
        alg.factor, alg.factoraccept, alg.factorreject, alg.minscale,
        alg.maxscale, alg.factorupdate, alg.minfactor, alg.maxfactor,
    )

    if prob.u0 isa SArray
        res, fx, info, iter, nfev,
            njev = FastLM.lmsolve(
            f, jac_fn, prob.u0; solver_kwargs...
        )
        LM, solver = nothing, nothing
    else
        J = prob.f.jac_prototype === nothing ? similar(u, length(resid), length(u)) :
            zero(prob.f.jac_prototype)

        solver = if alg.linsolve === :cholesky
            FastLM.CholeskySolver(ArrayInterface.undefmatrix(u))
        elseif alg.linsolve === :qr
            FastLM.QRSolver(eltype(u), length(u))
        else
            throw(ArgumentError("Unknown FastLevenbergMarquardt Linear Solver: \
                                 $(Meta.quot(alg.linsolve))"))
        end

        LM = FastLM.LMWorkspace(u, resid, J)

        res, fx, info, iter, nfev, njev,
            LM, solver = FastLM.lmsolve!(
            f, jac_fn, LM; solver, solver_kwargs...
        )
    end

    stats = SciMLBase.NLStats(nfev, njev, -1, -1, iter)
    retcode = info == -1 ? ReturnCode.MaxIters : ReturnCode.Success
    return SciMLBase.build_solution(
        prob, alg, res, fx; retcode,
        original = (res, fx, info, iter, nfev, njev, LM, solver), stats
    )
end

end

module TrimTest
#=
Currently, trimming only works if the target code is in a package. I.e., trying to trim
```julia
include("optimization_trimmable.jl")
function (@main)(argv::Vector{String})::Cint
    minimize(1.0)
    return 0
end
```
or even
```julia
mod MyMod
    include("optimization_trimmable.jl")
end
function (@main)(argv::Vector{String})::Cint
    MyMod.minimize(1.0)
    return 0
end
```
segfaults `juliac`. Looking at the segfault stacktrace it seems the culprit is
`const cache = init(...)`. Either way, we circumvent the segfault by putting
this below code into a package definition.
=#
include("../optimization_trimmable.jl")
include("../optimization_clean.jl")
end

@testitem "Steady State Problems" tags = [:wrappers] retries = 5 begin
    import NLSolvers, NLsolve, SIAMFANLEquations, MINPACK

    function f_iip(du, u, p, t)
        du[1] = 2 - 2u[1]
        du[2] = u[1] - 4u[2]
    end
    u0 = zeros(2)
    prob_iip = SteadyStateProblem(f_iip, u0)

    algs = Any[
        NLSolversJL(NLSolvers.LineSearch(NLSolvers.Newton(), NLSolvers.Backtracking())),
        NLsolveJL(),
        SIAMFANLEquationsJL(),
        CMINPACK(),
    ]

    @testset "$(nameof(typeof(alg)))" for alg in algs
        alg isa CMINPACK && Sys.isapple() && continue
        sol = solve(prob_iip, alg)
        @test SciMLBase.successful_retcode(sol.retcode)
        @test maximum(abs, sol.resid) < 1.0e-6
    end

    f_oop(u, p, t) = [2 - 2u[1], u[1] - 4u[2]]
    u0 = zeros(2)
    prob_oop = SteadyStateProblem(f_oop, u0)

    @testset "$(nameof(typeof(alg)))" for alg in algs
        alg isa CMINPACK && Sys.isapple() && continue
        sol = solve(prob_oop, alg)
        @test SciMLBase.successful_retcode(sol.retcode)
        @test maximum(abs, sol.resid) < 1.0e-6
    end
end

@testitem "Nonlinear Root Finding Problems" tags = [:wrappers] retries = 5 begin
    using LinearAlgebra
    import NLSolvers, NLsolve, SIAMFANLEquations, MINPACK

    function f_iip(du, u, p)
        du[1] = 2 - 2u[1]
        du[2] = u[1] - 4u[2]
    end
    u0 = zeros(2)
    prob_iip = NonlinearProblem{true}(f_iip, u0)

    algs = Any[
        NLSolversJL(NLSolvers.LineSearch(NLSolvers.Newton(), NLSolvers.Backtracking())),
        NLsolveJL(),
        SIAMFANLEquationsJL(),
        CMINPACK(),
    ]

    @testset "$(nameof(typeof(alg)))" for alg in algs
        alg isa CMINPACK && Sys.isapple() && continue
        local sol
        sol = solve(prob_iip, alg)
        @test SciMLBase.successful_retcode(sol.retcode)
        @test maximum(abs, sol.resid) < 1.0e-6
    end

    f_oop(u, p) = [2 - 2u[1], u[1] - 4u[2]]
    u0 = zeros(2)
    prob_oop = NonlinearProblem{false}(f_oop, u0)
    @testset "$(nameof(typeof(alg)))" for alg in algs
        alg isa CMINPACK && Sys.isapple() && continue
        local sol
        sol = solve(prob_oop, alg)
        @test SciMLBase.successful_retcode(sol.retcode)
        @test maximum(abs, sol.resid) < 1.0e-6
    end

    f_tol(u, p) = u^2 - 2
    prob_tol = NonlinearProblem(f_tol, 1.0)
    tol_algs = Any[
        NLSolversJL(NLSolvers.LineSearch(NLSolvers.Newton(), NLSolvers.Backtracking())),
        NLsolveJL(),
        CMINPACK(),
        SIAMFANLEquationsJL(; method = :newton),
        SIAMFANLEquationsJL(; method = :pseudotransient),
        SIAMFANLEquationsJL(; method = :secant),
    ]
    for tol in [1.0e-1, 1.0e-3, 1.0e-6, 1.0e-10, 1.0e-15], alg in tol_algs
        alg isa CMINPACK && Sys.isapple() && continue
        sol = solve(prob_tol, alg, abstol = tol)
        @test abs(sol.u[1] - sqrt(2)) < tol
    end

    f_jfnk(u, p) = u^2 - 2
    prob_jfnk = NonlinearProblem(f_jfnk, 1.0)
    for tol in [1.0e-1, 1.0e-3, 1.0e-6, 1.0e-10, 1.0e-11]
        sol = solve(prob_jfnk, SIAMFANLEquationsJL(linsolve = :gmres), abstol = tol)
        @test abs(sol.u[1] - sqrt(2)) < tol
    end

    # Test the finite differencing technique
    function f!(fvec, x, p)
        fvec[1] = (x[1] + 3) * (x[2]^3 - 7) + 18
        fvec[2] = sin(x[2] * exp(x[1]) - 1)
    end

    prob = NonlinearProblem{true}(f!, [0.1; 1.2])
    sol = solve(prob, NLsolveJL(autodiff = :central))
    @test maximum(abs, sol.resid) < 1.0e-6
    sol = solve(prob, SIAMFANLEquationsJL())
    @test maximum(abs, sol.resid) < 1.0e-6

    # Test the autodiff technique
    sol = solve(prob, NLsolveJL(autodiff = :forward))
    @test maximum(abs, sol.resid) < 1.0e-6

    # Custom Jacobian
    f_custom_jac!(F, u, p) = (F[1:152] = u .^ 2 .- p)
    j_custom_jac!(J, u, p) = (J[1:152, 1:152] = diagm(2 .* u))

    init = ones(152)
    A = ones(152)
    A[6] = 0.8

    f = NonlinearFunction(f_custom_jac!; jac = j_custom_jac!)
    p = A

    ProbN = NonlinearProblem(f, init, p)

    sol = solve(ProbN, NLsolveJL(); abstol = 1.0e-8)
    @test maximum(abs, sol.resid) < 1.0e-6
    sol = solve(
        ProbN,
        NLSolversJL(NLSolvers.LineSearch(NLSolvers.Newton(), NLSolvers.Backtracking()));
        abstol = 1.0e-8
    )
    @test maximum(abs, sol.resid) < 1.0e-6
    sol = solve(ProbN, SIAMFANLEquationsJL(; method = :newton); abstol = 1.0e-8)
    @test maximum(abs, sol.resid) < 1.0e-6
    sol = solve(ProbN, SIAMFANLEquationsJL(; method = :pseudotransient); abstol = 1.0e-8)
    @test maximum(abs, sol.resid) < 1.0e-6
end

using SafeTestsets

@safetestset "Clean implementation (non-trimmable)" begin
    using JET
    using SciMLBase: successful_retcode
    include("optimization_clean.jl")
    @test successful_retcode(TestModuleClean.minimize(1.0).retcode)
    # can't use `@test_opt` macro here because it would try to eval before
    # `using JET` is processed
    test_opt(TestModuleClean.minimize, (typeof(1.0),))
end

@safetestset "Trimmable implementation" begin
    using JET
    using SciMLBase: successful_retcode
    include("optimization_trimmable.jl")
    @test successful_retcode(TestModuleTrimmable.minimize(1.0).retcode)
    # can't use `@test_opt` macro here because it would try to eval before
    # `using JET` is processed
    test_opt(TestModuleTrimmable.minimize, (typeof(1.0),))
end

@safetestset "Run trim" begin
    # https://discourse.julialang.org/t/capture-stdout-and-stderr-in-case-a-command-fails/101772/3?u=romeov
    """
    Run a Cmd object, returning the stdout & stderr contents plus the exit code
    """
    function _execute(cmd::Cmd)
        out = Pipe()
        err = Pipe()
        process = run(pipeline(ignorestatus(cmd); stdout = out, stderr = err))
        close(out.in)
        close(err.in)
        out = (
            stdout = String(read(out)), stderr = String(read(err)),
            exitcode = process.exitcode,
        )
        return out
    end

    JULIAC = normpath(
        joinpath(
            Sys.BINDIR, Base.DATAROOTDIR, "julia", "juliac",
            "juliac.jl"
        )
    )
    @test isfile(JULIAC)

    for (mainfile, expectedtopass) in [
            ("main_trimmable.jl", true),
            #= The test below should verify that we indeed can't get a trimmed binary
    # for the "clean" implementation, but will trigger in the future if
    # it does start working. Unfortunately, right now it hangs indefinitely
    # so we are commenting it out. =#
            # ("main_clean.jl", false),
            ("main_segfault.jl", false),
        ]
        binpath = tempname()
        cmd = `$(Base.julia_cmd()) --project=. --depwarn=error $(JULIAC) --experimental --trim=unsafe-warn --output-exe $(binpath) $(mainfile)`

        # since we are calling Julia from Julia, we first need to clean some
        # environment variables
        clean_env = copy(ENV)
        delete!(clean_env, "JULIA_PROJECT")
        delete!(clean_env, "JULIA_LOAD_PATH")
        # We could just check for success, but then failures are hard to debug.
        # Instead we use `_execute` to also capture `stdout` and `stderr`.
        # @test success(setenv(cmd, clean_env))
        trimcall = _execute(setenv(cmd, clean_env; dir = @__DIR__))
        if trimcall.exitcode != 0 && expectedtopass
            @show trimcall.stdout
            @show trimcall.stderr
        end
        @test trimcall.exitcode == 0 broken = !expectedtopass
        @test isfile(binpath) broken = !expectedtopass
        @test success(`$(binpath) 1.0`) broken = !expectedtopass
    end
end

@testsetup module ForwardADTesting
using Reexport, NonlinearSolve
@reexport using ForwardDiff, MINPACK, NLsolve, StaticArrays, Sundials, LinearAlgebra

test_f!(du, u, p) = (@. du = u^2 - p)
test_f(u, p) = (@. u^2 - p)

jacobian_f(::Number, p) = 1 / (2 * √p)
jacobian_f(::Number, p::Number) = 1 / (2 * √p)
jacobian_f(u, p::Number) = one.(u) .* (1 / (2 * √p))
jacobian_f(u, p::AbstractArray) = diagm(vec(@. 1 / (2 * √p)))

function solve_with(::Val{mode}, u, alg) where {mode}
    f = if mode === :iip
        solve_iip(p) = solve(NonlinearProblem(test_f!, u, p), alg).u
    elseif mode === :iip_cache
        function solve_iip_init(p)
            cache = SciMLBase.init(NonlinearProblem(test_f!, u, p), alg)
            return SciMLBase.solve!(cache).u
        end
    elseif mode === :oop
        solve_oop(p) = solve(NonlinearProblem(test_f, u, p), alg).u
    elseif mode === :oop_cache
        function solve_oop_init(p)
            cache = SciMLBase.init(NonlinearProblem(test_f, u, p), alg)
            return SciMLBase.solve!(cache).u
        end
    end
    return f
end

compatible(::Any, ::Val{:oop}) = true
compatible(::Any, ::Val{:oop_cache}) = true
compatible(::Number, ::Val{:iip}) = false
compatible(::AbstractArray, ::Val{:iip}) = true
compatible(::StaticArray, ::Val{:iip}) = false
compatible(::Number, ::Val{:iip_cache}) = false
compatible(::AbstractArray, ::Val{:iip_cache}) = true
compatible(::StaticArray, ::Val{:iip_cache}) = false

compatible(::Any, ::Number) = true
compatible(::Number, ::AbstractArray) = false
compatible(u::AbstractArray, p::AbstractArray) = size(u) == size(p)

compatible(u::Number, ::SciMLBase.AbstractNonlinearAlgorithm) = true
compatible(u::Number, ::Union{CMINPACK, NLsolveJL, KINSOL}) = true
compatible(u::AbstractArray, ::SciMLBase.AbstractNonlinearAlgorithm) = true
compatible(u::AbstractArray{T, N}, ::KINSOL) where {T, N} = N == 1  # Need to be fixed upstream
compatible(u::StaticArray{S, T, N}, ::KINSOL) where {S <: Tuple, T, N} = false
compatible(u::StaticArray, ::SciMLBase.AbstractNonlinearAlgorithm) = true
compatible(u::StaticArray, ::Union{CMINPACK, NLsolveJL, KINSOL}) = false
compatible(u, ::Nothing) = true

compatible(::Any, ::Any) = true
compatible(::CMINPACK, ::Val{:iip_cache}) = false
compatible(::CMINPACK, ::Val{:oop_cache}) = false
compatible(::NLsolveJL, ::Val{:iip_cache}) = false
compatible(::NLsolveJL, ::Val{:oop_cache}) = false
compatible(::KINSOL, ::Val{:iip_cache}) = false
compatible(::KINSOL, ::Val{:oop_cache}) = false

export test_f!, test_f, jacobian_f, solve_with, compatible
end

@testitem "ForwardDiff.jl Integration" setup = [ForwardADTesting] tags = [:nopre] begin
    @testset for alg in (
            NewtonRaphson(),
            TrustRegion(),
            LevenbergMarquardt(),
            PseudoTransient(; alpha_initial = 10.0),
            Broyden(),
            Klement(),
            DFSane(),
            FastShortcutNonlinearPolyalg(),
            nothing,
            NLsolveJL(),
            CMINPACK(),
            KINSOL(; globalization_strategy = :LineSearch),
        )
        us = (2.0, @SVector[1.0, 1.0], [1.0, 1.0], ones(2, 2), @SArray ones(2, 2))

        alg isa CMINPACK && Sys.isapple() && continue

        @testset "Scalar AD" begin
            for p in 1.0:0.1:100.0, u0 in us, mode in (:iip, :oop, :iip_cache, :oop_cache)
                compatible(u0, alg) || continue
                compatible(u0, Val(mode)) || continue
                compatible(alg, Val(mode)) || continue

                sol = solve(NonlinearProblem(test_f, u0, p), alg)
                if SciMLBase.successful_retcode(sol)
                    gs = abs.(ForwardDiff.derivative(solve_with(Val{mode}(), u0, alg), p))
                    gs_true = abs.(jacobian_f(u0, p))
                    if !(isapprox(gs, gs_true, atol = 1.0e-5))
                        @error "ForwardDiff Failed for u0=$(u0) and p=$(p) with $(alg)" forwardiff_gradient = gs true_gradient = gs_true
                    else
                        @test abs.(gs) ≈ abs.(gs_true) atol = 1.0e-5
                    end
                end
            end
        end

        @testset "Jacobian" begin
            for u0 in us,
                    p in ([2.0, 1.0], [2.0 1.0; 3.0 4.0]),
                    mode in (:iip, :oop, :iip_cache, :oop_cache)
                compatible(u0, p) || continue
                compatible(u0, alg) || continue
                compatible(u0, Val(mode)) || continue
                compatible(alg, Val(mode)) || continue

                sol = solve(NonlinearProblem(test_f, u0, p), alg)
                if SciMLBase.successful_retcode(sol)
                    gs = abs.(ForwardDiff.jacobian(solve_with(Val{mode}(), u0, alg), p))
                    gs_true = abs.(jacobian_f(u0, p))
                    if !(isapprox(gs, gs_true, atol = 1.0e-5))
                        @show sol.retcode, sol.u
                        @error "ForwardDiff Failed for u0=$(u0) and p=$(p) with $(alg)" forwardiff_jacobian = gs true_jacobian = gs_true
                    else
                        @test abs.(gs) ≈ abs.(gs_true) atol = 1.0e-5
                    end
                end
            end
        end
    end
end

@testitem "NLLS Hessian SciML/NonlinearSolve.jl#445" tags = [:core] begin
    using ForwardDiff, FiniteDiff

    function objfn(F, init, params)
        th1, th2 = init
        px, py, l1, l2 = params
        F[1] = l1 * cos(th1) + l2 * cos(th1 + th2) - px
        F[2] = l1 * sin(th1) + l2 * sin(th1 + th2) - py
        return F
    end

    function solve_nlprob(pxpy)
        px, py = pxpy
        theta1 = pi / 4
        theta2 = pi / 4
        initial_guess = [theta1; theta2]
        l1 = 60
        l2 = 60
        p = [px; py; l1; l2]
        prob = NonlinearLeastSquaresProblem(
            NonlinearFunction(objfn, resid_prototype = zeros(2)),
            initial_guess, p
        )
        resu = solve(
            prob,
            reltol = 1.0e-12, abstol = 1.0e-12
        )
        th1, th2 = resu.u
        cable1_base = [-90; 0; 0]
        cable2_base = [-150; 0; 0]
        cable3_base = [150; 0; 0]
        cable1_top = [l1 * cos(th1) / 2; l1 * sin(th1) / 2; 0]
        cable23_top = [
            l1 * cos(th1) + l2 * cos(th1 + th2) / 2;
            l1 * sin(th1) + l2 * sin(th1 + th2) / 2; 0
        ]
        c1_length = sqrt(
            (cable1_top[1] - cable1_base[1])^2 +
                (cable1_top[2] - cable1_base[2])^2
        )
        c2_length = sqrt(
            (cable23_top[1] - cable2_base[1])^2 +
                (cable23_top[2] - cable2_base[2])^2
        )
        c3_length = sqrt(
            (cable23_top[1] - cable3_base[1])^2 +
                (cable23_top[2] - cable3_base[2])^2
        )
        return c1_length + c2_length + c3_length
    end

    grad1 = ForwardDiff.gradient(solve_nlprob, [34.0, 87.0])
    grad2 = FiniteDiff.finite_difference_gradient(solve_nlprob, [34.0, 87.0])

    @test grad1 ≈ grad2 atol = 1.0e-3

    hess1 = ForwardDiff.hessian(solve_nlprob, [34.0, 87.0])
    hess2 = FiniteDiff.finite_difference_hessian(solve_nlprob, [34.0, 87.0])

    @test hess1 ≈ hess2 atol = 1.0e-3

    function solve_nlprob_with_cache(pxpy)
        px, py = pxpy
        theta1 = pi / 4
        theta2 = pi / 4
        initial_guess = [theta1; theta2]
        l1 = 60
        l2 = 60
        p = [px; py; l1; l2]
        prob = NonlinearLeastSquaresProblem(
            NonlinearFunction(objfn, resid_prototype = zeros(2)),
            initial_guess, p
        )
        cache = init(prob; reltol = 1.0e-12, abstol = 1.0e-12)
        resu = solve!(cache)
        th1, th2 = resu.u
        cable1_base = [-90; 0; 0]
        cable2_base = [-150; 0; 0]
        cable3_base = [150; 0; 0]
        cable1_top = [l1 * cos(th1) / 2; l1 * sin(th1) / 2; 0]
        cable23_top = [
            l1 * cos(th1) + l2 * cos(th1 + th2) / 2;
            l1 * sin(th1) + l2 * sin(th1 + th2) / 2; 0
        ]
        c1_length = sqrt(
            (cable1_top[1] - cable1_base[1])^2 +
                (cable1_top[2] - cable1_base[2])^2
        )
        c2_length = sqrt(
            (cable23_top[1] - cable2_base[1])^2 +
                (cable23_top[2] - cable2_base[2])^2
        )
        c3_length = sqrt(
            (cable23_top[1] - cable3_base[1])^2 +
                (cable23_top[2] - cable3_base[2])^2
        )
        return c1_length + c2_length + c3_length
    end

    grad1 = ForwardDiff.gradient(solve_nlprob_with_cache, [34.0, 87.0])
    grad2 = FiniteDiff.finite_difference_gradient(solve_nlprob_with_cache, [34.0, 87.0])

    @test grad1 ≈ grad2 atol = 1.0e-3

    hess1 = ForwardDiff.hessian(solve_nlprob_with_cache, [34.0, 87.0])
    hess2 = FiniteDiff.finite_difference_hessian(solve_nlprob_with_cache, [34.0, 87.0])

    @test hess1 ≈ hess2 atol = 1.0e-3
end

@testitem "reinit! on ForwardDiff cache SciML/NonlinearSolve.jl#391" tags = [:core] begin
    using ForwardDiff

    function multiple_solves(ps::Vector)
        res = similar(ps, 4, length(ps))
        for (i, p) in enumerate(ps)
            prob = NonlinearProblem{false}((u, p) -> u .* u .- p, rand(4), ps[i])
            sol = solve(prob)
            res[:, i] .= sol.u
        end
        return sum(abs2, res)
    end

    function multiple_solves_cached(ps::Vector)
        res = similar(ps, 4, length(ps))
        prob = NonlinearProblem{false}((u, p) -> u .* u .- p, rand(4), ps[1])
        cache = init(prob, NewtonRaphson())
        for (i, p) in enumerate(ps)
            reinit!(cache; p)
            sol = solve!(cache)
            res[:, i] .= sol.u
        end
        return sum(abs2, res)
    end

    ps = collect(1.0:5.0)

    @test ForwardDiff.gradient(multiple_solves, ps) ≈
        ForwardDiff.gradient(multiple_solves_cached, ps)
end

module NonlinearSolveSundialsExt

using Sundials: KINSOL

using CommonSolve: CommonSolve
using NonlinearSolveBase: NonlinearSolveBase, nonlinearsolve_forwarddiff_solve,
    nonlinearsolve_dual_solution, is_fw_wrapped, get_raw_f
using NonlinearSolve: NonlinearSolve, DualNonlinearProblem
using SciMLBase: SciMLBase, remake
using Setfield: @set

function SciMLBase.__solve(prob::DualNonlinearProblem, alg::KINSOL, args...; kwargs...)
    # Unwrap AutoSpecialize — external packages do their own AD
    if is_fw_wrapped(prob.f.f)
        prob = @set prob.f.f = get_raw_f(prob.f.f)
    end

    sol, partials = nonlinearsolve_forwarddiff_solve(prob, alg, args...; kwargs...)
    dual_soln = nonlinearsolve_dual_solution(sol.u, partials, prob.p)
    return SciMLBase.build_solution(
        prob, alg, dual_soln, sol.resid; sol.retcode, sol.stats, sol.original
    )
end

function SciMLBase.__init(prob::DualNonlinearProblem, alg::KINSOL, args...; kwargs...)
    p = NonlinearSolveBase.nodual_value(prob.p)
    newprob = SciMLBase.remake(prob; u0 = NonlinearSolveBase.nodual_value(prob.u0), p)
    cache = CommonSolve.init(newprob, alg, args...; kwargs...)
    return NonlinearSolveForwardDiffCache(
        cache, newprob, alg, prob.p, p, ForwardDiff.partials(prob.p)
    )
end

end

const EXTENSION_SOLVER_TYPES = [
    LeastSquaresOptimJL, FastLevenbergMarquardtJL, NLsolveJL, NLSolversJL,
    SpeedMappingJL, FixedPointAccelerationJL, SIAMFANLEquationsJL,
    CMINPACK, PETScSNES,
]

const DualNonlinearProblem = NonlinearProblem{
    <:Union{Number, <:AbstractArray}, iip,
    <:Union{<:Dual{T, V, P}, <:AbstractArray{<:Dual{T, V, P}}},
} where {iip, T, V, P}
const DualNonlinearLeastSquaresProblem = NonlinearLeastSquaresProblem{
    <:Union{Number, <:AbstractArray}, iip,
    <:Union{<:Dual{T, V, P}, <:AbstractArray{<:Dual{T, V, P}}},
} where {iip, T, V, P}
const DualAbstractNonlinearProblem = Union{
    DualNonlinearProblem, DualNonlinearLeastSquaresProblem,
}

for algType in EXTENSION_SOLVER_TYPES
    @eval function SciMLBase.__init(
            prob::DualAbstractNonlinearProblem, alg::$(algType), args...; kwargs...
        )
        p = NonlinearSolveBase.nodual_value(prob.p)
        newprob = SciMLBase.remake(prob; u0 = NonlinearSolveBase.nodual_value(prob.u0), p)
        cache = init(newprob, alg, args...; kwargs...)
        return NonlinearSolveForwardDiffCache(
            cache, newprob, alg, prob.p, p, ForwardDiff.partials(prob.p)
        )
    end
end

for algType in EXTENSION_SOLVER_TYPES
    @eval function SciMLBase.__solve(
            prob::DualAbstractNonlinearProblem, alg::$(algType), args...; kwargs...
        )
        sol,
            partials = NonlinearSolveBase.nonlinearsolve_forwarddiff_solve(
            prob, alg, args...; kwargs...
        )
        dual_soln = NonlinearSolveBase.nonlinearsolve_dual_solution(sol.u, partials, prob.p)
        return SciMLBase.build_solution(
            prob, alg, dual_soln, sol.resid; sol.retcode, sol.stats, sol.original
        )
    end
end

@testsetup module RobustnessTesting
using NonlinearSolve, LinearAlgebra, LinearSolve, NonlinearProblemLibrary, Test

problems = NonlinearProblemLibrary.problems
dicts = NonlinearProblemLibrary.dicts

function test_on_library(
        problems, dicts, alg_ops, broken_tests, ϵ = 1.0e-4; skip_tests = nothing
    )
    for (idx, (problem, dict)) in enumerate(zip(problems, dicts))
        x = dict["start"]
        res = similar(x)
        nlprob = NonlinearProblem(problem, copy(x))
        @testset "$idx: $(dict["title"]) | alg #$(alg_id)" for (alg_id, alg) in
            enumerate(alg_ops)
            try
                sol = solve(nlprob, alg; maxiters = 10000)
                problem(res, sol.u, nothing)

                skip = skip_tests !== nothing && idx in skip_tests[alg]
                if skip
                    @test_skip norm(res, Inf) ≤ ϵ
                    continue
                end
                broken = idx in broken_tests[alg] ? true : false
                @test norm(res, Inf) ≤ ϵ broken = broken
            catch err
                @error err
                broken = idx in broken_tests[alg] ? true : false
                if broken
                    @test false broken = true
                else
                    @test 1 == 2
                end
            end
        end
    end
end

export test_on_library, problems, dicts
end

@testitem "23 Test Problems: PolyAlgorithms" setup = [RobustnessTesting] tags = [:nopre] begin
    alg_ops = (RobustMultiNewton(), FastShortcutNonlinearPolyalg())

    broken_tests = Dict(alg => Int[] for alg in alg_ops)
    broken_tests[alg_ops[1]] = []
    broken_tests[alg_ops[2]] = []

    test_on_library(problems, dicts, alg_ops, broken_tests)
end

@testitem "23 Test Problems: NewtonRaphson" setup = [RobustnessTesting] tags = [:core] begin
    alg_ops = (
        NewtonRaphson(),
        SimpleNewtonRaphson(),
    )

    broken_tests = Dict(alg => Int[] for alg in alg_ops)
    # Generalized Rosenbrock function regressed when LinearSolve defaulted
    # residualsafety to false (SciML/LinearSolve.jl@93b2a2d3, 2026-04-08).
    broken_tests[alg_ops[1]] = [1]

    test_on_library(problems, dicts, alg_ops, broken_tests)
end

@testitem "23 Test Problems: Halley" setup = [RobustnessTesting] tags = [:core] begin
    alg_ops = (SimpleHalley(; autodiff = AutoForwardDiff()),)

    broken_tests = Dict(alg => Int[] for alg in alg_ops)
    broken_tests[alg_ops[1]] = [1, 5, 15, 16, 18]

    test_on_library(problems, dicts, alg_ops, broken_tests)
end

@testitem "23 Test Problems: TrustRegion" setup = [RobustnessTesting] tags = [:core] begin
    alg_ops = (
        TrustRegion(; radius_update_scheme = RadiusUpdateSchemes.Simple),
        TrustRegion(; radius_update_scheme = RadiusUpdateSchemes.Fan),
        TrustRegion(; radius_update_scheme = RadiusUpdateSchemes.Hei),
        TrustRegion(; radius_update_scheme = RadiusUpdateSchemes.Yuan),
        TrustRegion(; radius_update_scheme = RadiusUpdateSchemes.Bastin),
        TrustRegion(; radius_update_scheme = RadiusUpdateSchemes.NLsolve),
        SimpleTrustRegion(),
        SimpleTrustRegion(; nlsolve_update_rule = Val(true)),
    )

    broken_tests = Dict(alg => Int[] for alg in alg_ops)
    broken_tests[alg_ops[1]] = [11, 21]
    broken_tests[alg_ops[2]] = [11, 21]
    broken_tests[alg_ops[3]] = [11, 21]
    broken_tests[alg_ops[4]] = [8, 11, 21]
    broken_tests[alg_ops[5]] = [21]
    broken_tests[alg_ops[6]] = [11, 21]
    broken_tests[alg_ops[7]] = [3, 15, 16, 21]
    broken_tests[alg_ops[8]] = [15, 16]

    test_on_library(problems, dicts, alg_ops, broken_tests)
end

@testitem "23 Test Problems: LevenbergMarquardt" setup = [RobustnessTesting] tags = [:core] begin
    using LinearSolve

    alg_ops = (
        LevenbergMarquardt(),
        LevenbergMarquardt(; α_geodesic = 0.1),
        LevenbergMarquardt(; linsolve = CholeskyFactorization()),
    )

    broken_tests = Dict(alg => Int[] for alg in alg_ops)
    broken_tests[alg_ops[1]] = [11, 21]
    broken_tests[alg_ops[2]] = [11, 21]
    broken_tests[alg_ops[3]] = [11, 21]

    test_on_library(problems, dicts, alg_ops, broken_tests)
end

@testitem "23 Test Problems: DFSane" setup = [RobustnessTesting] tags = [:core] begin
    alg_ops = (
        DFSane(),
        SimpleDFSane(),
    )

    broken_tests = Dict(alg => Int[] for alg in alg_ops)
    broken_tests[alg_ops[1]] = [1, 2, 3, 5, 21]
    if Sys.isapple()
        if VERSION ≥ v"1.11-"
            broken_tests[alg_ops[2]] = [1, 2, 3, 5, 6, 11, 21]
        else
            broken_tests[alg_ops[2]] = [1, 2, 3, 5, 6, 21]
        end
    else
        broken_tests[alg_ops[2]] = [1, 2, 3, 5, 6, 11, 21]
    end

    test_on_library(problems, dicts, alg_ops, broken_tests)
end

@testitem "23 Test Problems: Broyden" setup = [RobustnessTesting] tags = [:core] retries = 3 begin
    alg_ops = (
        Broyden(),
        Broyden(; init_jacobian = Val(:true_jacobian)),
        Broyden(; update_rule = Val(:bad_broyden)),
        Broyden(; init_jacobian = Val(:true_jacobian), update_rule = Val(:bad_broyden)),
        SimpleBroyden(),
    )

    broken_tests = Dict(alg => Int[] for alg in alg_ops)
    broken_tests[alg_ops[2]] = [1, 5, 8, 11, 18]
    broken_tests[alg_ops[4]] = [5, 6, 8, 11]
    if Sys.isapple()
        broken_tests[alg_ops[1]] = [1, 5, 11]
        broken_tests[alg_ops[3]] = [1, 5, 6, 9, 11]
        if VERSION ≥ v"1.12"
            # Test #4 (Wood function) passes on v1.12+
            broken_tests[alg_ops[5]] = [1, 5, 11]
        elseif VERSION ≥ v"1.11-"
            broken_tests[alg_ops[5]] = [1, 4, 5, 11]
        else
            broken_tests[alg_ops[5]] = [1, 5, 11]
        end
    else
        broken_tests[alg_ops[1]] = [1, 5, 11]
        broken_tests[alg_ops[3]] = [1, 5, 6, 9, 11]
        broken_tests[alg_ops[5]] = [1, 5, 11]
    end

    test_on_library(problems, dicts, alg_ops, broken_tests, 1.0e-3)
end

@testitem "23 Test Problems: Klement" setup = [RobustnessTesting] tags = [:core] begin
    alg_ops = (
        Klement(),
        Klement(; init_jacobian = Val(:true_jacobian_diagonal)),
        SimpleKlement(),
    )

    broken_tests = Dict(alg => Int[] for alg in alg_ops)
    broken_tests[alg_ops[1]] = [1, 2, 4, 5, 11, 18, 22]
    broken_tests[alg_ops[2]] = [2, 4, 5, 7, 18, 22]
    broken_tests[alg_ops[3]] = [1, 2, 4, 5, 11, 22]

    test_on_library(problems, dicts, alg_ops, broken_tests)
end

@testitem "23 Test Problems: PseudoTransient" setup = [RobustnessTesting] tags = [:core] begin
    # PT relies on the root being a stable equilibrium for convergence, so it won't work on
    # most problems
    alg_ops = (PseudoTransient(),)

    broken_tests = Dict(alg => Int[] for alg in alg_ops)
    broken_tests[alg_ops[1]] = [1, 2, 3, 11, 15, 16]

    test_on_library(problems, dicts, alg_ops, broken_tests)
end

@testitem "Bounds: NonlinearLeastSquaresProblem" tags = [:core, :bounds] begin
    using SciMLBase, NonlinearSolveBase

    # Test out-of-place version
    f(u, p) = u .- p
    u0 = [5.0, 5.0]
    p = [1.0, 2.0]
    nf = NonlinearFunction(f; resid_prototype = zeros(2))
    alg = LevenbergMarquardt()

    @test !SciMLBase.allowsbounds(alg)

    @testset "solution within bounds" begin
        prob = NonlinearLeastSquaresProblem(nf, u0, p; lb = [0.0, 0.0], ub = [10.0, 10.0])
        sol = solve(prob, alg)

        @test SciMLBase.successful_retcode(sol)
        @test sol.u ≈ [1.0, 2.0] atol = 1.0e-6
        @test all(sol.u .>= 0.0)
        @test all(sol.u .<= 10.0)
    end

    @testset "solution clamped to bounds" begin
        prob = NonlinearLeastSquaresProblem(nf, u0, p; lb = [3.0, 3.0], ub = [10.0, 10.0])
        sol = solve(prob, alg)
        @test all(sol.u .>= 3.0)
        @test all(sol.u .<= 10.0)

        # Test init + solve! path
        cache = init(prob, alg)
        sol = solve!(cache)
        @test all(sol.u .>= 3.0)
        @test all(sol.u .<= 10.0)
    end

    # Test in-place version — use FullSpecialize for bounds compatibility
    f!(resid, u, p) = resid .= u .- p
    u0 = [5.0, 5.0]
    p = [1.0, 2.0]
    nf = NonlinearFunction{true, SciMLBase.FullSpecialize}(f!)
    lb = [0.0, 0.0]
    ub = [10.0, 10.0]

    prob = NonlinearLeastSquaresProblem(nf, u0, p; lb, ub)
    sol = solve(prob, alg)
    @test SciMLBase.successful_retcode(sol)
    @test sol.u ≈ [1.0, 2.0] atol = 1.0e-6

    # FullSpecialize preserves function identity
    @test sol.prob.f.f === f!

    # Default (AutoSpecialize) also works with bounds — bounds transform
    # unwraps AutoSpecializeCallable before wrapping in BoundedWrapper
    prob_as = NonlinearLeastSquaresProblem(NonlinearFunction(f!), u0, p; lb, ub)
    sol_as = solve(prob_as, alg)
    @test SciMLBase.successful_retcode(sol_as)
    @test sol_as.u ≈ [1.0, 2.0] atol = 1.0e-6
    @test sol.prob.lb == lb
    @test sol.prob.ub == ub
    @test sol.prob.u0 == prob.u0
end

@testitem "Bounds: one-sided" tags = [:core, :bounds] begin
    using SciMLBase

    f(u, p) = u .- p
    u0 = [5.0, 5.0]
    p = [1.0, 2.0]
    nf = NonlinearFunction(f; resid_prototype = zeros(2))
    alg = LevenbergMarquardt()
    @test !SciMLBase.allowsbounds(alg)

    @testset "lower bound only" begin
        prob = NonlinearLeastSquaresProblem(nf, u0, p; lb = [-Inf, 0.0])
        sol = solve(prob, alg)
        @test SciMLBase.successful_retcode(sol)
        @test sol.u ≈ [1.0, 2.0] atol = 1.0e-6
    end

    @testset "upper bound only" begin
        prob = NonlinearLeastSquaresProblem(nf, u0, p; ub = [Inf, 10.0])
        sol = solve(prob, alg)
        @test SciMLBase.successful_retcode(sol)
        @test sol.u ≈ [1.0, 2.0] atol = 1.0e-6
    end

    @testset "lower bound excludes solution" begin
        prob = NonlinearLeastSquaresProblem(nf, u0, p; lb = [3.0, 3.0])
        sol = solve(prob, alg)
        @test all(sol.u .>= 3.0)
    end
end

@testitem "Bounds: nonlinear model" tags = [:bounds, :nopre] begin
    using SciMLBase
    using Enzyme
    using NonlinearSolveBase: transform_bounded_problem, BoundedWrapper
    using PreallocationTools: FixedSizeDiffCache
    using ADTypes: AutoForwardDiff, AutoEnzyme

    # Test that the right cache type is chosen for the different autodiff backends
    let prob = NonlinearLeastSquaresProblem(Returns(42), [1.0, 1.0], 1:10)
        # Default to ForwardDiff
        unbounded_prob = transform_bounded_problem(prob, nothing)
        wrapper = unbounded_prob.f.f
        @test wrapper isa BoundedWrapper
        @test wrapper.u_cache isa FixedSizeDiffCache

        unbounded_prob = transform_bounded_problem(prob, LevenbergMarquardt())
        @test unbounded_prob.f.f.u_cache isa FixedSizeDiffCache

        unbounded_prob = transform_bounded_problem(prob, LevenbergMarquardt(; autodiff = AutoForwardDiff()))
        @test unbounded_prob.f.f.u_cache isa FixedSizeDiffCache

        # Test Enzyme
        unbounded_prob = transform_bounded_problem(prob, LevenbergMarquardt(; autodiff = AutoEnzyme()))
        @test unbounded_prob.f.f.u_cache isa typeof(prob.u0)
    end

    for autodiff in (AutoEnzyme(; function_annotation = Enzyme.Duplicated), AutoForwardDiff())
        # A more realistic test: fit y = a*exp(b*x) with bounds on parameters
        true_a, true_b = 2.0, -0.5
        x = collect(range(0.0, 3.0; length = 20))
        y = true_a .* exp.(true_b .* x)

        model(u, p) = u[1] .* exp.(u[2] .* p) .- y
        nf = NonlinearFunction(model; resid_prototype = zeros(20))
        u0 = [1.0, -1.0]
        alg = LevenbergMarquardt(; autodiff)
        @test !SciMLBase.allowsbounds(alg)

        @testset "unconstrained finds true params" begin
            prob = NonlinearLeastSquaresProblem(nf, u0, x)
            sol = solve(prob, alg)
            @test SciMLBase.successful_retcode(sol)
            @test sol.u ≈ [true_a, true_b] atol = 1.0e-6
        end

        @testset "bounded finds true params when in range" begin
            prob = NonlinearLeastSquaresProblem(
                nf, u0, x; lb = [0.0, -2.0], ub = [5.0, 0.0]
            )
            sol = solve(prob, alg)
            @test SciMLBase.successful_retcode(sol)
            @test sol.u ≈ [true_a, true_b] atol = 1.0e-6
        end

        @testset "bounds constrain the solution" begin
            prob = NonlinearLeastSquaresProblem(
                nf, u0, x; lb = [3.0, -2.0], ub = [5.0, -0.1]
            )
            sol = solve(prob, alg)
            @test sol.u[1] >= 3.0
            @test sol.u[2] >= -2.0
            @test sol.u[1] <= 5.0
            @test sol.u[2] <= -0.1
        end
    end
end

module NonlinearSolvePETScExt

using MPI: MPI
using PETSc: PETSc

using NonlinearSolveBase: NonlinearSolveBase, is_fw_wrapped, get_raw_f
using NonlinearSolve: NonlinearSolve, PETScSNES
using SciMLBase: SciMLBase, NonlinearProblem, ReturnCode
using Setfield: @set

using SparseArrays: AbstractSparseMatrix, SparseMatrixCSC, sparse, rowvals, nonzeros, nzrange

# Helper function to copy a Julia matrix to a PETSc matrix
function copy_to_petsc_mat!(J_petsc, J_julia::AbstractMatrix)
    m, n = size(J_julia)
    for j in 1:n
        for i in 1:m
            J_petsc[i, j] = J_julia[i, j]
        end
    end
    return nothing
end

# For sparse matrices, iterate over non-zero values
function copy_to_petsc_mat!(J_petsc, J_julia::SparseMatrixCSC)
    rows = rowvals(J_julia)
    vals = nonzeros(J_julia)
    m, n = size(J_julia)
    for j in 1:n
        for ii in nzrange(J_julia, j)
            i = rows[ii]
            J_petsc[i, j] = vals[ii]
        end
    end
    return nothing
end

function SciMLBase.__solve(
        prob::NonlinearProblem, alg::PETScSNES, args...;
        abstol = nothing, reltol = nothing,
        maxiters = 1000, alias = SciMLBase.NonlinearAliasSpecifier(alias_u0 = false), termination_condition = nothing,
        show_trace::Val = Val(false), kwargs...
    )
    # Unwrap AutoSpecialize — external packages do their own AD
    if is_fw_wrapped(prob.f.f)
        prob = @set prob.f.f = get_raw_f(prob.f.f)
    end

    if haskey(kwargs, :alias_u0)
        alias = SciMLBase.NonlinearAliasSpecifier(alias_u0 = kwargs[:alias_u0])
    end
    alias_u0 = alias.alias_u0
    # XXX: https://petsc.org/release/manualpages/SNES/SNESSetConvergenceTest/
    NonlinearSolveBase.assert_extension_supported_termination_condition(
        termination_condition, alg; abs_norm_supported = false
    )

    f_wrapped!, u0,
        resid = NonlinearSolveBase.construct_extension_function_wrapper(
        prob; alias_u0
    )
    T = eltype(u0)

    if alg.petsclib === missing
        petsclibidx = findfirst(PETSc.petsclibs) do petsclib
            petsclib isa PETSc.PetscLibType{T}
        end

        if petsclibidx === nothing
            error(lazy"No compatible PETSc library found for element type $(T). Pass in a \
                   custom `petsclib` via `PETScSNES(; petsclib = <petsclib>, ....)`.")
        end
        petsclib = PETSc.petsclibs[petsclibidx]
    else
        petsclib = alg.petsclib
    end
    PETSc.initialized(petsclib) || PETSc.initialize(petsclib)

    abstol = NonlinearSolveBase.get_tolerance(abstol, T)
    reltol = NonlinearSolveBase.get_tolerance(reltol, T)

    nf = Ref{Int}(0)

    # PETSc 0.4 callback signature: f!(fx, snes, x) returning PetscInt(0) for success
    # PETSc 0.4.2 passes PetscVec objects to callbacks
    function f!(cfx, snes_arg, cx)
        nf[] += 1
        # Use withlocalarray! with multiple vectors to get Julia array views
        # cx: read-only, cfx: write-only
        PETSc.withlocalarray!(cx, cfx; read = (true, false), write = (false, true)) do x_arr, fx_arr
            f_wrapped!(fx_arr, x_arr)
        end
        return PETSc.LibPETSc.PetscInt(0)
    end

    snes = PETSc.SNES(
        petsclib,
        alg.mpi_comm === missing ? MPI.COMM_SELF : alg.mpi_comm;
        alg.snes_options..., snes_monitor = show_trace isa Val{true}, snes_rtol = reltol,
        snes_atol = abstol, snes_max_it = maxiters
    )

    PETSc.setfunction!(snes, f!, PETSc.VecSeq(petsclib, MPI.COMM_SELF, zero(u0)))

    njac = Ref{Int}(-1)
    if alg.autodiff !== missing || prob.f.jac !== nothing
        autodiff = alg.autodiff === missing ? nothing : alg.autodiff
        if prob.u0 isa Number
            jac! = NonlinearSolveBase.construct_extension_jac(
                prob, alg, prob.u0, prob.u0; autodiff
            )
            J_init = zeros(T, 1, 1)
        else
            jac!,
                J_init = NonlinearSolveBase.construct_extension_jac(
                prob, alg, u0, resid; autodiff, initial_jacobian = Val(true)
            )
        end

        njac = Ref{Int}(0)

        mpi_comm = alg.mpi_comm === missing ? MPI.COMM_SELF : alg.mpi_comm
        if J_init isa AbstractSparseMatrix
            PJ = PETSc.MatCreateSeqAIJ(petsclib, mpi_comm, J_init)
        else
            PJ = PETSc.MatSeqDense(petsclib, J_init)
        end

        # PETSc 0.4 callback signature: jac!(J, snes, x) returning PetscInt(0) for success
        # Use J_init as intermediate storage for the Julia Jacobian
        function jac_fn!(J, snes_arg, cx)
            njac[] += 1
            PETSc.withlocalarray!(cx; read = true, write = false) do x_arr
                jac!(snes_arg.user_ctx.jacobian, x_arr)
                copy_to_petsc_mat!(J, snes_arg.user_ctx.jacobian)
                PETSc.assemble!(J)
            end
            return PETSc.LibPETSc.PetscInt(0)
        end
        PETSc.setjacobian!(snes, jac_fn!, PJ, PJ)
        snes.user_ctx = (; jacobian = J_init)
    end

    # Create PETSc vector for solution and solve
    x_petsc = PETSc.VecSeq(petsclib, MPI.COMM_SELF, copy(u0))
    PETSc.solve!(x_petsc, snes)

    # Copy solution back to Julia array
    res = similar(u0)
    PETSc.withlocalarray!(x_petsc; read = true) do x_arr
        copyto!(res, x_arr)
    end

    f_wrapped!(resid, res)
    u_res = prob.u0 isa Number ? res[1] : res
    resid_res = prob.u0 isa Number ? resid[1] : resid

    objective = maximum(abs, resid)
    # XXX: Return Code from PETSc
    retcode = ifelse(objective ≤ abstol, ReturnCode.Success, ReturnCode.Failure)
    return SciMLBase.build_solution(
        prob, alg, u_res, resid_res;
        retcode, original = snes,
        stats = SciMLBase.NLStats(nf[], njac[], -1, -1, -1)
    )
end

end

module NonlinearSolveMINPACKExt

using FastClosures: @closure
using MINPACK: MINPACK

using NonlinearSolveBase: NonlinearSolveBase, is_fw_wrapped, get_raw_f
using NonlinearSolve: NonlinearSolve, CMINPACK
using SciMLBase: SciMLBase, NonlinearLeastSquaresProblem, NonlinearProblem, ReturnCode
using Setfield: @set

function SciMLBase.__solve(
        prob::Union{NonlinearLeastSquaresProblem, NonlinearProblem}, alg::CMINPACK, args...;
        abstol = nothing, maxiters = 1000, alias_u0::Bool = false,
        show_trace::Val = Val(false), store_trace::Val = Val(false),
        termination_condition = nothing, kwargs...
    )
    # Unwrap AutoSpecialize — external packages do their own AD
    if is_fw_wrapped(prob.f.f)
        prob = @set prob.f.f = get_raw_f(prob.f.f)
    end

    NonlinearSolveBase.assert_extension_supported_termination_condition(
        termination_condition, alg
    )

    f_wrapped!, u0,
        resid = NonlinearSolveBase.construct_extension_function_wrapper(
        prob; alias_u0
    )
    resid_size = size(resid)
    f! = @closure (du, u) -> (f_wrapped!(du, u); Cint(0))
    m = length(resid)

    method = ifelse(
        alg.method === :auto,
        ifelse(prob isa NonlinearLeastSquaresProblem, :lm, :hybr), alg.method
    )

    show_trace = show_trace isa Val{true}
    tracing = store_trace isa Val{true}
    tol = NonlinearSolveBase.get_tolerance(abstol, eltype(u0))

    if alg.autodiff === missing && prob.f.jac === nothing
        original = MINPACK.fsolve(
            f!, u0, m; tol, show_trace, tracing, method, iterations = maxiters
        )
    else
        autodiff = alg.autodiff === missing ? nothing : alg.autodiff
        jac_wrapped! = NonlinearSolveBase.construct_extension_jac(
            prob, alg, u0, resid; autodiff
        )
        jac! = @closure (J, u) -> (jac_wrapped!(J, u); Cint(0))
        original = MINPACK.fsolve(
            f!, jac!, u0, m; tol, show_trace, tracing, method, iterations = maxiters
        )
    end

    u = original.x
    resid = original.f
    objective = maximum(abs, resid)
    retcode = ifelse(objective ≤ tol, ReturnCode.Success, ReturnCode.Failure)

    # These are only meaningful if `store_trace = Val(true)`
    stats = SciMLBase.NLStats(
        original.trace.f_calls, original.trace.g_calls,
        original.trace.g_calls, original.trace.g_calls, -1
    )

    u = prob.u0 isa Number ? original.x[1] : reshape(original.x, size(prob.u0))
    resid = prob.u0 isa Number ? resid[1] : reshape(resid, resid_size)
    return SciMLBase.build_solution(prob, alg, u, resid; retcode, original, stats)
end

end

module NonlinearSolve

using ConcreteStructs: @concrete
using Reexport: @reexport
using PrecompileTools: @compile_workload, @setup_workload

using ADTypes: ADTypes
using ArrayInterface: ArrayInterface
using CommonSolve: CommonSolve, init, solve, solve!
using LinearAlgebra: LinearAlgebra
using LineSearch: BackTracking
using NonlinearSolveBase: NonlinearSolveBase, AbstractNonlinearSolveAlgorithm,
    NonlinearSolvePolyAlgorithm, pickchunksize, NonlinearVerbosity

using SciMLBase: SciMLBase, ReturnCode, AbstractNonlinearProblem,
    NonlinearFunction,
    NonlinearProblem, NonlinearLeastSquaresProblem
using SymbolicIndexingInterface: SymbolicIndexingInterface
using StaticArraysCore: StaticArray

# Default Algorithm
using NonlinearSolveFirstOrder: NewtonRaphson, TrustRegion, LevenbergMarquardt, GaussNewton,
    RUS, RobustMultiNewton
using NonlinearSolveQuasiNewton: Broyden, Klement
using SimpleNonlinearSolve: SimpleBroyden, SimpleKlement

# Default AD Support
using FiniteDiff: FiniteDiff          # Default Finite Difference Method
using ForwardDiff: ForwardDiff, Dual  # Default Forward Mode AD

# Sub-Packages that are re-exported by NonlinearSolve
using BracketingNonlinearSolve: BracketingNonlinearSolve
using LineSearch: LineSearch
using LinearSolve: LinearSolve
using NonlinearSolveFirstOrder: NonlinearSolveFirstOrder, GeneralizedFirstOrderAlgorithm
using NonlinearSolveQuasiNewton: NonlinearSolveQuasiNewton, QuasiNewtonAlgorithm
using NonlinearSolveSpectralMethods: NonlinearSolveSpectralMethods, GeneralizedDFSane
using SimpleNonlinearSolve: SimpleNonlinearSolve

const SII = SymbolicIndexingInterface

include("poly_algs.jl")
include("extension_algs.jl")

include("default.jl")

include("forward_diff.jl")

@setup_workload begin
    nonlinear_functions = (
        (NonlinearFunction{false}((u, p) -> u .* u .- p), 0.1),
        (NonlinearFunction{false}((u, p) -> u .* u .- p), [0.1]),
        (NonlinearFunction{true}((du, u, p) -> du .= u .* u .- p), [0.1]),
    )

    nonlinear_problems = NonlinearProblem[]
    for (fn, u0) in nonlinear_functions
        push!(nonlinear_problems, NonlinearProblem(fn, u0, 2.0))
    end

    # IIP with Vector{Float64} params
    push!(
        nonlinear_problems,
        NonlinearProblem(
            NonlinearFunction{true}((du, u, p) -> du .= u .* u .- p),
            [0.1],
            [2.0],
        ),
    )

    # IIP with NullParameters (no p)
    push!(
        nonlinear_problems,
        NonlinearProblem(
            NonlinearFunction{true}((du, u, p) -> du .= u .* u .- 2.0),
            [0.1],
        ),
    )

    nonlinear_functions = (
        (NonlinearFunction{false}((u, p) -> (u .^ 2 .- p)[1:1]), [0.1, 0.0]),
        (
            NonlinearFunction{false}(
                (u, p) -> vcat(u .* u .- p, u .* u .- p)
            ),
            [0.1, 0.1],
        ),
        (
            NonlinearFunction{true}(
                (du, u, p) -> du[1] = u[1] * u[1] - p, resid_prototype = zeros(1)
            ),
            [0.1, 0.0],
        ),
        (
            NonlinearFunction{true}(
                (du, u, p) -> du .= vcat(u .* u .- p, u .* u .- p),
                resid_prototype = zeros(4)
            ),
            [0.1, 0.1],
        ),
    )

    nlls_problems = NonlinearLeastSquaresProblem[]
    for (fn, u0) in nonlinear_functions
        push!(nlls_problems, NonlinearLeastSquaresProblem(fn, u0, 2.0))
    end

    # NLLS with Vector{Float64} params
    push!(
        nlls_problems,
        NonlinearLeastSquaresProblem(
            NonlinearFunction{true}(
                (du, u, p) -> du .= vcat(u .* u .- p, u .* u .- p),
                resid_prototype = zeros(4),
            ),
            [0.1, 0.1],
            [2.0, 2.0],
        ),
    )

    nlp_algs = [NewtonRaphson(), TrustRegion(), LevenbergMarquardt()]
    nlls_algs = [GaussNewton(), TrustRegion(), LevenbergMarquardt()]

    @compile_workload begin
        @sync begin
            for prob in nonlinear_problems, alg in nlp_algs
                Threads.@spawn CommonSolve.solve(prob, alg; abstol = 1.0e-2, verbose = NonlinearVerbosity())
            end

            for prob in nlls_problems, alg in nlls_algs
                Threads.@spawn CommonSolve.solve(prob, alg; abstol = 1.0e-2, verbose = NonlinearVerbosity())
            end

            # Default algorithms — the paths hit by solve(prob) with no algorithm
            # NonlinearProblem → FastShortcutNonlinearPolyalg
            # NonlinearLeastSquaresProblem → FastShortcutNLLSPolyalg
            for prob in nonlinear_problems
                Threads.@spawn CommonSolve.solve(prob; abstol = 1.0e-2, verbose = NonlinearVerbosity())
            end
            for prob in nlls_problems
                Threads.@spawn CommonSolve.solve(prob; abstol = 1.0e-2, verbose = NonlinearVerbosity())
            end
        end
    end
end

# Rexexports
@reexport using SciMLBase, NonlinearSolveBase, LineSearch, ADTypes
@reexport using NonlinearSolveFirstOrder, NonlinearSolveSpectralMethods,
    NonlinearSolveQuasiNewton, SimpleNonlinearSolve, BracketingNonlinearSolve
@reexport using LinearSolve

# Poly Algorithms
export NonlinearSolvePolyAlgorithm, FastShortcutNonlinearPolyalg

# Extension Algorithms
export LeastSquaresOptimJL, FastLevenbergMarquardtJL, NLsolveJL, NLSolversJL,
    FixedPointAccelerationJL, SpeedMappingJL, SIAMFANLEquationsJL
export PETScSNES, CMINPACK

end

module TestModuleTrimmable
using NonlinearSolveFirstOrder
using DiffEqBase
using ADTypes: AutoForwardDiff
using ForwardDiff
using LinearAlgebra
using StaticArrays
using LinearSolve
import SciMLBase
const LS = LinearSolve

function f(u, p)
    L, U = cholesky(p.Σ)
    rhs = (u .* u .- p.λ)
    # there are some issues currently with LinearSolve and triangular matrices,
    # so we just make `L` dense here.
    linprob = LinearProblem(Matrix(L), rhs)
    alg = LS.GenericLUFactorization()
    sol = LinearSolve.solve(linprob, alg)
    return sol.u
end

struct MyParams{T, M}
    λ::T
    Σ::M
end

const autodiff = AutoForwardDiff(; chunksize = 1)
const alg = TrustRegion(; autodiff, linsolve = LS.CholeskyFactorization())
const prob = NonlinearLeastSquaresProblem{false}(
    f,
    rand(2),
    MyParams(rand(), hermitianpart(rand(2, 2) + 2I))
)
const cache = init(prob, alg)

function minimize(x)
    ps = MyParams(x, hermitianpart(rand(2, 2) + 2I))
    reinit!(cache, rand(2); p = ps)
    solve!(cache)
    return cache
end
end

module NonlinearSolveSIAMFANLEquationsExt

using FastClosures: @closure
using SIAMFANLEquations: SIAMFANLEquations, aasol, nsol, nsoli, nsolsc, ptcsol, ptcsoli,
    ptcsolsc, secant

using NonlinearSolveBase: NonlinearSolveBase, is_fw_wrapped, get_raw_f
using NonlinearSolve: NonlinearSolve, SIAMFANLEquationsJL
using SciMLBase: SciMLBase, NonlinearProblem, ReturnCode
using Setfield: @set

function siamfanlequations_retcode_mapping(sol)
    if sol.errcode == 0
        return ReturnCode.Success
    elseif sol.errcode == 10
        return ReturnCode.MaxIters
    elseif sol.errcode == 1
        return ReturnCode.Failure
    elseif sol.errcode == -1
        return ReturnCode.Default
    elseif sol.errcode == -2
        # aasol reports -2 when the Anderson iteration is diverging.
        return ReturnCode.Unstable
    else
        error(lazy"Unknown SIAMFANLEquations return code: $(sol.errcode)")
    end
end

function zeros_like(x, args...)
    z = similar(x, args...)
    fill!(z, false)
    return z
end

# pseudo transient continuation has a fixed cost per iteration, iteration statistics are
# not interesting here.
function siamfanlequations_stats_mapping(method, sol)
    ((method === :pseudotransient) || (method === :anderson)) && return nothing
    return SciMLBase.NLStats(
        sum(sol.stats.ifun), sum(sol.stats.ijac), 0, 0, sum(sol.stats.iarm)
    )
end

function SciMLBase.__solve(
        prob::NonlinearProblem, alg::SIAMFANLEquationsJL, args...;
        abstol = nothing, reltol = nothing, alias = SciMLBase.NonlinearAliasSpecifier(alias_u0 = false), maxiters = 1000,
        termination_condition = nothing, show_trace = Val(false), kwargs...
    )
    # Unwrap AutoSpecialize — external packages do their own AD
    if is_fw_wrapped(prob.f.f)
        prob = @set prob.f.f = get_raw_f(prob.f.f)
    end

    if haskey(kwargs, :alias_u0)
        alias = SciMLBase.NonlinearAliasSpecifier(alias_u0 = kwargs[:alias_u0])
    end
    alias_u0 = alias.alias_u0
    NonlinearSolveBase.assert_extension_supported_termination_condition(
        termination_condition, alg
    )

    (; method, delta, linsolve, m, beta) = alg
    T = eltype(prob.u0)
    atol = NonlinearSolveBase.get_tolerance(abstol, T)
    rtol = NonlinearSolveBase.get_tolerance(reltol, T)

    printerr = show_trace isa Val{true}

    if prob.u0 isa Number
        f = Base.Fix2(prob.f, prob.p)
        if method == :newton
            sol = nsolsc(f, prob.u0; maxit = maxiters, atol, rtol, printerr)
        elseif method == :pseudotransient
            sol = ptcsolsc(
                f, prob.u0; delta0 = delta, maxit = maxiters, atol, rtol, printerr
            )
        elseif method == :secant
            sol = secant(f, prob.u0; maxit = maxiters, atol, rtol, printerr)
        elseif method == :anderson
            f_aa, u,
                _ = NonlinearSolveBase.construct_extension_function_wrapper(
                prob; alias_u0, make_fixed_point = Val(true)
            )
            sol = aasol(
                f_aa, u, m, zeros_like(u, 1, 2 * m + 4);
                maxit = maxiters, atol, rtol, beta
            )
        end
    else
        f, u,
            resid = NonlinearSolveBase.construct_extension_function_wrapper(
            prob; alias_u0, make_fixed_point = Val(method == :anderson)
        )
        N = length(u)
        FS = zeros_like(u, N)

        # Jacobian Free Newton Krylov
        if linsolve !== nothing
            # Allocate ahead for Krylov basis
            JVS = linsolve == :gmres ? zeros_like(u, N, 3) : zeros_like(u, N)
            linsolve_alg = String(linsolve)
            if method == :newton
                sol = nsoli(
                    f, u, FS, JVS; lsolver = linsolve_alg,
                    maxit = maxiters, atol, rtol, printerr
                )
            elseif method == :pseudotransient
                sol = ptcsoli(
                    f, u, FS, JVS; lsolver = linsolve_alg,
                    maxit = maxiters, atol, rtol, printerr
                )
            end
        else
            # Anderson acceleration does not use a Jacobian — skip allocating FPS.
            if method == :anderson
                sol = aasol(
                    f, u, m, zeros(T, N, 2 * m + 4);
                    atol, rtol, maxit = maxiters, beta
                )
            elseif prob.f.jac === nothing && alg.autodiff === missing
                FPS = zeros_like(u, N, N)
                if method == :newton
                    sol = nsol(
                        f, u, FS, FPS; sham = 1, atol, rtol, maxit = maxiters, printerr
                    )
                elseif method == :pseudotransient
                    sol = ptcsol(
                        f, u, FS, FPS;
                        atol, rtol, maxit = maxiters, delta0 = delta, printerr
                    )
                end
            else
                autodiff = alg.autodiff === missing ? nothing : alg.autodiff
                FPS = prob.f.jac_prototype !== nothing ? zero(prob.f.jac_prototype) :
                    zeros_like(u, N, N)
                jac = NonlinearSolveBase.construct_extension_jac(
                    prob, alg, u, resid; autodiff
                )
                AJ! = @closure (J, u, x) -> jac(J, x)
                if method == :newton
                    sol = nsol(
                        f, u, FS, FPS, AJ!; sham = 1, atol,
                        rtol, maxit = maxiters, printerr
                    )
                elseif method == :pseudotransient
                    sol = ptcsol(
                        f, u, FS, FPS, AJ!; atol, rtol, maxit = maxiters,
                        delta0 = delta, printerr
                    )
                end
            end
        end
    end

    retcode = siamfanlequations_retcode_mapping(sol)
    stats = siamfanlequations_stats_mapping(method, sol)
    res = prob.u0 isa Number && method === :anderson ? sol.solution[1] : sol.solution
    resid = NonlinearSolveBase.Utils.evaluate_f(prob, res)
    return SciMLBase.build_solution(prob, alg, res, resid; retcode, stats, original = sol)
end

end

## TODO: In the long run we want to use an `Assumptions` API like LinearSolve to specify
##       the conditioning of the Jacobian and such

## TODO: Currently some of the algorithms like LineSearches / TrustRegion don't support
##       complex numbers. We should use the `DiffEqBase` trait for this once all of the
##       NonlinearSolve algorithms support it. For now we just do a check and remove the
##       unsupported ones from default

## Defaults to a fast and robust poly algorithm in most cases. If the user went through
## the trouble of specifying a custom jacobian function, we should use algorithms that
## can use that!
function SciMLBase.__init(prob::NonlinearProblem, ::Nothing, args...; kwargs...)
    must_use_jacobian = Val(SciMLBase.has_jac(prob.f))
    return SciMLBase.__init(
        prob,
        FastShortcutNonlinearPolyalg(
            eltype(prob.u0); must_use_jacobian, u0_len = length(prob.u0)
        ),
        args...;
        kwargs...
    )
end

function SciMLBase.__solve(prob::NonlinearProblem, ::Nothing, args...; kwargs...)
    must_use_jacobian = Val(SciMLBase.has_jac(prob.f))
    prefer_simplenonlinearsolve = Val(prob.u0 isa StaticArray)
    return SciMLBase.__solve(
        prob,
        FastShortcutNonlinearPolyalg(
            eltype(prob.u0);
            must_use_jacobian,
            prefer_simplenonlinearsolve,
            u0_len = length(prob.u0)
        ),
        args...;
        kwargs...
    )
end

function SciMLBase.__init(prob::SciMLBase.AbstractSteadyStateProblem, ::Nothing, args...; kwargs...)
    # Convert SteadyStateProblem to NonlinearProblem and use its default
    nlprob = SciMLBase.NonlinearProblem(prob)
    return SciMLBase.__init(nlprob, nothing, args...; kwargs...)
end

function SciMLBase.__solve(prob::SciMLBase.AbstractSteadyStateProblem, ::Nothing, args...; kwargs...)
    # Convert SteadyStateProblem to NonlinearProblem and use its default
    nlprob = SciMLBase.NonlinearProblem(prob)
    return SciMLBase.__solve(nlprob, nothing, args...; kwargs...)
end

function NonlinearSolveBase.initialization_alg(::AbstractNonlinearProblem, autodiff)
    return FastShortcutNonlinearPolyalg(; autodiff)
end

@testitem "Nonlinear Verbosity" tags = [:verbosity] begin
    using NonlinearSolve
    using BracketingNonlinearSolve
    using NonlinearSolve: NonlinearVerbosity
    using LinearSolve: LinearVerbosity
    using SciMLLogging: SciMLLogging
    using Test

    @testset "NonlinearVerbosity preset constructors" begin
        v_none = NonlinearVerbosity(SciMLLogging.None())
        v_all = NonlinearVerbosity(SciMLLogging.All())
        v_minimal = NonlinearVerbosity(SciMLLogging.Minimal())
        v_standard = NonlinearVerbosity(SciMLLogging.Standard())
        v_detailed = NonlinearVerbosity(SciMLLogging.Detailed())

        @test v_none.non_enclosing_interval == SciMLLogging.Silent()
        @test v_none.threshold_state == SciMLLogging.Silent()
        @test v_none.alias_u0_immutable == SciMLLogging.Silent()
        @test v_none.sensitivity_vjp_choice == SciMLLogging.Silent()

        @test v_minimal.non_enclosing_interval == SciMLLogging.WarnLevel()
        @test v_minimal.alias_u0_immutable == SciMLLogging.Silent()
        @test v_minimal.termination_condition == SciMLLogging.Silent()
        @test v_minimal.sensitivity_vjp_choice == SciMLLogging.Silent()

        @test v_standard.non_enclosing_interval == SciMLLogging.WarnLevel()
        @test v_standard.threshold_state == SciMLLogging.WarnLevel()
        @test v_standard.sensitivity_vjp_choice == SciMLLogging.WarnLevel()

        @test v_detailed.alias_u0_immutable == SciMLLogging.WarnLevel()
        @test v_detailed.termination_condition == SciMLLogging.WarnLevel()
        @test v_detailed.sensitivity_vjp_choice == SciMLLogging.WarnLevel()

        @test v_all.linsolve_failed_noncurrent == SciMLLogging.WarnLevel()
        @test v_all.threshold_state == SciMLLogging.InfoLevel()
        @test v_all.sensitivity_vjp_choice == SciMLLogging.WarnLevel()
    end

    @testset "Group-level keyword constructors" begin
        v_error = NonlinearVerbosity(error_control = SciMLLogging.ErrorLevel())
        @test v_error.alias_u0_immutable == SciMLLogging.ErrorLevel()
        @test v_error.non_enclosing_interval == SciMLLogging.ErrorLevel()
        @test v_error.termination_condition == SciMLLogging.ErrorLevel()
        @test v_error.linsolve_failed_noncurrent == SciMLLogging.ErrorLevel()

        v_numerical = NonlinearVerbosity(numerical = SciMLLogging.Silent())
        @test v_numerical.threshold_state == SciMLLogging.Silent()

        v_sensitivity = NonlinearVerbosity(sensitivity = SciMLLogging.Silent())
        @test v_sensitivity.sensitivity_vjp_choice == SciMLLogging.Silent()

        v_sensitivity2 = NonlinearVerbosity(sensitivity = SciMLLogging.InfoLevel())
        @test v_sensitivity2.sensitivity_vjp_choice == SciMLLogging.InfoLevel()
    end

    @testset "Mixed group and individual settings" begin
        v_mixed = NonlinearVerbosity(
            numerical = SciMLLogging.Silent(),
            threshold_state = SciMLLogging.WarnLevel(),
            error_control = SciMLLogging.InfoLevel()
        )
        # Individual override should take precedence
        @test v_mixed.threshold_state == SciMLLogging.WarnLevel()
        # Error control group setting should apply
        @test v_mixed.alias_u0_immutable == SciMLLogging.InfoLevel()
        @test v_mixed.linsolve_failed_noncurrent == SciMLLogging.InfoLevel()
    end

    @testset "Individual keyword arguments" begin
        v_individual = NonlinearVerbosity(
            alias_u0_immutable = SciMLLogging.ErrorLevel(),
            threshold_state = SciMLLogging.InfoLevel(),
            termination_condition = SciMLLogging.Silent()
        )
        @test v_individual.alias_u0_immutable == SciMLLogging.ErrorLevel()
        @test v_individual.threshold_state == SciMLLogging.InfoLevel()
        @test v_individual.termination_condition == SciMLLogging.Silent()
        # Unspecified options should use defaults
        @test v_individual.non_enclosing_interval == SciMLLogging.WarnLevel()
        @test v_individual.linsolve_failed_noncurrent == SciMLLogging.WarnLevel()
    end

    g(u, p) = u^2 - 4

    int_prob = IntervalNonlinearProblem(g, (3.0, 5.0))

    @test_logs (
        :info,
        r"The interval is not an enclosing interval, opposite signs at the boundaries are required.",
    ) solve(
        int_prob,
        ITP(), verbose = NonlinearVerbosity(non_enclosing_interval = SciMLLogging.InfoLevel())
    )

    @test_logs (
        :error,
        r"The interval is not an enclosing interval, opposite signs at the boundaries are required.",
    ) @test_throws ErrorException solve(
        int_prob,
        ITP(), verbose = NonlinearVerbosity(non_enclosing_interval = SciMLLogging.ErrorLevel())
    )

    # Test that the linear verbosity is passed to the linear solve
    f(u, p) = [u[1]^2 - 2u[1] + 1, sum(u)]
    prob = NonlinearProblem(f, [1.0, 1.0])

    @test_logs (
        :warn,
        r"LU factorization failed, falling back to QR factorization. `A` is potentially rank-deficient.",
    ) match_mode = :any solve(
        prob,
        verbose = NonlinearVerbosity(linear_verbosity = SciMLLogging.Detailed())
    )

    @test_logs (
        :info,
        r"LU factorization failed, falling back to QR factorization. `A` is potentially rank-deficient.",
    ) match_mode = :any solve(
        prob,
        verbose = NonlinearVerbosity(linear_verbosity = LinearVerbosity(default_lu_fallback = SciMLLogging.InfoLevel()))
    )

    @test_logs min_level = 0 solve(
        prob,
        verbose = NonlinearVerbosity(linear_verbosity = SciMLLogging.Standard())
    )

    @test_logs (
        :warn,
        r"LU factorization failed, falling back to QR factorization. `A` is potentially rank-deficient.",
    ) match_mode = :any solve(
        prob,
        verbose = NonlinearVerbosity(linear_verbosity = SciMLLogging.Detailed())
    )

    @test_logs min_level = 0 solve(
        prob,
        verbose = NonlinearVerbosity(SciMLLogging.None())
    )

    @test_logs min_level = 0 solve(
        prob,
        verbose = false
    )

    # Test that caches get correct verbosities
    cache = init(
        prob, verbose = NonlinearVerbosity(threshold_state = SciMLLogging.InfoLevel())
    )

    @test cache.verbose.threshold_state == SciMLLogging.InfoLevel()

    f(u, p) = u .* u .- 2
    prob = NonlinearProblem(f, [1.0, 1.0])

    @testset "solve with Bool verbose" begin
        # Test verbose = true works (default verbosity)
        sol1 = solve(prob, verbose = true)
        @test sol1.retcode == ReturnCode.Success

        # Test verbose = false silences all output
        @test_logs min_level = 0 sol2 = solve(prob, verbose = false)
    end

    @testset "solve with Preset verbose" begin
        # Test verbose = SciMLLogging.Standard() works
        sol1 = solve(prob, verbose = SciMLLogging.Standard())
        @test sol1.retcode == ReturnCode.Success

        # Test verbose = SciMLLogging.None() silences output
        @test_logs min_level = 0 sol2 = solve(prob, verbose = SciMLLogging.None())

        # Test verbose = SciMLLogging.Detailed() works
        sol3 = solve(prob, verbose = SciMLLogging.Detailed())
        @test sol3.retcode == ReturnCode.Success

        # Test verbose = SciMLLogging.All() works
        sol4 = solve(prob, verbose = SciMLLogging.All())
        @test sol4.retcode == ReturnCode.Success

        # Test verbose = SciMLLogging.Minimal() works
        sol5 = solve(prob, verbose = SciMLLogging.Minimal())
        @test sol5.retcode == ReturnCode.Success
    end

    @testset "init with Bool verbose" begin
        # Test verbose = true converts to NonlinearVerbosity()
        cache1 = init(prob, verbose = true)
        @test cache1.verbose isa NonlinearVerbosity
        @test cache1.verbose.threshold_state == SciMLLogging.WarnLevel()

        # Test verbose = false converts to NonlinearVerbosity(None())
        cache2 = init(prob, verbose = false)
        @test cache2.verbose isa NonlinearVerbosity
        @test cache2.verbose.threshold_state == SciMLLogging.Silent()
        @test cache2.verbose.non_enclosing_interval == SciMLLogging.Silent()
    end

    @testset "init with Preset verbose" begin
        # Test verbose = SciMLLogging.Standard() converts to NonlinearVerbosity(Standard())
        cache1 = init(prob, verbose = SciMLLogging.Standard())
        @test cache1.verbose isa NonlinearVerbosity
        @test cache1.verbose.threshold_state == SciMLLogging.WarnLevel()

        # Test verbose = SciMLLogging.None() converts to NonlinearVerbosity(None())
        cache2 = init(prob, verbose = SciMLLogging.None())
        @test cache2.verbose isa NonlinearVerbosity
        @test cache2.verbose.threshold_state == SciMLLogging.Silent()

        # Test verbose = SciMLLogging.Detailed()
        cache3 = init(prob, verbose = SciMLLogging.Detailed())
        @test cache3.verbose isa NonlinearVerbosity
        @test cache3.verbose.linear_verbosity == SciMLLogging.Detailed()

        # Test verbose = SciMLLogging.All()
        cache4 = init(prob, verbose = SciMLLogging.All())
        @test cache4.verbose isa NonlinearVerbosity
        @test cache4.verbose.threshold_state == SciMLLogging.InfoLevel()

        # Test verbose = SciMLLogging.Minimal()
        cache5 = init(prob, verbose = SciMLLogging.Minimal())
        @test cache5.verbose isa NonlinearVerbosity
        @test cache5.verbose.alias_u0_immutable == SciMLLogging.Silent()
    end

    @testset "init then solve with converted verbose" begin
        # Ensure the converted verbose works through the full solve pipeline
        cache = init(prob, verbose = false)
        @test_logs min_level = 0 sol = solve!(cache)
    end

    @testset "NonlinearVerbosity with keyword message levels (issue #796)" begin
        # Regression test: constructing NonlinearVerbosity with keyword arguments
        # that are MessageLevel subtypes should not throw UndefVarError
        verb = NonlinearVerbosity(non_enclosing_interval = SciMLLogging.ErrorLevel())
        @test verb.non_enclosing_interval == SciMLLogging.ErrorLevel()

        # Test with the full solve pipeline from the issue MWE
        f_interval(x, p) = x^2 - p
        prob_interval = IntervalNonlinearProblem(f_interval, (1.0, 3.0), 4.0)
        sol = solve(prob_interval, verbose = verb)
        @test sol.retcode == ReturnCode.Success
    end
end

@testitem "Simple Scalar Problem" tags = [:wrappers] begin
    import SpeedMapping, SIAMFANLEquations, NLsolve, FixedPointAcceleration

    f1(x, p) = cos(x) - x
    prob = NonlinearProblem(f1, 1.1)

    for alg in (:Anderson, :MPE, :RRE, :VEA, :SEA, :Simple, :Aitken, :Newton)
        @test abs(solve(prob, FixedPointAccelerationJL(; algorithm = alg)).resid) ≤ 1.0e-10
    end

    @test abs(solve(prob, SpeedMappingJL()).resid) ≤ 1.0e-10
    @test abs(solve(prob, SpeedMappingJL(; orders = [3, 2])).resid) ≤ 1.0e-10
    @test abs(solve(prob, SpeedMappingJL(; stabilize = true)).resid) ≤ 1.0e-10

    @test abs(solve(prob, NLsolveJL(; method = :anderson)).resid) ≤ 1.0e-10
    @test abs(solve(prob, SIAMFANLEquationsJL(; method = :anderson)).resid) ≤ 1.0e-10
end

# Simple Vector Problem
@testitem "Simple Vector Problem" tags = [:wrappers] begin
    import SpeedMapping, SIAMFANLEquations, NLsolve, FixedPointAcceleration

    f2(x, p) = cos.(x) .- x
    prob = NonlinearProblem(f2, [1.1, 1.1])

    for alg in (:Anderson, :MPE, :RRE, :VEA, :SEA, :Simple, :Aitken, :Newton)
        @test maximum(abs.(solve(prob, FixedPointAccelerationJL()).resid)) ≤ 1.0e-10
    end

    @test maximum(abs.(solve(prob, SpeedMappingJL()).resid)) ≤ 1.0e-10
    @test maximum(abs.(solve(prob, SpeedMappingJL(; orders = [3, 2])).resid)) ≤ 1.0e-10
    @test maximum(abs.(solve(prob, SpeedMappingJL(; stabilize = true)).resid)) ≤ 1.0e-10
    @test maximum(abs.(solve(prob, SIAMFANLEquationsJL(; method = :anderson)).resid)) ≤
        1.0e-10

    @test_broken maximum(abs.(solve(prob, NLsolveJL(; method = :anderson)).resid)) ≤ 1.0e-10
end

# Fixed Point for Power Method
# Taken from https://github.com/NicolasL-S/SpeedMapping.jl/blob/95951db8f8a4457093090e18802ad382db1c76da/test/runtests.jl
@testitem "Power Method" tags = [:wrappers] begin
    using LinearAlgebra
    import SpeedMapping, SIAMFANLEquations, NLsolve, FixedPointAcceleration

    C = [1 2 3; 4 5 6; 7 8 9]
    A = C + C'
    B = Hermitian(ones(10) * ones(10)' .* im + Diagonal(1:10))

    function power_method!(du, u, A)
        mul!(du, A, u)
        du ./= norm(du, Inf)
        du .-= u  # Convert to a root finding problem
        return nothing
    end

    prob = NonlinearProblem(power_method!, ones(3), A)

    for alg in (:Anderson, :MPE, :RRE, :VEA, :SEA, :Simple, :Aitken, :Newton)
        sol = solve(prob, FixedPointAccelerationJL(; algorithm = alg))
        if SciMLBase.successful_retcode(sol)
            @test sol.u' * A[:, 3] ≈ 32.916472867168096
        else
            @warn "Power Method failed for FixedPointAccelerationJL(; algorithm = $alg)"
            @test_broken sol.u' * A[:, 3] ≈ 32.916472867168096
        end
    end

    for kwargs in ((;), (; orders = [3, 2]), (; stabilize = true))
        alg = SpeedMappingJL(; kwargs...)
        sol = solve(prob, alg)
        @test sol.u' * A[:, 3] ≈ 32.916472867168096
    end

    sol = solve(prob, NLsolveJL(; method = :anderson))
    @test_broken sol.u' * A[:, 3] ≈ 32.916472867168096

    sol = solve(prob, SIAMFANLEquationsJL(; method = :anderson))
    @test sol.u' * A[:, 3] ≈ 32.916472867168096

    # Non vector inputs
    function power_method_nonvec!(du, u, A)
        mul!(vec(du), A, vec(u))
        du ./= norm(du, Inf)
        du .-= u  # Convert to a root finding problem
        return nothing
    end

    prob = NonlinearProblem(power_method_nonvec!, ones(1, 3, 1), A)

    for alg in (:Anderson, :MPE, :RRE, :VEA, :SEA, :Simple, :Aitken, :Newton)
        sol = solve(prob, FixedPointAccelerationJL(; algorithm = alg))
        if SciMLBase.successful_retcode(sol)
            @test vec(sol.u)' * A[:, 3] ≈ 32.916472867168096
        else
            @warn "Power Method failed for FixedPointAccelerationJL(; algorithm = $alg)"
            @test_broken vec(sol.u)' * A[:, 3] ≈ 32.916472867168096
        end
    end

    for kwargs in ((;), (; orders = [3, 2]), (; stabilize = true))
        alg = SpeedMappingJL(; kwargs...)
        sol = solve(prob, alg)
        @test vec(sol.u)' * A[:, 3] ≈ 32.916472867168096
    end

    sol = solve(prob, NLsolveJL(; method = :anderson))
    @test_broken vec(sol.u)' * A[:, 3] ≈ 32.916472867168096
end

# Issue #862: NLsolveJL and SIAMFANLEquationsJL Anderson must NOT allocate a dense
# N×N Jacobian (Anderson acceleration is Jacobian-free).
@testitem "Anderson does not allocate dense Jacobian (#862)" tags = [:wrappers] begin
    import NLsolve, SIAMFANLEquations

    # N large enough that a dense N×N Float64 matrix would dominate the
    # measured allocation, but small enough to solve quickly.
    N = 3_200
    # Simple fixed point: f(x) = 0 at x_i = 0.739... (cos(x) = x).
    F!(F, x, p) = (F .= cos.(x) .- x)
    x0 = fill(0.5, N)
    prob = NonlinearProblem(NonlinearFunction(F!), x0)

    # Cap iterations so per-iteration allocations don't dwarf the one-shot
    # Jacobian allocation we're guarding against.
    maxit = 10

    # Warm up compilation
    solve(prob, NLsolveJL(; method = :anderson, m = 5); maxiters = maxit)
    solve(prob, SIAMFANLEquationsJL(; method = :anderson, m = 5); maxiters = maxit)

    # An N×N Float64 matrix is 8·N² bytes ≈ 82 MB at N=3200.
    dense_jac_bytes = 8 * N * N

    allocs_nlsolve = @allocated solve(
        prob, NLsolveJL(; method = :anderson, m = 5); maxiters = maxit
    )
    @test allocs_nlsolve < dense_jac_bytes ÷ 4

    allocs_siam = @allocated solve(
        prob, SIAMFANLEquationsJL(; method = :anderson, m = 5); maxiters = maxit
    )
    @test allocs_siam < dense_jac_bytes ÷ 4
end

# Internal Algorithm Helpers

## Pseudo Transient Method

```@docs
NonlinearSolveFirstOrder.SwitchedEvolutionRelaxation
NonlinearSolveFirstOrder.SwitchedEvolutionRelaxationCache
```

## Approximate Jacobian Methods

### Initialization

```@docs
NonlinearSolveQuasiNewton.IdentityInitialization
NonlinearSolveQuasiNewton.TrueJacobianInitialization
NonlinearSolveQuasiNewton.BroydenLowRankInitialization
```

### Jacobian Structure

```@docs
NonlinearSolveQuasiNewton.FullStructure
NonlinearSolveQuasiNewton.DiagonalStructure
```

### Jacobian Caches

```@docs
NonlinearSolveQuasiNewton.InitializedApproximateJacobianCache
```

### Reset Methods

```@docs
NonlinearSolveQuasiNewton.NoChangeInStateReset
NonlinearSolveQuasiNewton.IllConditionedJacobianReset
```

### Update Rules

```@docs
NonlinearSolveQuasiNewton.GoodBroydenUpdateRule
NonlinearSolveQuasiNewton.BadBroydenUpdateRule
NonlinearSolveQuasiNewton.KlementUpdateRule
```

## Levenberg Marquardt Method

```@docs
NonlinearSolveFirstOrder.LevenbergMarquardtTrustRegion
```

## Trust Region Method

```@docs
NonlinearSolveFirstOrder.GenericTrustRegionScheme
```

## Miscellaneous

```@docs
NonlinearSolveBase.callback_into_cache!
NonlinearSolveBase.concrete_jac
```

# NLSolvers.jl

This is a extension for importing solvers from NLSolvers.jl into the SciML interface. Note
that these solvers do not come by default, and thus one needs to install the package before
using these solvers:

```julia
import Pkg
Pkg.add("NLSolvers")
import NLSolvers
import NonlinearSolve as NLS
```

## Solver API

```@docs
NLSolversJL
```

# SimpleNonlinearSolve.jl

These methods can be used independently of the rest of NonlinearSolve.jl

```@index
Pages = ["simplenonlinearsolve.md"]
```

## General Methods

These methods are suited for any general nonlinear root-finding problem, i.e.
`NonlinearProblem`.

| Solver                               | In-place | Out of Place | Non-Allocating (Scalars) | Non-Allocating (`SArray`) |
|:------------------------------------ |:-------- |:------------ |:------------------------ |:------------------------- |
| [`SimpleNewtonRaphson`](@ref)        | ✔️       | ✔️           | ✔️                       | ✔️                        |
| [`SimpleBroyden`](@ref)              | ✔️       | ✔️           | ✔️                       | ✔️                        |
| [`SimpleHalley`](@ref)               | ❌        | ✔️           | ✔️                       | ❌                         |
| [`SimpleKlement`](@ref)              | ✔️       | ✔️           | ✔️                       | ✔️                        |
| [`SimpleTrustRegion`](@ref)          | ✔️       | ✔️           | ✔️                       | ✔️                        |
| [`SimpleDFSane`](@ref)               | ✔️       | ✔️           | ✔️[^1]                   | ✔️                        |
| [`SimpleLimitedMemoryBroyden`](@ref) | ✔️       | ✔️           | ✔️                       | ✔️[^2]                    |

The algorithms which are non-allocating can be used directly inside GPU Kernels[^3].
See [ParallelParticleSwarms.jl](https://github.com/SciML/ParallelParticleSwarms.jl) for more details.

```@docs
SimpleNewtonRaphson
SimpleBroyden
SimpleHalley
SimpleKlement
SimpleTrustRegion
SimpleDFSane
SimpleLimitedMemoryBroyden
```

`SimpleGaussNewton` is aliased to [`SimpleNewtonRaphson`](@ref) for solving Nonlinear Least
Squares problems.

[^1]: Needs [`StaticArrays.jl`](https://github.com/JuliaArrays/StaticArrays.jl) to be
    installed and loaded for the non-allocating version.
[^2]: This method is non-allocating if the termination condition is set to either `nothing`
    (default) or [`NonlinearSolveBase.AbsNormTerminationMode`](@ref).
[^3]: Only the defaults are guaranteed to work inside kernels. We try to provide warnings
    if the used version is not non-allocating.

# Nonlinear Least Squares Solvers

```julia
solve(prob::NonlinearLeastSquaresProblem, alg; kwargs...)
```

Solves the nonlinear least squares problem defined by `prob` using the algorithm
`alg`. If no algorithm is given, a default algorithm will be chosen.

## Recommended Methods

The default method [`FastShortcutNLLSPolyalg`](@ref) is a good choice for most problems. It
is a polyalgorithm that attempts to use a fast algorithm ([`GaussNewton`](@ref)) and if that
fails it falls back to a more robust algorithms ([`LevenbergMarquardt`](@ref),
[`TrustRegion`](@ref)).

## Full List of Methods

### NonlinearSolve.jl

  - [`LevenbergMarquardt()`](@ref): An advanced Levenberg-Marquardt implementation with the
    improvements suggested in the [transtrum2012improvements](@citet). Designed for
    large-scale and numerically-difficult nonlinear systems.
  - [`GaussNewton()`](@ref): A Gauss-Newton method with swappable nonlinear solvers and
    autodiff methods for high performance on large and sparse systems.
  - [`TrustRegion()`](@ref): A Newton Trust Region dogleg method with swappable nonlinear
    solvers and autodiff methods for high performance on large and sparse systems.

### SimpleNonlinearSolve.jl

These methods are included with NonlinearSolve.jl by default, though SimpleNonlinearSolve.jl
can be used  directly to reduce dependencies and improve load times.
SimpleNonlinearSolve.jl's methods excel at small problems and problems defined with static
arrays.

  - `SimpleGaussNewton()`: Simple Gauss Newton implementation using QR factorizations for
    numerical stability (aliased to [`SimpleNewtonRaphson`](@ref)).

### [FastLevenbergMarquardt.jl](@id fastlm_wrapper_summary)

A wrapper over
[FastLevenbergMarquardt.jl](https://github.com/kamesy/FastLevenbergMarquardt.jl). Note that
it is called `FastLevenbergMarquardt` since the original package is called "Fast", though
benchmarks demonstrate [`LevenbergMarquardt()`](@ref) usually outperforms.

  - [`FastLevenbergMarquardtJL(linsolve = :cholesky)`](@ref), can also choose
    `linsolve = :qr`.

### [LeastSquaresOptim.jl](@id lso_wrapper_summary)

A wrapper over
[LeastSquaresOptim.jl](https://github.com/matthieugomez/LeastSquaresOptim.jl). Has a core
algorithm [`LeastSquaresOptimJL(alg; linsolve)`](@ref) where the choices for `alg` are:

  - `:lm` a Levenberg-Marquardt implementation
  - `:dogleg` a trust-region dogleg Gauss-Newton

And the choices for `linsolve` are:

  - `:qr`
  - `:cholesky`
  - `:lsmr` a conjugate gradient method (LSMR with diagonal preconditioner).

### MINPACK.jl

MINPACK.jl methods are fine for medium-sized nonlinear solves. They are the FORTRAN
standard methods which are used in many places, such as SciPy. However, our benchmarks
demonstrate that these methods are not robust or stable. In addition, they are slower
than the standard methods and do not scale due to lack of sparse Jacobian support.
Thus they are only recommended for benchmarking and testing code conversions.

  - [`CMINPACK()`](@ref): A wrapper for using the classic MINPACK method through
    [MINPACK.jl](https://github.com/sglyon/MINPACK.jl)

Submethod choices for this algorithm include:

  - `:hybr`: Modified version of Powell's algorithm.
  - `:lm`: Levenberg-Marquardt.
  - `:lmdif`: Advanced Levenberg-Marquardt
  - `:hybrd`: Advanced modified version of Powell's algorithm

### SciPy (Python via PythonCall)

A wrapper over `scipy.optimize.least_squares`.  Requires that the Python
package `scipy` is available to PythonCall.

  - [`SciPyLeastSquares()`](@ref) with convenience constructors
    `SciPyLeastSquaresTRF()`, `SciPyLeastSquaresDogbox()`, and
    `SciPyLeastSquaresLM()` for the common method choices.

### Optimization.jl

`NonlinearLeastSquaresProblem`s can be converted into an `OptimizationProblem`  and used
with any solver of [Optimization.jl](https://github.com/SciML/Optimization.jl).

# [Nonlinear Problems](@id problems)

## The Four Types of Nonlinear Problems

NonlinearSolve.jl tackles four related types of nonlinear systems:

 1. Interval rootfinding problems. I.e., find the ``t \in [t_0, t_f]`` such that
    ``f(t) = 0``.
 2. Systems of nonlinear equations, i.e., find the ``u`` such that ``f(u) = 0``.
 3. Steady state problems, i.e., find the ``u`` such that ``u' = f(u,t)`` has reached steady
    state, i.e., ``0 = f(u, ∞)``.
 4. The nonlinear least squares problem, which is an under/over-constrained nonlinear system
    which might not be satisfiable, i.e. there may be no ``u`` such that ``f(u) = 0``, and thus
    we find the ``u`` which minimizes ``\|f(u)\|_2^2`` in the least squares sense.

The first is for solving scalar rootfinding problems, i.e., finding a single number, and
requires that a bracketing interval is known. For a bracketing interval, one must have that
the sign of ``f(t_0)`` is opposite the sign of ``f(t_f)``, thus guaranteeing a root in the
interval.

!!! note
    Interval rootfinding problems allow for ``f`` to return an array, in which case the
    interval rootfinding problem is interpreted as finding the first ``t`` such that any of
    the components of the array hit zero.

The second type of nonlinear system can be multidimensional, and thus no ordering nor
boundaries are assumed to be known. For a system of nonlinear equations, ``f`` can return
an array, and the solver seeks the value of ``u`` for which all outputs of ``f`` are
simultaneously zero.

The third type is equivalent to a nonlinear system, but with the extra interpretation of
having a potentially preferred unique root. That is, when there are multiple `u` such
that ``f(u) = 0``, the `NonlinearProblem` does not have a preferred solution, while for the
`SteadyStateProblem` the preferred solution is the ``u(∞)`` that would arise from solving the
ODE ``u' = f(u,t)``.

The fourth type is an overdetermined nonlinear system, which has more constraints than free
variables, and thus is usually not possible to solve exactly. In these contexts, it is usually
convenient to minimize the Euclidean norm, as it is continuously differentiable if the
original function is.

!!! warning

    Most solvers for `SteadyStateProblem` do not guarantee the preferred solution and
    instead will solve for some `u` in the set of solutions. The documentation of the
    nonlinear solvers will note if they return the preferred solution.

## Problem Construction Details

```@docs
IntervalNonlinearProblem
NonlinearProblem
SteadyStateProblem
NonlinearLeastSquaresProblem
```

# LeastSquaresOptim.jl

This is an extension for importing solvers from LeastSquaresOptim.jl into the SciML
interface. Note that these solvers do not come by default, and thus one needs to install
the package before using these solvers:

```julia
import Pkg
Pkg.add("LeastSquaresOptim")
import LeastSquaresOptim
import NonlinearSolve as NLS
```

## Solver API

```@docs
LeastSquaresOptimJL
```

# Solving Nonlinear Problems with Bound Constraints

Many real-world problems have physical constraints on the parameters — concentrations must
be positive, probabilities must lie in $$[0, 1]$$, and so on. NonlinearSolve.jl supports
**box constraints** (lower and upper bounds on each variable) for both `NonlinearProblem`
and `NonlinearLeastSquaresProblem`.

## How It Works

When you pass `lb` and/or `ub` to a problem, NonlinearSolve checks whether the chosen
algorithm natively supports bounds. If it does not, the solver automatically applies a
**variable transformation** that maps the bounded variables into unconstrained space using
the logistic/logit functions. After solving, the solution is mapped back to the original
bounded space. This means you can use any algorithm — `NewtonRaphson`, `TrustRegion`,
`LevenbergMarquardt`, etc. — with bounds, without changing anything about your solver setup.

## Basic Example: Nonlinear System with Bounds

Let's solve a simple nonlinear system $$f(u) = u^2 - p$$ where we constrain the solution
to be positive:

```@example bounds
import NonlinearSolve as NLS

f(u, p) = u .* u .- p
u0 = [1.0, 1.0]
p = [2.0, 3.0]

prob = NLS.NonlinearProblem(f, u0, p; lb = [0.0, 0.0], ub = [10.0, 10.0])
sol = NLS.solve(prob, NLS.NewtonRaphson())
```

We can verify the solution satisfies the bounds:

```@example bounds
all(0.0 .<= sol.u .<= 10.0)
```

## Curve Fitting with Bounded Parameters

A common use case is nonlinear least squares curve fitting where parameters have physical
meaning and known ranges. Here we fit the model $$y = a \cdot e^{b x}$$ to data,
constraining the amplitude $$a > 0$$ and the decay rate $$b < 0$$:

```@example bounds
import NonlinearSolve as NLS

true_a, true_b = 2.0, -0.5
x = collect(range(0.0, 3.0; length = 20))
y = true_a .* exp.(true_b .* x)

model(u, p) = u[1] .* exp.(u[2] .* p) .- y
nf = NLS.NonlinearFunction(model; resid_prototype = zeros(20))

u0 = [1.0, -1.0]
prob = NLS.NonlinearLeastSquaresProblem(nf, u0, x; lb = [0.0, -2.0], ub = [5.0, 0.0])
sol = NLS.solve(prob, NLS.LevenbergMarquardt())
```

The fitted parameters should be close to the true values:

```@example bounds
sol.u
```

And they respect the bounds:

```@example bounds
all(sol.u .>= [0.0, -2.0]) && all(sol.u .<= [5.0, 0.0])
```

### When Bounds Actively Constrain the Solution

If the unconstrained optimum lies outside the feasible region, the solver finds the best
solution within the bounds:

```@example bounds
prob_tight = NLS.NonlinearLeastSquaresProblem(
    nf, u0, x; lb = [3.0, -2.0], ub = [5.0, -0.1]
)
sol_tight = NLS.solve(prob_tight, NLS.LevenbergMarquardt())
sol_tight.u
```

The true amplitude is 2.0, but the lower bound forces it to 3.0 or above:

```@example bounds
sol_tight.u[1] >= 3.0
```

## One-Sided Bounds

You don't need to specify both a lower and an upper bound. Use `-Inf` or `Inf` entries to
leave a direction unconstrained, or pass only `lb` or only `ub`:

```@example bounds
import NonlinearSolve as NLS

f(u, p) = u .- p
nf = NLS.NonlinearFunction(f; resid_prototype = zeros(2))

u0 = [5.0, 5.0]
p = [1.0, 2.0]

# Lower bound only — keep parameters positive
prob_lb = NLS.NonlinearLeastSquaresProblem(nf, u0, p; lb = [0.0, 0.0])
sol_lb = NLS.solve(prob_lb, NLS.LevenbergMarquardt())
sol_lb.u
```

```@example bounds
# Per-variable: first variable unbounded below, second bounded below at 0
prob_mixed = NLS.NonlinearLeastSquaresProblem(nf, u0, p; lb = [-Inf, 0.0])
sol_mixed = NLS.solve(prob_mixed, NLS.LevenbergMarquardt())
sol_mixed.u
```

## In-Place Formulation

Bounds work the same way with in-place problem formulations:

```@example bounds
import NonlinearSolve as NLS

function f_ip!(resid, u, p)
    resid .= u .- p
    return nothing
end

nf = NLS.NonlinearFunction(f_ip!)
prob = NLS.NonlinearLeastSquaresProblem(nf, [5.0, 5.0], [1.0, 2.0];
    lb = [0.0, 0.0], ub = [10.0, 10.0])

sol = NLS.solve(prob, NLS.LevenbergMarquardt())
sol.u
```

The original problem (with bounds) is preserved in the solution object:

```@example bounds
sol.prob.lb, sol.prob.ub
```

## Notes

  - **Any algorithm works.** Algorithms that natively support bounds use their own handling;
    algorithms that don't get automatic variable transformation.
  - **The transformation.** For two-sided bounds $$[\ell, u]$$, the transform is
    $$t = \text{logit}\!\left(\frac{x - \ell}{u - \ell}\right)$$ with inverse
    $$x = \ell + (u - \ell)\,\sigma(t)$$ where $$\sigma$$ is the logistic function. For
    one-sided bounds, a simple $$\log$$/$$\exp$$ transform is used.
  - **Initial guess.** If `u0` is exactly on a bound, it is automatically nudged into the
    strict interior to avoid numerical issues.

# [Efficiently Solving Large Sparse Ill-Conditioned Nonlinear Systems in Julia](@id large_systems)

This tutorial is for getting into the extra features of using NonlinearSolve.jl. Solving
ill-conditioned nonlinear systems requires specializing the linear solver on properties of
the Jacobian in order to cut down on the ``\mathcal{O}(n^3)`` linear solve and the
``\mathcal{O}(n^2)`` back-solves. This tutorial is designed to explain the advanced usage of
NonlinearSolve.jl by solving the steady state stiff Brusselator partial differential
equation (BRUSS) using NonlinearSolve.jl.

## Definition of the Brusselator Equation

!!! note

    Feel free to skip this section: it simply defines the example problem.

The Brusselator PDE is defined as follows:

```math
\begin{align}
0 &= 1 + u^2v - 4.4u + \alpha\left(\frac{\partial^2 u}{\partial x^2} + \frac{\partial^2 u}{\partial y^2}\right) + f(x, y, t)\\
0 &= 3.4u - u^2v + \alpha\left(\frac{\partial^2 v}{\partial x^2} + \frac{\partial^2 v}{\partial y^2}\right)
\end{align}
```

where

```math
f(x, y, t) = \begin{cases}
5 & \quad \text{if } (x-0.3)^2+(y-0.6)^2 ≤ 0.1^2 \text{ and } t ≥ 1.1 \\
0 & \quad \text{else}
\end{cases}
```

and the initial conditions are

```math
\begin{align}
u(x, y, 0) &= 22\cdot (y(1-y))^{3/2} \\
v(x, y, 0) &= 27\cdot (x(1-x))^{3/2}
\end{align}
```

with the periodic boundary condition

```math
\begin{align}
u(x+1,y,t) &= u(x,y,t) \\
u(x,y+1,t) &= u(x,y,t)
\end{align}
```

To solve this PDE, we will discretize it into a system of ODEs with the finite difference
method. We discretize `u` and `v` into arrays of the values at each time point:
`u[i,j] = u(i*dx,j*dy)` for some choice of `dx`/`dy`, and same for `v`. Then our ODE is
defined with `U[i,j,k] = [u v]`. The second derivative operator, the Laplacian, discretizes
to become a tridiagonal matrix with `[1 -2 1]` and a `1` in the top right and bottom left
corners. The nonlinear functions are then applied at each point in space (they are
broadcast). Use `dx=dy=1/32`.

The resulting `NonlinearProblem` definition is:

```@example ill_conditioned_nlprob
import NonlinearSolve as NLS
import LinearAlgebra
import SparseArrays
import LinearSolve as LS
import ADTypes

const N = 32
const xyd_brusselator = range(0, stop = 1, length = N)

brusselator_f(x, y) = (((x - 0.3)^2 + (y - 0.6)^2) <= 0.1^2) * 5.0
limit(a, N) = a == N + 1 ? 1 : a == 0 ? N : a

function brusselator_2d_loop(du, u, p)
    A, B, alpha, dx = p
    alpha = alpha / dx^2
    @inbounds for I in CartesianIndices((N, N))
        i, j = Tuple(I)
        x, y = xyd_brusselator[I[1]], xyd_brusselator[I[2]]
        ip1, im1, jp1,
        jm1 = limit(i + 1, N), limit(i - 1, N), limit(j + 1, N),
        limit(j - 1, N)
        du[i, j, 1] = alpha * (u[im1, j, 1] + u[ip1, j, 1] + u[i, jp1, 1] + u[i, jm1, 1] -
                       4u[i, j, 1]) +
                      B +
                      u[i, j, 1]^2 * u[i, j, 2] - (A + 1) * u[i, j, 1] + brusselator_f(x, y)
        du[i, j, 2] = alpha * (u[im1, j, 2] + u[ip1, j, 2] + u[i, jp1, 2] + u[i, jm1, 2] -
                       4u[i, j, 2]) + A * u[i, j, 1] - u[i, j, 1]^2 * u[i, j, 2]
    end
end
p = (3.4, 1.0, 10.0, step(xyd_brusselator))

function init_brusselator_2d(xyd)
    N = length(xyd)
    u = zeros(N, N, 2)
    for I in CartesianIndices((N, N))
        x = xyd[I[1]]
        y = xyd[I[2]]
        u[I, 1] = 22 * (y * (1 - y))^(3 / 2)
        u[I, 2] = 27 * (x * (1 - x))^(3 / 2)
    end
    u
end

u0 = init_brusselator_2d(xyd_brusselator)
prob_brusselator_2d = NLS.NonlinearProblem(
    brusselator_2d_loop, u0, p; abstol = 1e-10, reltol = 1e-10
)
```

## Choosing Jacobian Types

When we are solving this nonlinear problem, the Jacobian must be built at many iterations,
and this can be one of the most expensive steps. There are two pieces that must be optimized
in order to reach maximal efficiency when solving stiff equations: the sparsity pattern and
the construction of the Jacobian. The construction is filling the matrix `J` with values,
while the sparsity pattern is what `J` to use.

The sparsity pattern is given by a prototype matrix, the `jac_prototype`, which will be
copied to be used as `J`. The default is for `J` to be a `Matrix`, i.e. a dense matrix.
However, if you know the sparsity of your problem, then you can pass a different matrix
type. For example, a `SparseMatrixCSC` will give a sparse matrix. Other sparse matrix types
include:

- Bidiagonal
- Tridiagonal
- SymTridiagonal
- BandedMatrix ([BandedMatrices.jl](https://github.com/JuliaLinearAlgebra/BandedMatrices.jl))
- BlockBandedMatrix ([BlockBandedMatrices.jl](https://github.com/JuliaLinearAlgebra/BlockBandedMatrices.jl))

## Approximate Sparsity Detection & Sparse Jacobians

In the next section, we will show how to specify `sparsity` to trigger automatic sparsity
detection.

```@example ill_conditioned_nlprob
import BenchmarkTools: @btime # for @btime

@btime NLS.solve(prob_brusselator_2d, NLS.NewtonRaphson());
nothing # hide
```

```@example ill_conditioned_nlprob
import SparseConnectivityTracer, SparseMatrixColorings

prob_brusselator_2d_autosparse = NLS.NonlinearProblem(
    NLS.NonlinearFunction(brusselator_2d_loop; sparsity = SparseConnectivityTracer.TracerSparsityDetector()),
    u0, p; abstol = 1e-10, reltol = 1e-10
)

@btime NLS.solve(prob_brusselator_2d_autosparse,
    NLS.NewtonRaphson(; autodiff = ADTypes.AutoForwardDiff(; chunksize = 12)));
@btime NLS.solve(prob_brusselator_2d_autosparse,
    NLS.NewtonRaphson(; autodiff = ADTypes.AutoForwardDiff(; chunksize = 12),
        linsolve = LS.KLUFactorization()));
@btime NLS.solve(prob_brusselator_2d_autosparse,
    NLS.NewtonRaphson(; autodiff = ADTypes.AutoForwardDiff(; chunksize = 12),
        linsolve = LS.KrylovJL_GMRES()));
nothing # hide
```

## Declaring a Sparse Jacobian with Automatic Sparsity Detection

Jacobian sparsity is declared by the `jac_prototype` argument in the `NonlinearFunction`.
Note that you should only do this if the sparsity is high, for example, 0.1% of the matrix
is non-zeros, otherwise the overhead of sparse matrices can be higher than the gains from
sparse differentiation!

One of the useful companion tools for NonlinearSolve.jl is
[ADTypes.jl](https://github.com/SciML/ADTypes.jl) that specifies the interface for sparsity
detection via [`jacobian_sparsity`](@extref ADTypes.jacobian_sparsity). This allows for
automatic declaration of Jacobian sparsity types. To see this in action, we can give an
example `du` and `u` and call `jacobian_sparsity` on our function with the example
arguments, and it will kick out a sparse matrix with our pattern, that we can turn into our
`jac_prototype`.

!!! tip

    External packages like `SparseConnectivityTracer.jl` and `Symbolics.jl` provide the
    actual implementation of sparsity detection.

```@example ill_conditioned_nlprob
import SparseConnectivityTracer
import ADTypes

f! = (du, u) -> brusselator_2d_loop(du, u, p)
du0 = similar(u0)
jac_sparsity = ADTypes.jacobian_sparsity(f!, du0, u0, SparseConnectivityTracer.TracerSparsityDetector())
```

Notice that Julia gives a nice print out of the sparsity pattern. That's neat, and would be
tedious to build by hand! Now we just pass it to the `NonlinearFunction` like as before:

```@example ill_conditioned_nlprob
ff = NLS.NonlinearFunction(brusselator_2d_loop; jac_prototype = jac_sparsity)
```

Build the `NonlinearProblem`:

```@example ill_conditioned_nlprob
prob_brusselator_2d_sparse = NLS.NonlinearProblem(ff, u0, p; abstol = 1e-10, reltol = 1e-10)
```

Now let's see how the version with sparsity compares to the version without:

```@example ill_conditioned_nlprob
@btime NLS.solve(prob_brusselator_2d, NLS.NewtonRaphson());
@btime NLS.solve(prob_brusselator_2d_sparse, NLS.NewtonRaphson());
@btime NLS.solve(prob_brusselator_2d_sparse, NLS.NewtonRaphson(linsolve = LS.KLUFactorization()));
nothing # hide
```

Note that depending on the properties of the sparsity pattern, one may want to try
alternative linear solvers such as `NLS.NewtonRaphson(linsolve = LS.KLUFactorization())`
or `NLS.NewtonRaphson(linsolve = LS.UMFPACKFactorization())`

## Using Jacobian-Free Newton-Krylov

A completely different way to optimize the linear solvers for large sparse matrices is to
use a Krylov subspace method. This requires choosing a linear solver for changing to a
Krylov method. To swap the linear solver out, we use the `linsolve` command and choose the
GMRES linear solver.

```@example ill_conditioned_nlprob
@btime NLS.solve(prob_brusselator_2d, NLS.NewtonRaphson(linsolve = LS.KrylovJL_GMRES()));
nothing # hide
```

Notice that this acceleration does not require the definition of a sparsity pattern, and can
thus be an easier way to scale for large problems. For more information on linear solver
choices, see the
[linear solver documentation](https://docs.sciml.ai/DiffEqDocs/stable/features/linear_nonlinear/#linear_nonlinear).
`linsolve` choices are any valid [LinearSolve.jl](https://docs.sciml.ai/LinearSolve/dev/) solver.

!!! note

    Switching to a Krylov linear solver will automatically change the nonlinear problem
    solver into Jacobian-free mode, dramatically reducing the memory required. This can be
    overridden by adding `concrete_jac=true` to the algorithm.

## Adding a Preconditioner

Any [LinearSolve.jl-compatible preconditioner](https://docs.sciml.ai/LinearSolve/stable/basics/Preconditioners/)
can be used as a preconditioner in the linear solver interface. To define preconditioners,
one must define a `precs` function in compatible with linear solvers which returns the
left and right preconditioners, matrices which approximate the inverse of `W = I - gamma*J`
used in the solution of the ODE. An example of this with using
[IncompleteLU.jl](https://github.com/haampie/IncompleteLU.jl) is as follows:

```julia
# FIXME: On 1.10+ this is broken. Skipping this for now.
import IncompleteLU

incompletelu(W, p = nothing) = IncompleteLU.ilu(W, τ = 50.0), LinearAlgebra.I

@btime NLS.solve(prob_brusselator_2d_sparse,
    NLS.NewtonRaphson(linsolve = LS.KrylovJL_GMRES(precs = incompletelu), concrete_jac = true)
);
nothing # hide
```

Notice a few things about this preconditioner. This preconditioner uses the sparse Jacobian,
and thus we set `concrete_jac = true` to tell the algorithm to generate the Jacobian
(otherwise, a Jacobian-free algorithm is used with GMRES by default).

We use `convert(AbstractMatrix,W)` to get the concrete `W` matrix (matching `jac_prototype`,
thus `SpraseMatrixCSC`) which we can use in the preconditioner's definition. Then we use
`IncompleteLU.ilu` on that sparse matrix to generate the preconditioner. We return
`Pl, nothing` to say that our preconditioner is a left preconditioner, and that there is no
right preconditioning.

This method thus uses both the Krylov solver and the sparse Jacobian. Not only that, it is
faster than both implementations! IncompleteLU is fussy in that it requires a well-tuned `τ`
parameter. Another option is to use
[AlgebraicMultigrid.jl](https://github.com/JuliaLinearAlgebra/AlgebraicMultigrid.jl)
which is more automatic. The setup is very similar to before:

```@example ill_conditioned_nlprob
import AlgebraicMultigrid

function algebraicmultigrid(W, p = nothing)
    return AlgebraicMultigrid.aspreconditioner(AlgebraicMultigrid.ruge_stuben(convert(AbstractMatrix, W))),
    LinearAlgebra.I
end

@btime NLS.solve(prob_brusselator_2d_sparse,
    NLS.NewtonRaphson(
        linsolve = LS.KrylovJL_GMRES(; precs = algebraicmultigrid), concrete_jac = true
    )
);
nothing # hide
```

or with a Jacobi smoother:

```@example ill_conditioned_nlprob
function algebraicmultigrid2(W, p = nothing)
    A = convert(AbstractMatrix, W)
    Pl = AlgebraicMultigrid.aspreconditioner(AlgebraicMultigrid.ruge_stuben(
        A, presmoother = AlgebraicMultigrid.Jacobi(rand(size(A, 1))),
        postsmoother = AlgebraicMultigrid.Jacobi(rand(size(A, 1)))
    ))
    return Pl, LinearAlgebra.I
end

@btime NLS.solve(
    prob_brusselator_2d_sparse,
    NLS.NewtonRaphson(
        linsolve = LS.KrylovJL_GMRES(precs = algebraicmultigrid2), concrete_jac = true
    )
);
nothing # hide
```

## Let's compare the Sparsity Detection Methods

We benchmarked the solvers before with approximate and exact sparsity detection. However,
for the exact sparsity detection case, we left out the time it takes to perform exact
sparsity detection. Let's compare the two by setting the sparsity detection algorithms.

```@example ill_conditioned_nlprob
import DifferentiationInterface
import SparseConnectivityTracer

prob_brusselator_2d_exact_tracer = NLS.NonlinearProblem(
    NLS.NonlinearFunction(brusselator_2d_loop; sparsity = SparseConnectivityTracer.TracerSparsityDetector()),
    u0, p; abstol = 1e-10, reltol = 1e-10)
prob_brusselator_2d_approx_di = NLS.NonlinearProblem(
    NLS.NonlinearFunction(brusselator_2d_loop;
        sparsity = DifferentiationInterface.DenseSparsityDetector(ADTypes.AutoForwardDiff(); atol = 1e-4)),
    u0, p; abstol = 1e-10, reltol = 1e-10)

@btime NLS.solve(prob_brusselator_2d_exact_tracer, NLS.NewtonRaphson());
@btime NLS.solve(prob_brusselator_2d_approx_di, NLS.NewtonRaphson());
nothing # hide
```

For more information on the preconditioner interface, see the
[linear solver documentation](https://docs.sciml.ai/LinearSolve/stable/basics/Preconditioners/).

# Globalization Subroutines

The following globalization subroutines are available.

```@index
Pages = ["globalization.md"]
```

## [Line Search Algorithms](@id line-search)

Line Searches have been moved to an external package. Take a look at the
[LineSearch.jl](https://github.com/SciML/LineSearch.jl) package and its
[documentation](https://sciml.github.io/LineSearch.jl/dev/).

## Radius Update Schemes for Trust Region

```@docs
RadiusUpdateSchemes
```

### Available Radius Update Schemes

```@docs
RadiusUpdateSchemes.Simple
RadiusUpdateSchemes.Hei
RadiusUpdateSchemes.Yuan
RadiusUpdateSchemes.Bastin
RadiusUpdateSchemes.Fan
RadiusUpdateSchemes.NLsolve
RadiusUpdateSchemes.NocedalWright
```

# Automatic Differentiation Backends

!!! note
    
    We support all backends supported by DifferentiationInterface.jl. Please refer to
    the [backends page](https://juliadiff.org/DifferentiationInterface.jl/DifferentiationInterface/stable/explanation/backends/)
    for more information.

## Summary of Finite Differencing Backends

  - [`AutoFiniteDiff`](@extref ADTypes.AutoFiniteDiff): Finite differencing using
    `FiniteDiff.jl`, not optimal but always applicable.
  - [`AutoFiniteDifferences`](@extref ADTypes.AutoFiniteDifferences): Finite differencing
    using `FiniteDifferences.jl`, not optimal but always applicable.

## Summary of Forward Mode AD Backends

  - [`AutoForwardDiff`](@extref ADTypes.AutoForwardDiff): The best choice for dense
    problems.
  - [`AutoPolyesterForwardDiff`](@extref ADTypes.AutoPolyesterForwardDiff): Might be faster
    than [`AutoForwardDiff`](@extref ADTypes.AutoForwardDiff) for large problems. Requires
    `PolyesterForwardDiff.jl` to be installed and loaded.

## Summary of Reverse Mode AD Backends

  - [`AutoZygote`](@extref ADTypes.AutoZygote): The fastest choice for non-mutating
    array-based (BLAS) functions.
  - [`AutoEnzyme`](@extref ADTypes.AutoEnzyme): Uses `Enzyme.jl` Reverse Mode and works for
    both in-place and out-of-place functions.

!!! tip
    
    For sparsity detection and sparse AD take a look at
    [sparsity detection](@ref sparsity-detection).

# [Nonlinear Functions and Jacobian Types](@id nonlinearfunctions)

The SciML ecosystem provides an extensive interface for declaring extra functions
associated with the differential equation's data. In traditional libraries, there is usually
only one option: the Jacobian. However, we allow for a large array of pre-computed functions
to speed up the calculations. This is offered via the `NonlinearFunction` types, which can
be passed to the problems.

## Function Type Definitions

```@docs
SciMLBase.IntervalNonlinearFunction
SciMLBase.NonlinearFunction
```

# MINPACK.jl

This is a extension for importing solvers from MINPACK into the SciML interface. Note that
these solvers do not come by default, and thus one needs to install the package before using
these solvers:

```julia
import Pkg
Pkg.add("MINPACK")
import MINPACK
import NonlinearSolve as NLS
```

## Solver API

```@docs
CMINPACK
```

# [Steady State Solvers](@id ss_solvers)

```julia
solve(prob::SteadyStateProblem, alg; kwargs)
```

Solves for the steady states in the problem defined by `prob` using the algorithm `alg`. If
no algorithm is given, a default algorithm will be chosen.

## Recommended Methods

Conversion to a NonlinearProblem is generally the fastest method. However, this will not
guarantee the preferred root (the stable equilibrium), and thus if the preferred root is
required, then it's recommended that one uses [`DynamicSS`](@ref). For [`DynamicSS`](@ref),
often an adaptive stiff solver, like a Rosenbrock or BDF method (`Rodas5` or `QNDF`), is a
good way to allow for very large time steps as the steady state approaches.

The SteadyStateDiffEq.jl methods on a [`SteadyStateProblem`](@ref) respect the time
definition in the nonlinear definition, i.e., `u' = f(u, t)` uses the correct values for
`t` as the solution evolves. A conversion of a [`SteadyStateProblem`](@ref) to a
[`NonlinearProblem`](@ref) replaces this with the nonlinear system `u' = f(u, ∞)`, and thus
the direct [`SteadyStateProblem`](@ref) approach can give different answers (i.e., the
correct unique fixed point) on ODEs with non-autonomous dynamics.

If you have an unstable equilibrium and you want to solve for the unstable equilibrium,
then [`DynamicSS`](@ref) will not converge to that equilibrium for any initial condition.
However, Nonlinear Solvers don't suffer from this issue, and thus it's recommended to
use a nonlinear solver if you want to solve for the unstable equilibrium.

## Full List of Methods

### Conversion to NonlinearProblem

Any [`SteadyStateProblem`](@ref) can be trivially converted to a [`NonlinearProblem`](@ref)
via `NonlinearProblem(prob::SteadyStateProblem)`. Using this approach, any of the solvers
from the [Nonlinear System Solvers page](@ref nonlinearsystemsolvers) can be used. As a
convenience, users can use:

  - [`SSRootfind`](@ref): A wrapper around `NonlinearSolve.jl` compliant solvers which
    converts the [`SteadyStateProblem`](@ref) to a [`NonlinearProblem`](@ref) and solves it.

### SteadyStateDiffEq.jl

SteadyStateDiffEq.jl uses ODE solvers to iteratively approach the steady state. It is a
very stable method for solving nonlinear systems,
though often computationally more expensive than direct methods.

  - [`DynamicSS`](@ref) : Uses an ODE solver to find the steady state. Automatically
    terminates when close to the steady state. `DynamicSS(alg; tspan = Inf)` requires that
    an ODE algorithm is given as the first argument. The absolute and relative tolerances
    specify the termination conditions on the derivative's closeness to zero. This
    internally uses the `TerminateSteadyState` callback from the Callback Library. The
    simulated time, for which the ODE is solved, can be limited by `tspan`.  If `tspan` is a
    number, it is equivalent to passing `(zero(tspan), tspan)`.

Example usage:

```julia
import NonlinearSolve as NLS
import SteadyStateDiffEq as SSDE
import OrdinaryDiffEq as ODE
sol = NLS.solve(prob, SSDE.DynamicSS(ODE.Tsit5()))

import Sundials
sol = NLS.solve(prob, SSDE.DynamicSS(Sundials.CVODE_BDF()), dt = 1.0)
```

!!! note
    
    If you use `CVODE_BDF` you may need to give a starting `dt` via `dt=....`.

# [PETSc SNES Example 2](@id snes_ex2)

This implements `src/snes/examples/tutorials/ex2.c` from PETSc and `examples/SNES_ex2.jl`
from PETSc.jl using automatic sparsity detection and automatic differentiation using
`NonlinearSolve.jl`.

This solves the equations sequentially. Newton method to solve
`u'' + u^{2} = f`, sequentially.

```@example snes_ex2
import NonlinearSolve as NLS
import PETSc
import LinearAlgebra
import SparseConnectivityTracer
import BenchmarkTools

u0 = fill(0.5, 128)

function form_residual!(resid, x, _)
    n = length(x)
    xp = LinRange(0.0, 1.0, n)
    F = 6xp .+ (xp .+ 1e-12) .^ 6

    dx = 1 / (n - 1)
    resid[1] = x[1]
    for i in 2:(n - 1)
        resid[i] = (x[i - 1] - 2x[i] + x[i + 1]) / dx^2 + x[i] * x[i] - F[i]
    end
    resid[n] = x[n] - 1

    return
end
```

To use automatic sparsity detection, we need to specify `sparsity` keyword argument to
`NonlinearFunction`. See [Automatic Sparsity Detection](@ref sparsity-detection) for more
details.

```@example snes_ex2
nlfunc_dense = NLS.NonlinearFunction(form_residual!)
nlfunc_sparse = NLS.NonlinearFunction(
    form_residual!; sparsity = SparseConnectivityTracer.TracerSparsityDetector())

nlprob_dense = NLS.NonlinearProblem(nlfunc_dense, u0)
nlprob_sparse = NLS.NonlinearProblem(nlfunc_sparse, u0)
```

Now we can solve the problem using `PETScSNES` or with one of the native `NonlinearSolve.jl`
solvers.

```@example snes_ex2
sol_dense_nr = NLS.solve(nlprob_dense, NLS.NewtonRaphson(); abstol = 1e-8)
sol_dense_snes = NLS.solve(nlprob_dense, NLS.PETScSNES(); abstol = 1e-8)
sol_dense_nr .- sol_dense_snes
```

```@example snes_ex2
sol_sparse_nr = NLS.solve(nlprob_sparse, NLS.NewtonRaphson(); abstol = 1e-8)
sol_sparse_snes = NLS.solve(nlprob_sparse, NLS.PETScSNES(); abstol = 1e-8)
sol_sparse_nr .- sol_sparse_snes
```

As expected the solutions are the same (upto floating point error). Now let's compare the
runtimes.

## Runtimes

### Dense Jacobian

```@example snes_ex2
BenchmarkTools.@benchmark NLS.solve($(nlprob_dense), $(NLS.NewtonRaphson()); abstol = 1e-8)
```

```@example snes_ex2
BenchmarkTools.@benchmark NLS.solve($(nlprob_dense), $(NLS.PETScSNES()); abstol = 1e-8)
```

### Sparse Jacobian

```@example snes_ex2
BenchmarkTools.@benchmark NLS.solve($(nlprob_sparse), $(NLS.NewtonRaphson()); abstol = 1e-8)
```

```@example snes_ex2
BenchmarkTools.@benchmark NLS.solve($(nlprob_sparse), $(NLS.PETScSNES()); abstol = 1e-8)
```

# PETSc.jl

This is a extension for importing solvers from PETSc.jl SNES into the SciML interface. Note
that these solvers do not come by default, and thus one needs to install the package before
using these solvers:

```julia
import Pkg
Pkg.add("PETSc")
import PETSc
import NonlinearSolve as NLS
```

## Solver API

```@docs
PETScSNES
```

# Fixed Point Solvers

Currently we don't have an API to directly specify Fixed Point Solvers. However, a Fixed
Point Problem can be trivially converted to a Root Finding Problem. Say we want to solve:

```math
f(u) = u
```

This can be written as:

```math
g(u) = f(u) - u = 0
```

``g(u) = 0`` is a root finding problem. Note that we can use any root finding
algorithm to solve this problem. However, this is often not the most efficient way to
solve a fixed point problem. We provide a few algorithms available via extensions that
are more efficient for fixed point problems.

Note that even if you use one of the Fixed Point Solvers mentioned here, you must still
use the `NonlinearProblem` API to specify the problem, i.e., ``g(u) = 0``.

## Recommended Methods

Using [native NonlinearSolve.jl methods](@ref nonlinearsystemsolvers) is the recommended
approach. For systems where constructing Jacobian Matrices are expensive, we recommend
using a Krylov Method with one of those solvers.

## [Full List of Methods](@id fixed_point_methods_full_list)

We are only listing the methods that natively solve fixed point problems.

### SpeedMapping.jl

  - [`SpeedMappingJL()`](@ref): accelerates the convergence of a mapping to a fixed point by
    the Alternating cyclic extrapolation algorithm (ACX).

### FixedPointAcceleration.jl

  - [`FixedPointAccelerationJL()`](@ref): accelerates the convergence of a mapping to a
    fixed point by the Anderson acceleration algorithm and a few other methods.

### NLsolve.jl

In our tests, we have found the anderson method implemented here to NOT be the most
robust.

  - [`NLsolveJL(; method = :anderson)`](@ref): Anderson acceleration for fixed point
    problems.

### SIAMFANLEquations.jl

  - [`SIAMFANLEquationsJL(; method = :anderson)`](@ref): Anderson acceleration for fixed
    point problems.

# Accelerated Rootfinding on GPUs

NonlinearSolve.jl supports GPU acceleration on a wide array of devices, such as:

| GPU Manufacturer | GPU Kernel Language | Julia Support Package                              | Backend Type             |
|:---------------- |:------------------- |:-------------------------------------------------- |:------------------------ |
| NVIDIA           | CUDA                | [CUDA.jl](https://github.com/JuliaGPU/CUDA.jl)     | `CUDA.CUDABackend()`     |
| AMD              | ROCm                | [AMDGPU.jl](https://github.com/JuliaGPU/AMDGPU.jl) | `AMDGPU.ROCBackend()`    |
| Intel            | OneAPI              | [OneAPI.jl](https://github.com/JuliaGPU/oneAPI.jl) | `oneAPI.oneAPIBackend()` |
| Apple (M-Series) | Metal               | [Metal.jl](https://github.com/JuliaGPU/Metal.jl)   | `Metal.MetalBackend()`   |

To use NonlinearSolve.jl on GPUs, there are two distinctly different approaches:

 1. You can build a `NonlinearProblem` / `NonlinearLeastSquaresProblem` where the elements
    of the problem, i.e. `u0` and `p`, are defined on GPUs. This will make the evaluations
    of `f` occur on the GPU, and all internal updates of the solvers will be completely
    on the GPU as well. This is the optimal form for large systems of nonlinear equations.
 2. You can use SimpleNonlinearSolve.jl as kernels in KernelAbstractions.jl. This will build
    problem-specific GPU kernels in order to parallelize the solution of the chosen nonlinear
    system over a large number of inputs. This is useful for cases where you have a small
    `NonlinearProblem` / `NonlinearLeastSquaresProblem` which you want to solve over a large
    number of initial guesses or parameters.

For a deeper dive into the computational difference between these techniques and why it
leads to different pros/cons, see the
[DiffEqGPU.jl technical paper](https://www.sciencedirect.com/science/article/abs/pii/S0045782523007156).
In particular, the second form is unique to NonlinearSolve.jl and offers orders of magnitude
performance improvements over libraries in Jax and PyTorch which are restricted to only
using the first form.

In this tutorial we will highlight both use cases in separate parts.

!!! note
    
    If you're looking for GPU-accelerated neural networks inside of nonlinear solvers,
    check out [DeepEquilibriumNetworks.jl](https://docs.sciml.ai/DeepEquilibriumNetworks/stable/).

## GPU Acceleration of Large Nonlinear Systems using GPUArrays

The simplest way to GPU accelerate a large system is to simply make your `u0` and `p` values
be on the GPU via GPUArrays. For example, CUDA.jl has the CuArray type which implements
standard array operations, such as broadcasting and linear algebra. And since
NonlinearSolve.jl respects your chosen array types, if you choose to make `u0` be a type
that is on the GPU, then all internal broadcasting and linear algebra takes place on the
GPU.

This means the one major limitation is that you as a user must write your `f` to be
compatible with GPU arrays. Those limitations are discussed in detail in the GPU libraries,
for example
[the CuArray documentation discusses the operations available for CUDA arrays](https://cuda.juliagpu.org/stable/usage/array/)

In practice when this comes together, it looks like:

```julia
import NonlinearSolve as NLS
import CUDA

f(u, p) = u .* u .- p
u0 = CUDA.cu(ones(1000))
p = CUDA.cu(collect(1:1000))
prob = NLS.NonlinearProblem(f, u0, p)
sol = NLS.solve(prob, NLS.NewtonRaphson(), abstol = 1.0f-4)
```

Notice a few things here. One, nothing is different except the input array types. But
notice that `cu` arrays automatically default to `Float32` precision. Since NonlinearSolve.jl
respects the user's chosen types, this changes NonlinearSolve.jl to use `Float32` precision,
and thus the tolerances are adjusted accordingly.

## GPU Acceleration over Large Parameter Searches using KernelAbstractions.jl

If one has a "small" (200 equations or less) system of equations which they wish to solve
over many different inputs (parameters), then using the kernel generation approach will be
much more efficient than using the GPU-based array approach. In short, the GPU array
approach strings together standard GPU kernel calls (matrix multiply, +, etc.) where each
operation is an optimized GPU-accelerated call. In the kernel-building approach, we build
a custom kernel `f` that is then compiled specifically for our problem and ran in parallel.
This is equivalent to having built custom CUDA code for our problem! The reason this is
so much faster is because each kernel call has startup overhead, and we can cut that all
down to simply one optimized call.

To do this, we use KernelAbstractions.jl. First we have to say "what" our kernel is. The
kernel is the thing you want to embaressingly parallel call a bunch. For this nonlinear
solving, it will be the rebuilding of our nonlinear problem to new parameters and solving
it. This function must be defined using the `KernelAbstractions.@kernel` macro. This looks
like:

```julia
import NonlinearSolve as NLS
import StaticArrays
import SciMLBase
import KernelAbstractions # For writing vendor-agnostic kernels
import CUDA # For if you have an NVIDIA GPU
import AMDGPU # For if you have an AMD GPU
import Metal # For if you have a Mac M-series device and want to use the built-in GPU
import OneAPI # For if you have an Intel GPU

KernelAbstractions.@kernel function parallel_nonlinearsolve_kernel!(result, @Const(prob), @Const(alg))
    i = @index(Global)
    prob_i = SciMLBase.remake(prob; p = prob.p[i])
    sol = NLS.solve(prob_i, alg)
    @inbounds result[i] = sol.u
end
```

Note that `i = @index(Global)` is used to get a global index. I.e. this kernel will be
called with `N` different `prob` objects, and this `i` means "for the ith call". So this
is saying, "for the ith call, get the i'th parameter set and solve with these parameters.
The ith result is then this solution".

!!! note
    
    Because kernel code needs to be able to be compiled to a GPU kernel, it has very strict
    specifications of what's allowed because GPU cores are not as flexible as CPU cores.
    In general, this means that you need to avoid any runtime operations in kernel code,
    such as allocating vectors, dynamic dispatch, type instabilities, etc. The main thing
    to note is that most NonlinearSolve.jl algorithms will not be compatible with being
    in kernels. However, **SimpleNonlinearSolve.jl solvers are tested to be compatible**,
    and thus one should only choose SimpleNonlinearSolve.jl methods within kernels.

Once you have defined your kernel, you need to use KernelAbstractions in order to distribute
your call. This looks like:

```julia
function vectorized_solve(prob, alg; backend = CPU())
    result = KernelAbstractions.allocate(backend, eltype(prob.p), length(prob.p))
    groupsize = min(length(prob.p), 1024)
    kernel! = parallel_nonlinearsolve_kernel!(backend, groupsize, length(prob.p))
    kernel!(result, prob, alg)
    KernelAbstractions.synchronize(backend)
    return result
end
```

Now let's build a nonlinear system to test it on.

```julia
@inbounds function p2_f(x, p)
    out1 = x[1] + p[1] * x[2]
    out2 = sqrt(p[2]) * (x[3] - x[4])
    out3 = (x[2] - p[3] * x[3])^2
    out4 = sqrt(p[4]) * (x[1] - x[4]) * (x[1] - x[4])
    StaticArrays.SA[out1, out2, out3, out4]
end

p = StaticArrays.@SVector [StaticArrays.@SVector(rand(Float32, 4)) for _ in 1:1024]
u0 = StaticArrays.SA[1.0f0, 2.0f0, 3.0f0, 4.0f0]
prob = SciMLBase.ImmutableNonlinearProblem{false}(p2_f, u0, p)
```

!!! note
    
    Because the custom kernel is going to need to embed the the code for our nonlinear
    problem into the kernel, it also must be written to be GPU compatible.
    In general, this means that you need to avoid any runtime operations in kernel code,
    such as allocating vectors, dynamic dispatch, type instabilities, etc. Thus to make this
    work, your `f` function should be non-allocating, your `u0` function should use
    StaticArrays, and you must use `SciMLBase.ImmutableNonlinearProblem`
    (which is exactly the same as NonlinearProblem except it's immutable to satisfy the
    requirements of GPU kernels). Also, it's recommended that for most GPUs you use Float32
    precision because many GPUs are much slower on 64-bit floating point operations.

and we then simply call our vectorized kernel to parallelize it:

```julia
# Threaded CPU
vectorized_solve(prob, NLS.SimpleNewtonRaphson(); backend = KernelAbstractions.CPU())
# AMD ROCM GPU
vectorized_solve(prob, NLS.SimpleNewtonRaphson(); backend = AMDGPU.ROCBackend())
# NVIDIA CUDA GPU
vectorized_solve(prob, NLS.SimpleNewtonRaphson(); backend = CUDA.CUDABackend())
# Intel GPU
vectorized_solve(prob, NLS.SimpleNewtonRaphson(); backend = OneAPI.oneAPIBackend())
# Mac M-Series, such as M3Max
vectorized_solve(prob, NLS.SimpleNewtonRaphson(); backend = Metal.MetalBackend())
```

!!! warn
    
    The GPU-based calls will only work on your machine if you have a compatible GPU!

# [Termination Conditions](@id termination_condition)

Provides a API to specify termination conditions for [`NonlinearProblem`](@ref) and
[`SteadyStateProblem`](@ref). For details on the various termination modes:

## Termination Conditions

The termination condition is constructed as:

```julia
cache = init(du, u, AbsNormSafeBestTerminationMode(); abstol = 1e-9, reltol = 1e-9)
```

If `abstol` and `reltol` are not supplied, then we choose a default based on the element
types of `du` and `u`.

To test for termination simply call the `cache`:

```julia
terminated = cache(du, u, uprev)
```

### Absolute Tolerance

```@docs
NonlinearSolveBase.AbsTerminationMode
NonlinearSolveBase.AbsNormTerminationMode
NonlinearSolveBase.AbsNormSafeTerminationMode
NonlinearSolveBase.AbsNormSafeBestTerminationMode
```

### Relative Tolerance

```@docs
NonlinearSolveBase.RelTerminationMode
NonlinearSolveBase.RelNormTerminationMode
NonlinearSolveBase.RelNormSafeTerminationMode
NonlinearSolveBase.RelNormSafeBestTerminationMode
```

### Both Tolerances

```@docs
NonlinearSolveBase.NormTerminationMode
```

# [Controlling Solver Verbosity](@id verbosity)

NonlinearSolve.jl provides fine-grained control over diagnostic messages, warnings, and errors
through the `verbose` keyword argument. The verbosity system allows you to control what
information is displayed during the solve process. See [SciMLLogging.jl](https://docs.sciml.ai/SciMLLogging/dev/) for more details. 

```@docs
NonlinearVerbosity
```

# Frequently Asked Questions

## How is the performance of Julia's NonlinearSolve.jl vs MATLAB's fzero?

This is addressed in a [Twitter thread with the author of the improved fzero](https://twitter.com/ChrisRackauckas/status/1544743542094020615).
On the test example:

```@example
import NonlinearSolve as NLS
import BenchmarkTools

const N = 100_000;
levels = 1.5 .* rand(N);
out = zeros(N);
myfun(x, lv) = x * sin(x) - lv

function f(out, levels, u0)
    for i in 1:N
        out[i] = NLS.solve(
            NLS.IntervalNonlinearProblem{false}(
                NLS.IntervalNonlinearFunction{false}(myfun), u0, levels[i]),
            NLS.Falsi()).u
    end
end

function f2(out, levels, u0)
    for i in 1:N
        out[i] = NLS.solve(
            NLS.NonlinearProblem{false}(NLS.NonlinearFunction{false}(myfun), u0, levels[i]),
            NLS.SimpleNewtonRaphson()).u
    end
end

BenchmarkTools.@btime f(out, levels, (0.0, 2.0))
BenchmarkTools.@btime f2(out, levels, 1.0)
```

MATLAB 2022a achieves 1.66s. Try this code yourself: we receive 0.009 seconds, or a 184x
speedup.

For more information on performance of SciML, see the [SciMLBenchmarks](https://docs.sciml.ai/SciMLBenchmarksOutput/stable/).

## The solver tried to set a Dual Number in my Vector of Floats. How do I fix that?

This is a common problem that occurs if the code was not written to be generic based on the
input types. For example, consider this example taken from
[this issue](https://github.com/SciML/NonlinearSolve.jl/issues/298)

```@example dual_error_faq
import NonlinearSolve as NLS
import Random

function fff_incorrect(var, p)
    v_true = [1.0, 0.1, 2.0, 0.5]
    xx = [1.0, 2.0, 3.0, 4.0]
    xx[1] = var[1] - v_true[1]
    return var - v_true
end

v_true = [1.0, 0.1, 2.0, 0.5]
v_init = v_true .+ Random.randn!(similar(v_true)) * 0.1

prob_oop = NLS.NonlinearLeastSquaresProblem{false}(fff_incorrect, v_init)
try
    sol = NLS.solve(prob_oop, NLS.LevenbergMarquardt(); maxiters = 10000, abstol = 1e-8)
catch e
    @error e
end
```

Essentially what happened was, NonlinearSolve checked that we can use ForwardDiff.jl to
differentiate the function based on the input types. However, this function has
`xx = [1.0, 2.0, 3.0, 4.0]` followed by a `xx[1] = var[1] - v_true[1]` where `var` might
be a Dual number. This causes the error. To fix it:

 1. Specify the `autodiff` to be `AutoFiniteDiff`
    
    ```@example dual_error_faq
    import ADTypes
    sol = NLS.solve(prob_oop, NLS.LevenbergMarquardt(; autodiff = ADTypes.AutoFiniteDiff());
        maxiters = 10000, abstol = 1e-8)
    ```
    
    This worked but, Finite Differencing is not the recommended approach in any scenario.

 2. Rewrite the function to use
    [PreallocationTools.jl](https://github.com/SciML/PreallocationTools.jl) or write it as
    
    ```@example dual_error_faq
    function fff_correct(var, p)
        v_true = [1.0, 0.1, 2.0, 0.5]
        xx = eltype(var)[1.0, 2.0, 3.0, 4.0]
        xx[1] = var[1] - v_true[1]
        return xx - v_true
    end
    
    prob_oop = NLS.NonlinearLeastSquaresProblem{false}(fff_correct, v_init)
    sol = NLS.solve(prob_oop, NLS.LevenbergMarquardt(); maxiters = 10000, abstol = 1e-8)
    ```

## I thought NonlinearSolve.jl was type-stable and fast. But it isn't, why?

It is hard to say why your code is not fast. Take a look at the
[Diagnostics API](@ref diagnostics_api) to pin-point the problem. One common issue is that
there is type instability.

If you are using the defaults for the autodiff and your problem is not a scalar or using
static arrays, ForwardDiff will create type unstable code and lead to dynamic dispatch
internally. See this simple example:

```@example type_unstable
import NonlinearSolve as NLS
import InteractiveUtils
import ADTypes

f(u, p) = @. u^2 - p

prob = NLS.NonlinearProblem{false}(f, 1.0, 2.0)

InteractiveUtils.@code_warntype NLS.solve(prob, NLS.NewtonRaphson())
nothing # hide
```

Notice that this was type-stable, since it is a scalar problem. Now what happens for static
arrays

```@example type_unstable
import StaticArrays

prob = NLS.NonlinearProblem{false}(f, StaticArrays.@SVector([1.0, 2.0]), 2.0)

InteractiveUtils.@code_warntype NLS.solve(prob, NLS.NewtonRaphson())
nothing # hide
```

Again Type-Stable! Now let's try using a regular array:

```@example type_unstable
prob = NLS.NonlinearProblem(f, [1.0, 2.0], 2.0)

InteractiveUtils.@code_warntype NLS.solve(prob, NLS.NewtonRaphson())
nothing # hide
```

Ah it is still type stable. But internally since the chunksize is not statically inferred,
it will be dynamic and lead to dynamic dispatch. To fix this, we directly specify the
chunksize:

```@example type_unstable
InteractiveUtils.@code_warntype NLS.solve(
    prob,
    NLS.NewtonRaphson(;
        autodiff = ADTypes.AutoForwardDiff(; chunksize = NLS.pickchunksize(prob.u0))
    )
)
nothing # hide
```

And boom! Type stable again. We always recommend picking the chunksize via
[`NonlinearSolveBase.pickchunksize`](@ref), however, if you manually specify the chunksize, it
must be `≤ length of input`. However, a very large chunksize can lead to excessive
compilation times and slowdown.

```@docs
NonlinearSolveBase.pickchunksize
```

# [Faster Startup and and Static Compilation](@id fast_startup)

In many instances one may want a very lightweight version of NonlinearSolve.jl. For this
case there exists the solver package SimpleNonlinearSolve.jl. SimpleNonlinearSolve.jl
solvers all satisfy the same interface as NonlinearSolve.jl, but they are designed to be
simpler, lightweight, and thus have a faster startup time. Everything that can be done with
NonlinearSolve.jl can be done with SimpleNonlinearSolve.jl. Thus for example, we can solve
the core tutorial problem with just SimpleNonlinearSolve.jl as follows:

```@example simple
import SimpleNonlinearSolve as SNLS

f(u, p) = u .* u .- p
u0 = [1.0, 1.0]
p = 2.0
prob = SNLS.NonlinearProblem(f, u0, p)
sol = SNLS.solve(prob, SNLS.SimpleNewtonRaphson())
```

However, there are a few downsides to SimpleNonlinearSolve's `SimpleX` style algorithms to
note:

 1. SimpleNonlinearSolve.jl's methods are not hooked into the LinearSolve.jl system, and
    thus do not have the ability to specify linear solvers, use sparse matrices,
    preconditioners, and all of the other features which are required to scale for very
    large systems of equations.
 2. SimpleNonlinearSolve.jl's methods have less robust error handling and termination
    conditions, and thus these methods are missing some flexibility and give worse hints
    for debugging. Note that these can be enabled but are disabled by default.

However, the major upsides of SimpleNonlinearSolve.jl are:

 1. The methods are optimized and non-allocating on StaticArrays
 2. The methods are minimal in compilation

As such, you can use the code as shown above to have very low startup with good methods, but
for more scaling and debuggability we recommend the full NonlinearSolve.jl. But that said,

```@example simple
import StaticArrays

u0 = StaticArrays.SA[1.0, 1.0]
p = 2.0
prob = SNLS.NonlinearProblem(f, u0, p)
sol = SNLS.solve(prob, SNLS.SimpleNewtonRaphson())
```

using StaticArrays.jl is also the fastest form for small equations, so if you know your
system is small then SimpleNonlinearSolve.jl is not only sufficient but optimal.

## Static Compilation

Julia has tools for building small binaries via static compilation with
[StaticCompiler.jl](https://github.com/tshort/StaticCompiler.jl).
However, these tools are currently limited to type-stable non-allocating functions. That
said, SimpleNonlinearSolve.jl's solvers are precisely the subset of NonlinearSolve.jl which
are compatible with static compilation.

# Getting Started with Nonlinear Rootfinding in Julia

NonlinearSolve.jl is a system for solving rootfinding problems, i.e. finding the value $$u$$
such that $$f(u) = 0$$. In this tutorial we will go through the basics of NonlinearSolve.jl,
demonstrating the core ideas and leading you to understanding the deeper parts of the
documentation.

## The Four Types of Nonlinear Systems

There are four types of nonlinear systems:

 1. The "standard nonlinear system", i.e. the `NonlinearProblem`. This is a system of
    equations with an initial condition where you want to satisfy all equations
    simultaneously.
 2. The "interval rootfinding problem", i.e. the `IntervalNonlinearProblem`. This is the
    case where you're given an interval `[a,b]` and need to find where `f(u) = 0` for `u`
    inside the bounds.
 3. The "steady state problem", i.e. find the `u` such that `u' = f(u) = 0`. While related
    to (1), it's not entirely the same because there's a uniquely defined privileged root.
 4. The nonlinear least squares problem, which is an under/over-constrained nonlinear system
    which might not be satisfiable, i.e. there may be no `u` such that `f(u) = 0`, and thus
    we find the `u` which minimizes `||f(u)||` in the least squares sense.

One important distinction is that (1) and (3) require the input and output sizes to be the
same, while (4) does not.

## Problem Type 1: Solving Nonlinear Systems of Equations

A nonlinear system $$f(u) = 0$$ is specified by defining a function `f(u,p)`, where `p` are
the parameters of the system. For example, the following solves the vector
equation $$f(u) = u^2 - p$$ for a vector of equations:

```@example 1
import NonlinearSolve as NLS

f(u, p) = u .* u .- p
u0 = [1.0, 1.0]
p = 2.0
prob = NLS.NonlinearProblem(f, u0, p)
sol = NLS.solve(prob)
```

where `u0` is the initial condition for the rootfinder. Native NonlinearSolve.jl solvers use
the given type of `u0` to determine the type used within the solver and the return. Note
that the parameters `p` can be any type, but most are an AbstractArray for automatic
differentiation.

### Investigating the Solution

To investigate the solution, one can look at the elements of the `NonlinearSolution`. The
most important value is `sol.u`: this is the `u` that satisfies `f(u) = 0`. For example:

```@example 1
u = sol.u
```

```@example 1
f(u, p)
```

This final value, the difference of the solution against zero, can also be found with
`sol.resid`:

```@example 1
sol.resid
```

To know if the solution converged, or why the solution had not converged we can check the
return code (`retcode`):

```@example 1
sol.retcode
```

There are multiple return codes which can mean the solve was successful, and thus we can use
the general command `SciMLBase.successful_retcode` to check whether the solution process
exited as intended:

```@example 1
import SciMLBase
SciMLBase.successful_retcode(sol)
```

If we're curious about what it took to solve this equation, then you're in luck because all
of the details can be found in `sol.stats`:

```@example 1
sol.stats
```

For more information on `NonlinearSolution`s, see the
[`NonlinearSolution` manual page](@ref solution).

### Interacting with the Solver Options

While `sol = NonlinearSolve.solve(prob)` worked for our case here, in many situations you may need to
interact more deeply with how the solving process is done. First things first, you can
specify the solver using the positional arguments. For example, let's set the solver to
`TrustRegion()`:

```@example 1
NLS.solve(prob, NLS.TrustRegion())
```

For a complete list of solver choices, see
[the nonlinear system solvers page](@ref nonlinearsystemsolvers).

Next we can modify the tolerances. Here let's set some really low tolerances to force a
tight solution:

```@example 1
NLS.solve(prob, NLS.TrustRegion(), reltol = 1e-12, abstol = 1e-12)
```

There are many more options for doing this configuring. Specifically for handling
termination conditions, see the [Termination Conditions](@ref termination_condition) page
for more details. And for more details on all of the available keyword arguments, see the
[solver options](@ref solver_options) page.

## Problem Type 2: Solving Interval Rootfinding Problems with Bracketing Methods

For scalar rootfinding problems, bracketing methods exist in NonlinearSolve. The difference
with bracketing methods is that with bracketing methods, instead of giving a `u0` initial
condition, you pass a `uspan (a,b)` bracket in which the zero is expected to live. For
example:

```@example 1
import NonlinearSolve as NLS
f(u, p) = u * u - 2.0
uspan = (1.0, 2.0) # brackets
prob_int = NLS.IntervalNonlinearProblem(f, uspan)
sol = NLS.solve(prob_int)
```

All of the same option handling from before works just as before, now just with different
solver choices (see the [bracketing solvers](@ref bracketing) page for more details). For
example, let's set the solver to `ITP()` and set a high absolute tolerance:

```@example 1
sol = NLS.solve(prob_int, NLS.ITP(), abstol = 0.01)
```

## Problem Type 3: Solving Steady State Problems

For Steady State Problems, we have a wrapper package
[SteadyStateDiffEq.jl](https://github.com/SciML/SteadyStateDiffEq.jl). This package
automates handling SteadyStateProblems with NonlinearSolve and OrdinaryDiffEq.

```@example 1
import NonlinearSolve as NLS
import SteadyStateDiffEq as SSDE

f(u, p, t) = [2 - 2u[1]; u[1] - 4u[2]]
u0 = [0.0, 0.0]
prob = SSDE.SteadyStateProblem(f, u0)

NLS.solve(prob, SSDE.SSRootfind())
```

If you don't provide a nonlinear solver to `SSRootfind` it uses a polyalgorithm from
NonlinearSolve. We can also provide the actual nonlinear solver to use:

```@example 1
NLS.solve(prob, SSDE.SSRootfind(NLS.Broyden()))
```

## Problem Type 4: Solving Nonlinear Least Squares Problems

```@example 1
import NonlinearSolve as NLS

function nlls!(du, u, p)
    du[1] = 2u[1] - 2
    du[2] = u[1] - 4u[2]
    du[3] = 0
end
```

Note that here the output array is of length `3` while the input array is of length `2`. We
need to provide the `resid_prototype` to tell the solver what the output size is (this can
be skipped for out of place problems):

```@example 1
u0 = [0.0, 0.0]
prob = NLS.NonlinearLeastSquaresProblem(
    NLS.NonlinearFunction(nlls!, resid_prototype = zeros(3)), u0)

NLS.solve(prob)
```

Same as before, we can change the solver and tolerances:

```@example 1
NLS.solve(prob, NLS.GaussNewton(), reltol = 1e-12, abstol = 1e-12)
```

## Going Beyond the Basics: How to use the Documentation

Congrats, you now know how to use the basics of NonlinearSolve.jl! However, there is so much
more to see. Next check out:

  - [Some code optimization tricks to know about with NonlinearSolve.jl](@ref code_optimization)
  - [An iterator interface which lets you step through the solving process step by step](@ref iterator)
  - [How to handle large systems of equations efficiently](@ref large_systems)
  - [Ways to use NonlinearSolve.jl that is faster to startup and can statically compile](@ref fast_startup)
  - [More detailed termination conditions](@ref termination_condition)

And also check out the rest of the manual.

# FastLevenbergMarquardt.jl

This is an extension for importing solvers from FastLevenbergMarquardt.jl into the SciML
interface. Note that these solvers do not come by default, and thus one needs to install
the package before using these solvers:

```julia
import Pkg
Pkg.add("FastLevenbergMarquardt")
import FastLevenbergMarquardt
import NonlinearSolve as NLS
```

## Solver API

```@docs
FastLevenbergMarquardtJL
```

# HomotopyContinuation.jl

NonlinearSolve wraps the homotopy continuation algorithm implemented in
HomotopyContinuation.jl. This solver is not included by default and needs
to be installed separately:

```julia
import Pkg
Pkg.add("NonlinearSolveHomotopyContinuation")
import NonlinearSolveHomotopyContinuation
import NonlinearSolve as NLS
```

# Solver API

```@docs
NonlinearSolveHomotopyContinuation.HomotopyContinuationJL
SciMLBase.HomotopyNonlinearFunction
```

# SteadyStateDiffEq.jl

This is a wrapper package for using ODE solvers from
[DifferentialEquations.jl](https://docs.sciml.ai/DiffEqDocs/stable/) into the SciML
interface. Note that these solvers do not come by default, and thus one needs to install
the package before using these solvers:

```julia
import Pkg
Pkg.add("SteadyStateDiffEq")
import SteadyStateDiffEq as SSDE
```

These methods can be used independently of the rest of NonlinearSolve.jl

```@index
Pages = ["steadystatediffeq.md"]
```

## Solver API

```@docs
DynamicSS
SSRootfind
```

# SIAMFANLEquations.jl

This is an extension for importing solvers from
[SIAMFANLEquations.jl](https://github.com/ctkelley/SIAMFANLEquations.jl) into the SciML
interface. Note that these solvers do not come by default, and thus one needs to install
the package before using these solvers:

```julia
import Pkg
Pkg.add("SIAMFANLEquations")
import SIAMFANLEquations
import NonlinearSolve as NLS
```

## Solver API

```@docs
SIAMFANLEquationsJL
```

# [Symbolic Nonlinear System Definition and Acceleration via ModelingToolkit](@id modelingtoolkit)

[ModelingToolkit.jl](https://docs.sciml.ai/ModelingToolkit/dev/) is a symbolic-numeric
modeling system for the Julia SciML ecosystem. It adds a high-level interactive interface
for the numerical solvers which can make it easy to symbolically modify and generate
equations to be solved. The basic form of using ModelingToolkit looks as follows:

```julia
import ModelingToolkit as MTK
import NonlinearSolve as NLS

MTK.@variables x y z
MTK.@parameters σ ρ β

# Define a nonlinear system
eqs = [0 ~ σ * (y - x), 0 ~ x * (ρ - z) - y, 0 ~ x * y - β * z]
MTK.@mtkbuild ns = MTK.NonlinearSystem(eqs, [x, y, z], [σ, ρ, β])

u0 = [x => 1.0, y => 0.0, z => 0.0]

ps = [σ => 10.0
      ρ => 26.0
      β => 8 / 3]

prob = NLS.NonlinearProblem(ns, u0, ps)
sol = NLS.solve(prob, NLS.NewtonRaphson())
```

## Symbolic Derivations of Extra Functions

As a symbolic system, ModelingToolkit can be used to represent the equations and derive new
forms. For example, let's look at the equations:

```julia
MTK.equations(ns)
```

We can ask it what the Jacobian of our system is via `calculate_jacobian`:

```julia
MTK.calculate_jacobian(ns)
```

We can tell MTK to generate a computable form of this analytical Jacobian via `jac = true`
to help the solver use efficient forms:

```julia
prob = NLS.NonlinearProblem(ns, u0, ps, jac = true)
sol = NLS.solve(prob, NLS.NewtonRaphson())
```

## Symbolic Simplification of Nonlinear Systems via Tearing

One of the major reasons for using ModelingToolkit is to allow structural simplification of
the systems. It's very easy to write down a mathematical model that, in theory, could be
solved more simply. Let's take a look at a quick system:

```julia
MTK.@variables u1 u2 u3 u4 u5
eqs = [0 ~ u1 - sin(u5), 0 ~ u2 - cos(u1), 0 ~ u3 - hypot(u1, u2),
    0 ~ u4 - hypot(u2, u3), 0 ~ u5 - hypot(u4, u1)]
MTK.@named sys = MTK.NonlinearSystem(eqs, [u1, u2, u3, u4, u5], [])
```

If we run structural simplification, we receive the following form:

```julia
sys = MTK.structural_simplify(sys)
```

```julia
MTK.equations(sys)
```

How did it do this? Let's look at the `observed` to see the relationships that it found:

```julia
MTK.observed(sys)
```

Using ModelingToolkit, we can build and solve the simplified system:

```julia
u0 = [u5 .=> 1.0]
prob = NLS.NonlinearProblem(sys, u0)
sol = NLS.solve(prob, NLS.NewtonRaphson())
```

We can then use symbolic indexing to retrieve any variable:

```julia
sol[u1]
```

```julia
sol[u2]
```

```julia
sol[u3]
```

```julia
sol[u4]
```

```julia
sol[u5]
```

## Component-Based and Acausal Modeling

If you're interested in building models in a component or block based form, such as seen in
systems like Simulink or Modelica, take a deeper look at
[ModelingToolkit.jl's documentation](https://docs.sciml.ai/ModelingToolkit/stable/) which
goes into detail on such features.

# NonlinearSolve.jl: High-Performance Unified Nonlinear Solvers

NonlinearSolve.jl is a unified interface for the nonlinear solving packages of Julia. The
package includes its own high-performance nonlinear solvers which include the ability to
swap out to fast direct and iterative linear solvers, along with the ability to use sparse
automatic differentiation for Jacobian construction and Jacobian-vector products.
NonlinearSolve.jl interfaces with other packages of the Julia ecosystem to make it easy to
test alternative solver packages and pass small types to control algorithm swapping. It also
interfaces with the [ModelingToolkit.jl](https://docs.sciml.ai/ModelingToolkit/stable/)
world of symbolic modeling to allow for automatically generating high-performance code.

Performance is key: the current methods are made to be highly performant on scalar and
statically sized small problems, with options for large-scale systems. If you run into any
performance issues, please file an issue. Consult the
[NonlinearSystemSolvers](@ref nonlinearsystemsolvers) page for information on how to import
solvers from different packages.

## Installation

To install NonlinearSolve.jl, use the Julia package manager:

```julia
using Pkg
Pkg.add("NonlinearSolve")
```

## Contributing

  - Please refer to the
    [SciML ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://github.com/SciML/ColPrac/blob/master/README.md)
    for guidance on PRs, issues, and other matters relating to contributing to SciML.

  - See the [SciML Style Guide](https://github.com/SciML/SciMLStyle) for common coding practices and other style decisions.
  - There are a few community forums:
    
      + The #diffeq-bridged and #sciml-bridged channels in the [Julia Slack](https://julialang.org/slack/)
      + The #diffeq-bridged and #sciml-bridged channels in the [Julia Zulip](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
      + On the [Julia Discourse forums](https://discourse.julialang.org)
      + See also [SciML Community page](https://sciml.ai/community/)

## Reproducibility

```@raw html
<details><summary>The documentation of this SciML package was built using these direct dependencies,</summary>
```

```@example
using Pkg # hide
Pkg.status() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>and using this machine and Julia version.</summary>
```

```@example
using InteractiveUtils # hide
versioninfo() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>A more complete overview of all dependencies and their versions is also provided.</summary>
```

```@example
using Pkg # hide
Pkg.status(; mode = PKGMODE_MANIFEST) # hide
```

```@raw html
</details>
```

```@eval
using TOML
using Markdown
version = TOML.parse(read("../../Project.toml", String))["version"]
name = TOML.parse(read("../../Project.toml", String))["name"]
link_manifest = "https://github.com/SciML/" *
                name *
                ".jl/tree/gh-pages/v" *
                version *
                "/assets/Manifest.toml"
link_project = "https://github.com/SciML/" *
               name *
               ".jl/tree/gh-pages/v" *
               version *
               "/assets/Project.toml"
Markdown.parse("""You can also download the
[manifest]($link_manifest)
file and the
[project]($link_project)
file.
""")
```

# [(Semi-)Automatic Sparsity Detection](@id sparsity-detection)

This section describes how to enable Sparsity Detection. For a detailed tutorial on how
to use this in an actual problem, see
[this tutorial on Efficiently Solving Large Sparse Ill-Conditioned Nonlinear Systems](@ref large_systems).

Notation wise we are trying to solve for `x` such that `nlfunc(x) = 0`.

## Big Table for Determining Sparsity Detection and Coloring Algorithms

| `f.sparsity`               | `f.jac_prototype` | `f.colorvec` | Sparsity Detection                               | Coloring Algorithm                        |
|:-------------------------- |:----------------- |:------------ |:------------------------------------------------ |:----------------------------------------- |
| ❌                          | ❌                 | `Any`        | `NoSparsityDetector()`                           | `NoColoringAlgorithm()`                   |
| ❌                          | Not Structured    | `Any`        | `NoSparsityDetector()`                           | `NoColoringAlgorithm()`                   |
| ❌                          | Structured        | ✅            | `KnownJacobianSparsityDetector(f.jac_prototype)` | `GreedyColoringAlgorithm(LargestFirst())` |
| ❌                          | Structured        | ❌            | `KnownJacobianSparsityDetector(f.jac_prototype)` | `GreedyColoringAlgorithm(LargestFirst())` |
| -                          | -                 | -            | -                                                | -                                         |
| `AbstractMatrix`           | ❌                 | ✅            | `KnownJacobianSparsityDetector(f.sparsity)`      | `ConstantColoringAlgorithm(f.colorvec)`   |
| `AbstractMatrix`           | ❌                 | ❌            | `KnownJacobianSparsityDetector(f.sparsity)`      | `GreedyColoringAlgorithm(LargestFirst())` |
| `AbstractMatrix`           | Not Structured    | ✅            | `KnownJacobianSparsityDetector(f.sparsity)`      | `ConstantColoringAlgorithm(f.colorvec)`   |
| `AbstractMatrix`           | Not Structured    | ❌            | `KnownJacobianSparsityDetector(f.sparsity)`      | `GreedyColoringAlgorithm(LargestFirst())` |
| `AbstractMatrix`           | Structured        | `Any`        | 🔴                                                | 🔴                                         |
| -                          | -                 | -            | -                                                | -                                         |
| `AbstractSparsityDetector` | ❌                 | `Any`        | `f.sparsity`                                     | `GreedyColoringAlgorithm(LargestFirst())` |
| `AbstractSparsityDetector` | Not Structured    | ✅            | `f.sparsity`                                     | `ConstantColoringAlgorithm(f.colorvec)`   |
| `AbstractSparsityDetector` | Not Structured    | ❌            | `f.sparsity`                                     | `GreedyColoringAlgorithm(LargestFirst())` |
| `AbstractSparsityDetector` | Structured        | ✅            | `KnownJacobianSparsityDetector(f.jac_prototype)` | `ConstantColoringAlgorithm(f.colorvec)`   |
| `AbstractSparsityDetector` | Structured        | ❌            | `KnownJacobianSparsityDetector(f.jac_prototype)` | `GreedyColoringAlgorithm(LargestFirst())` |

 1. `Structured` means either a `AbstractSparseMatrix` or `ArrayInterface.isstructured(x)` is true.
 2. ❌ means not provided (default)
 3. ✅ means provided
 4. 🔴 means an error will be thrown
 5. Providing a colorvec without specifying either sparsity or jac_prototype with a sparse or structured matrix will cause us to ignore the colorvec.
 6. The function calls demonstrated above are simply pseudo-code to show the general idea.

## Case I: Sparse Jacobian Prototype is Provided

Let's say you have a Sparse Jacobian Prototype `jac_prototype`, in this case you can
create your problem as follows:

```julia
prob = NonlinearProblem(NonlinearFunction(nlfunc; jac_prototype = jac_prototype), x0)
```

NonlinearSolve will automatically perform matrix coloring and use sparse differentiation.

Now you can help the solver further by providing the color vector. This can be done by

```julia
prob = NonlinearProblem(
    NonlinearFunction(nlfunc; jac_prototype = jac_prototype, colorvec = colorvec), x0)
```

If the `colorvec` is not provided, then it is computed on demand.

!!! note
    
    One thing to be careful about in this case is that `colorvec` is dependent on the
    autodiff backend used. `ADTypes.mode(ad) isa ADTypes.ForwardMode` will assume that the
    colorvec is the column colorvec, otherwise we will assume that the colorvec is the
    row colorvec.

## Case II: Sparsity Detection algorithm is provided

If you don't have a Sparse Jacobian Prototype, but you know the which sparsity detection
algorithm you want to use, then you can create your problem as follows:

```julia
prob = NonlinearProblem(
    NonlinearFunction(nlfunc; sparsity = SymbolicsSparsityDetector()), x0)  # Remember to have Symbolics.jl loaded
# OR
prob = NonlinearProblem(
    NonlinearFunction(nlfunc; sparsity = TracerSparsityDetector()), x0) # From SparseConnectivityTracer.jl
```

Refer to the documentation of DifferentiationInterface.jl and SparseConnectivityTracer.jl
for more information on sparsity detection algorithms.

# [Nonlinear Solutions](@id solution)

```@docs
SciMLBase.AbstractNonlinearSolution
SciMLBase.NonlinearSolution
```

## Statistics

```@docs
SciMLBase.NLStats
```

## Return Code

```@docs
ReturnCode.Default
ReturnCode.Success
ReturnCode.StalledSuccess
ReturnCode.ExactSolutionLeft
ReturnCode.ExactSolutionRight
ReturnCode.FloatingPointLimit
ReturnCode.Terminated
ReturnCode.ConvergenceFailure
ReturnCode.InitialFailure
ReturnCode.Unstable
ReturnCode.MaxIters
ReturnCode.MaxTime
ReturnCode.MaxNumSub
ReturnCode.Failure
ReturnCode.InternalLineSearchFailed
ReturnCode.InternalLinearSolveFailed
ReturnCode.Stalled
ReturnCode.ShrinkThresholdExceeded
ReturnCode.Infeasible
ReturnCode.DtNaN
ReturnCode.DtLessThanMin
```

# [Interval Root-Finding Methods (Bracketing Solvers)](@id bracketing)

```julia
solve(prob::IntervalNonlinearProblem, alg; kwargs...)
```

Solves for ``f(t) = 0`` in the problem defined by `prob` using the algorithm `alg`. If no
algorithm is given, a default algorithm will be chosen.

## Recommended Methods
[`modAB`](@ref) (Modified Anderson-Bjork) is the recommended method for the scalar interval 
root-finding problems. It combines Bisection with Anderson-Bjork steps to achieve superlinear 
convergence 1.7–1.8, providing optimal convergence rate for poorly behaved functions. 
According to our benchmarks, it outperforms the other methods in most cases.

[`ITP`](@ref) is particularly well-suited for cases where the function is smooth and well-behaved; and achieved superlinear convergence while retaining the optimal worst-case performance of the
Bisection method. For more details, consult the detailed solver API docs.

[`Ridder`](@ref) is a hybrid method that uses the value of function at the midpoint of the
interval to perform an exponential interpolation to the root. This gives a fast convergence
with a guaranteed convergence of at most twice the number of iterations as the bisection
method.

[`Brent`](@ref) is a combination of the bisection method, the secant method and inverse
quadratic interpolation. At every iteration, Brent's method decides which method out of
these three is likely to do best, and proceeds by doing a step according to that method.
This gives a robust and fast method, which therefore enjoys considerable popularity.

## Full List of Methods

### BracketingNonlinearSolve.jl

These methods are automatically included as part of NonlinearSolve.jl. Though, one can use
BracketingNonlinearSolve.jl directly to decrease the dependencies and improve load time.

  - [`Alefeld`](@ref): A non-allocating Alefeld method
  - [`Bisection`](@ref): A common bisection method
  - [`Brent`](@ref): A non-allocating Brent method
  - [`Falsi`](@ref): A non-allocating regula falsi method
  - [`ITP`](@ref): A non-allocating ITP (Interpolate, Truncate & Project) method
  - [`ModAB`](@ref): A non-allocating Modified Anderson-Bjork's method
  - [`Muller`](@ref): A non-allocating Muller's method
  - [`Ridder`](@ref): A non-allocating Ridder method

# [Code Optimization for Small Nonlinear Systems in Julia](@id code_optimization)

## General Code Optimization in Julia

Before starting this tutorial, we recommend the reader to check out one of the many
tutorials for optimization Julia code. The following is an incomplete list:

  - [The Julia Performance Tips](https://docs.julialang.org/en/v1/manual/performance-tips/)
  - [MIT 18.337 Course Notes on Optimizing Serial Code](https://mitmath.github.io/18337/lecture2/optimizing)
  - [What scientists must know about hardware to write fast code](https://viralinstruction.com/posts/hardware/)

User-side optimizations are important because, for sufficiently difficult problems, most
time will be spent inside your `f` function, the function you are trying to solve.
“Efficient solvers" are those that reduce the required number of `f` calls to hit the error
tolerance. The main ideas for optimizing your nonlinear solver code, or any Julia function,
are the following:

  - Make it non-allocating
  - Use StaticArrays for small arrays
  - Use broadcast fusion
  - Make it type-stable
  - Reduce redundant calculations
  - Make use of BLAS calls
  - Optimize algorithm choice

We'll discuss these strategies in the context of nonlinear solvers. Let's start with small
systems.

## Optimizing Nonlinear Solver Code for Small Systems

Take for example a prototypical small nonlinear solver code in its out-of-place form:

```@example small_opt
import NonlinearSolve as NLS

f(u, p) = u .* u .- p
u0 = [1.0, 1.0]
p = 2.0
prob = NLS.NonlinearProblem(f, u0, p)
sol = NLS.solve(prob, NLS.NewtonRaphson())
```

We can use BenchmarkTools.jl to get more precise timings:

```@example small_opt
import BenchmarkTools

BenchmarkTools.@benchmark NLS.solve(prob, NLS.NewtonRaphson())
```

Note that this way of writing the function is a shorthand for:

```@example small_opt
f(u, p) = [u[1] * u[1] - p, u[2] * u[2] - p]
```

where the function `f` returns an array. This is a common pattern from things like MATLAB's
`fzero` or SciPy's `scipy.optimize.fsolve`. However, by design it's very slow. In the
benchmark you can see that there are many allocations. These allocations cause the memory
allocator to take more time than the actual numerics itself, which is one of the reasons why
codes from MATLAB and Python end up slow.

In order to avoid this issue, we can use a non-allocating "in-place" approach. Written out
by hand, this looks like:

```@example small_opt
function f(du, u, p)
    du[1] = u[1] * u[1] - p
    du[2] = u[2] * u[2] - p
    return nothing
end

prob = NLS.NonlinearProblem(f, u0, p)
BenchmarkTools.@benchmark sol = NLS.solve(prob, NLS.NewtonRaphson())
```

Notice how much faster this already runs! We can make this code even simpler by using
the `.=` in-place broadcasting.

```@example small_opt
function f(du, u, p)
    du .= u .* u .- p
    return nothing
end

BenchmarkTools.@benchmark sol = NLS.solve(prob, NLS.NewtonRaphson())
```

## Further Optimizations for Small Nonlinear Solves with Static Arrays and SimpleNonlinearSolve

Allocations are only expensive if they are “heap allocations”. For a more in-depth
definition of heap allocations,
[there are many sources online](https://net-informations.com/faq/net/stack-heap.htm).
But a good working definition is that heap allocations are variable-sized slabs of memory
which have to be pointed to, and this pointer indirection costs time. Additionally, the heap
has to be managed, and the garbage controllers has to actively keep track of what's on the
heap.

However, there's an alternative to heap allocations, known as stack allocations. The stack
is statically-sized (known at compile time) and thus its accesses are quick. Additionally,
the exact block of memory is known in advance by the compiler, and thus re-using the memory
is cheap. This means that allocating on the stack has essentially no cost!

Arrays have to be heap allocated because their size (and thus the amount of memory they take
up) is determined at runtime. But there are structures in Julia which are stack-allocated.
`struct`s for example are stack-allocated “value-type”s. `Tuple`s are a stack-allocated
collection. The most useful data structure for NonlinearSolve though is the `StaticArray`
from the package [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl). These
arrays have their length determined at compile-time. For example:

```@example small_opt
import StaticArrays

A = StaticArrays.SA[2.0, 3.0, 5.0]
typeof(A)
```

Notice that the `3` after `SVector` gives the size of the `SVector`. It cannot be changed.
Additionally, `SVector`s are immutable, so we have to create a new `SVector` to change
values. But remember, we don't have to worry about allocations because this data structure
is stack-allocated. `SArray`s have numerous extra optimizations as well: they have fast
matrix multiplication, fast QR factorizations, etc. which directly make use of the
information about the size of the array. Thus, when possible, they should be used.

Unfortunately, static arrays can only be used for sufficiently small arrays. After a certain
size, they are forced to heap allocate after some instructions and their compile time
balloons. Thus, static arrays shouldn't be used if your system has more than ~20 variables.
Additionally, only the native Julia algorithms can fully utilize static arrays.

Let's ***optimize our nonlinear solve using static arrays***. Note that in this case, we
want to use the out-of-place allocating form, but this time we want to output a static
array. Doing it with broadcasting looks like:

```@example small_opt
f_SA(u, p) = u .* u .- p

u0 = StaticArrays.SA[1.0, 1.0]
p = 2.0
prob = NLS.NonlinearProblem(f_SA, u0, p)

BenchmarkTools.@benchmark NLS.solve(prob, NLS.NewtonRaphson())
```

Note that only change here is that `u0` is made into a StaticArray! If we needed to write
`f` out for a more complex nonlinear case, then we'd simply do the following:

```@example small_opt
f_SA(u, p) = StaticArrays.SA[u[1] * u[1] - p, u[2] * u[2] - p]

BenchmarkTools.@benchmark NLS.solve(prob, NLS.NewtonRaphson())
```

However, notice that this did not give us a speedup but rather a slowdown. This is because
many of the methods in NonlinearSolve.jl are designed to scale to larger problems, and thus
aggressively do things like caching which is good for large problems but not good for these
smaller problems and static arrays. In order to see the full benefit, we need to move to one
of the methods from SimpleNonlinearSolve.jl which are designed for these small-scale static
examples. Let's now use `SimpleNewtonRaphson`:

```@example small_opt
BenchmarkTools.@benchmark NLS.solve(prob, NLS.SimpleNewtonRaphson())
```

And there we go, around `40ns` from our starting point of almost `4μs`!

# Descent Subroutines

The following subroutines are available for computing the descent direction.

```@index
Pages = ["descent.md"]
```

## Core Subroutines

```@docs
NewtonDescent
SteepestDescent
DampedNewtonDescent
```

## Special Trust Region Descent Subroutines

```@docs
Dogleg
```

## Special Levenberg Marquardt Descent Subroutines

```@docs
GeodesicAcceleration
```

# [Common Solver Options (Solve Keyword Arguments)](@id solver_options)

```@docs
solve(::NonlinearProblem, args...; kwargs...)
```

## General Controls

  - `alias_u0::Bool`: Whether to alias the initial condition or use a copy.
    Defaults to `false`.
  - `internalnorm::Function`: The norm used by the solver. Default depends on algorithm
    choice.

## Iteration Controls

  - `maxiters::Int`: The maximum number of iterations to perform. Defaults to `1000`.
  - `maxtime`: The maximum time for solving the nonlinear system of equations. Defaults to
    `nothing` which means no time limit. Note that setting a time limit does have a small
    overhead.
  - `abstol::Number`: The absolute tolerance. Defaults to
    `real(oneunit(T)) * (eps(real(one(T))))^(4 // 5)`.
  - `reltol::Number`: The relative tolerance. Defaults to
    `real(oneunit(T)) * (eps(real(one(T))))^(4 // 5)`.
  - `termination_condition`: Termination Condition from NonlinearSolveBase. Defaults to
    `AbsNormSafeBestTerminationMode()` for `NonlinearSolve.jl` and `AbsNormTerminationMode()` for
    `SimpleNonlinearSolve.jl`.

## Tracing Controls

These are exclusively available for native `NonlinearSolve.jl` solvers.

  - `show_trace`: Must be `Val(true)` or `Val(false)`. This controls whether the trace is
    displayed to the console. (Defaults to `Val(false)`)
  - `trace_level`: Needs to be one of Trace Objects: [`TraceMinimal`](@ref),
    [`TraceWithJacobianConditionNumber`](@ref), or [`TraceAll`](@ref). This controls the
    level of detail of the trace. (Defaults to `TraceMinimal()`)
  - `store_trace`: Must be `Val(true)` or `Val(false)`. This controls whether the trace is
    stored in the solution object. (Defaults to `Val(false)`)

## Verbosity Controls
  - `verbose::NonlinearVerbosity`: Controls the verbosity of the solver. Determines which messages get logged at what logging level. 
### Quick Start

```julia
# Use a preset
solve(prob, alg; verbose = SciMLLogging.Standard())

# Silence all messages
solve(prob, alg; verbose = SciMLLogging.None())

# Maximum verbosity
solve(prob, alg; verbose = SciMLLogging.All())

# Custom configuration
solve(prob, alg; verbose = NonlinearVerbosity(
    alias_u0_immutable = SciMLLogging.WarnLevel(),
    threshold_state = SciMLLogging.InfoLevel()
))
```

# SciPy

This is an extension for importing solvers from
[SciPy](https://scipy.org/) into the SciML
interface. Note that these solvers do not come by default, and thus one needs to install
the package before using these solvers:

```julia
import Pkg
Pkg.add("NonlinearSolveSciPy")
import NonlinearSolveSciPy as NLSP
```

Note that using this package requires Python and SciPy to be available via PythonCall.jl.

## Solver API

```@docs
NonlinearSolveSciPy.SciPyLeastSquares
NonlinearSolveSciPy.SciPyRoot
NonlinearSolveSciPy.SciPyRootScalar
```

# Internal Abstract Types

## Solvers

```@docs
NonlinearSolveBase.AbstractNonlinearSolveAlgorithm
NonlinearSolveBase.AbstractNonlinearSolveCache
```

## Descent Directions

```@docs
NonlinearSolveBase.AbstractDescentDirection
NonlinearSolveBase.AbstractDescentCache
```

### Descent Results

```@docs
NonlinearSolveBase.DescentResult
```

## Approximate Jacobian

```@docs
NonlinearSolveBase.AbstractApproximateJacobianStructure
NonlinearSolveBase.AbstractJacobianInitialization
NonlinearSolveBase.AbstractApproximateJacobianUpdateRule
NonlinearSolveBase.AbstractApproximateJacobianUpdateRuleCache
NonlinearSolveBase.AbstractResetCondition
```

## Damping Algorithms

```@docs
NonlinearSolveBase.AbstractDampingFunction
NonlinearSolveBase.AbstractDampingFunctionCache
```

## Trust Region

```@docs
NonlinearSolveBase.AbstractTrustRegionMethod
NonlinearSolveBase.AbstractTrustRegionMethodCache
```

# [Diagnostics API](@id diagnostics_api_reference)

## Timer Outputs

These functions are not exported since the names have a potential for conflict.

```@docs
NonlinearSolveBase.enable_timer_outputs
NonlinearSolveBase.disable_timer_outputs
NonlinearSolveBase.@static_timeit
```

## Tracing API

```@docs
TraceAll
TraceWithJacobianConditionNumber
TraceMinimal
```

# NonlinearSolve.jl Solvers

These are the native solvers of NonlinearSolve.jl.

```@index
Pages = ["solvers.md"]
```

## General Keyword Arguments

Several Algorithms share the same specification for common keyword arguments. Those are
documented in this section to avoid repetition. Certain algorithms might have additional
considerations for these keyword arguments, which are documented in the algorithm's
documentation.

  - `linsolve`: the [LinearSolve.jl](https://github.com/SciML/LinearSolve.jl) solvers used
    for the linear solves within the Newton method. Defaults to `nothing`, which means it
    uses the LinearSolve.jl default algorithm choice. For more information on available
    algorithm choices, see the
    [LinearSolve.jl documentation](https://docs.sciml.ai/LinearSolve/stable/).
  - `linesearch`: the line search algorithm to use. Defaults to
    [`NoLineSearch()`](@extref LineSearch.NoLineSearch), which means that no line search is
    performed.
  - `autodiff`: determines the backend used for the Jacobian. Note that this
    argument is ignored if an analytical Jacobian is passed, as that will be used instead.
    Defaults to `nothing` which means that a default is selected according to the problem
    specification! Valid choices are types from ADTypes.jl.
  - `vjp_autodiff`: similar to `autodiff`, but is used to compute Jacobian
    Vector Products. Ignored if the NonlinearFunction contains the `jvp` function.
  - `vjp_autodiff`: similar to `autodiff`, but is used to compute Vector
    Jacobian Products. Ignored if the NonlinearFunction contains the `vjp` function.
  - `concrete_jac`: whether to build a concrete Jacobian. If a Krylov-subspace method is
    used, then the Jacobian will not be constructed and instead direct Jacobian-Vector
    products `J*v` are computed using forward-mode automatic differentiation or finite
    differencing tricks (without ever constructing the Jacobian). However, if the Jacobian
    is still needed, for example for a preconditioner, `concrete_jac = true` can be passed
    in order to force the construction of the Jacobian.
  - `forcing`: Adaptive forcing term strategy for Newton-Krylov methods. When using an
    iterative linear solver (Krylov method), this controls how accurately the linear system
    is solved at each Newton iteration. Defaults to `nothing` (fixed tolerance). See
    [Forcing Term Strategies](@ref forcing_strategies) for available options.

## Nonlinear Solvers

```@docs
NewtonRaphson
DFSane
Broyden
Klement
LimitedMemoryBroyden
```

## Nonlinear Least Squares Solvers

```@docs
GaussNewton
```

## Both Nonlinear & Nonlinear Least Squares Solvers

These solvers can be used for both nonlinear and nonlinear least squares problems.

```@docs
TrustRegion
LevenbergMarquardt
PseudoTransient
```

## Polyalgorithms

```@docs
NonlinearSolvePolyAlgorithm
FastShortcutNonlinearPolyalg
FastShortcutNLLSPolyalg
RobustMultiNewton
```

## Advanced Solvers

All of the previously mentioned solvers are wrappers around the following solvers. These
are meant for advanced users and allow building custom solvers.

```@docs
QuasiNewtonAlgorithm
GeneralizedFirstOrderAlgorithm
GeneralizedDFSane
```

## [Forcing Term Strategies](@id forcing_strategies)

Forcing term strategies control how accurately the linear system is solved at each Newton
iteration when using iterative (Krylov) linear solvers. This is the key idea behind
Newton-Krylov methods: instead of solving ``J \delta u = -f(u)`` exactly, we solve it only
approximately with a tolerance ``\eta_k`` (the forcing term).

The [eisenstat1996choosing](@citet) paper introduced adaptive strategies for choosing
``\eta_k`` that can significantly improve convergence, especially for problems where the
initial guess is far from the solution.

```@docs
EisenstatWalkerForcing2
```

### Example Usage

```julia
using NonlinearSolve, LinearSolve

# Define a large nonlinear problem
function f!(F, u, p)
    for i in 2:(length(u) - 1)
        F[i] = u[i - 1] - 2u[i] + u[i + 1] + sin(u[i])
    end
    F[1] = u[1] - 1.0
    F[end] = u[end]
end

n = 1000
u0 = zeros(n)
prob = NonlinearProblem(f!, u0)

# Use Newton-Raphson with GMRES and Eisenstat-Walker forcing
sol = solve(prob, NewtonRaphson(
    linsolve = KrylovJL_GMRES(),
    forcing = EisenstatWalkerForcing2()
))
```

# [Diagnostics API](@id diagnostics_api)

Detailed API Documentation is provided at
[Diagnostics API Reference](@ref diagnostics_api_reference).

## Logging the Solve Process

All NonlinearSolve.jl native solvers allow storing and displaying the trace of the nonlinear
solve process. This is controlled by 3 keyword arguments to `solve`:

 1. `show_trace`: Must be `Val(true)` or `Val(false)`. This controls whether the trace is
    displayed to the console. (Defaults to `Val(false)`)
 2. `trace_level`: Needs to be one of Trace Objects: [`TraceMinimal`](@ref),
    [`TraceWithJacobianConditionNumber`](@ref), or [`TraceAll`](@ref). This controls the
    level of detail of the trace. (Defaults to `TraceMinimal()`)
 3. `store_trace`: Must be `Val(true)` or `Val(false)`. This controls whether the trace is
    stored in the solution object. (Defaults to `Val(false)`)

## Detailed Internal Timings

All the native NonlinearSolve.jl algorithms come with in-built
[TimerOutputs.jl](https://github.com/KristofferC/TimerOutputs.jl) support. However, this
is disabled by default and can be enabled via [`NonlinearSolveBase.enable_timer_outputs`](@ref).

Note that you will have to restart Julia to disable the timer outputs once enabled.

## Example Usage

```@example diagnostics_example
import NonlinearSolve as NLS

function nlfunc(resid, u0, p)
    resid[1] = u0[1] * u0[1] - p
    resid[2] = u0[2] * u0[2] - p
    resid[3] = u0[3] * u0[3] - p
    nothing
end

prob = NLS.NonlinearProblem(nlfunc, [1.0, 3.0, 5.0], 2.0)

NLS.solve(prob)
```

This produced the output, but it is hard to diagnose what is going on. We can turn on
the trace to see what is happening:

```@example diagnostics_example
NLS.solve(prob; show_trace = Val(true), trace_level = NLS.TraceAll(10))
nothing; # hide
```

You can also store the trace in the solution object:

```@example diagnostics_example
sol = NLS.solve(prob; trace_level = NLS.TraceAll(), store_trace = Val(true));

sol.trace
```

Now, let's try to investigate the time it took for individual internal steps. We will have
to use the `init` and `solve!` API for this. The `TimerOutput` will be present in
`cache.timer`. However, note that for poly-algorithms this is currently not implemented.

```@example diagnostics_example
cache = NLS.init(prob, NLS.NewtonRaphson(); show_trace = Val(true));
NLS.solve!(cache)
cache.timer
```

Let's try for some other solver:

```@example diagnostics_example
cache = NLS.init(prob, NLS.DFSane(); show_trace = Val(true), trace_level = NLS.TraceMinimal(50));
NLS.solve!(cache)
cache.timer
```

!!! note
    
    For `iteration == 0` only the `norm(fu, Inf)` is guaranteed to be meaningful. The other
    values being meaningful are solver dependent.

# [Nonlinear System Solvers](@id nonlinearsystemsolvers)

```julia
solve(prob::NonlinearProblem, alg; kwargs...)
```

Solves for ``f(u) = 0`` in the problem defined by `prob` using the algorithm `alg`. If no
algorithm is given, a default algorithm will be chosen.

## Recommended Methods

The default method [`FastShortcutNonlinearPolyalg`](@ref) is a good choice for most
problems. It is a polyalgorithm that attempts to use a fast algorithm ([`Klement`](@ref),
[`Broyden`](@ref)) and if that fails it falls back to a more robust algorithm
([`NewtonRaphson`](@ref)) before falling back the most robust variant of
[`TrustRegion`](@ref). For basic problems this will be very fast, for harder problems it
will make sure to work.

If one is looking for more robustness then [`RobustMultiNewton`](@ref) is a good choice. It
attempts a set of the most robust methods in succession and only fails if all of the methods
fail to converge. Additionally, [`DynamicSS`](@ref) can be a good choice for high stability
if the root corresponds to a stable equilibrium.

As a balance, [`NewtonRaphson`](@ref) is a good choice for most problems that aren't too
difficult yet need high performance, and  [`TrustRegion`](@ref) is a bit less performant but
more stable. If the problem is well-conditioned, [`Klement`](@ref) or [`Broyden`](@ref) may
be faster, but highly dependent on the eigenvalues of the Jacobian being sufficiently small.

[`NewtonRaphson`](@ref) and [`TrustRegion`](@ref) are designed for for large systems. They
can make use of sparsity patterns for sparse automatic differentiation and sparse linear
solving of very large systems. Meanwhile, [`SimpleNewtonRaphson`](@ref) and
[`SimpleTrustRegion`](@ref) are implementations which are specialized for small equations.
They are non-allocating on static arrays and thus really well-optimized for small systems,
thus usually outperforming the other methods when such types are used for `u0`.
Additionally, these solvers can be used inside GPU kernels. See
[ParallelParticleSwarms.jl](https://github.com/SciML/ParallelParticleSwarms.jl) for an example of this.

## Full List of Methods

!!! note
    
    For the full details on the capabilities and constructors of the different solvers,
    see the Detailed Solver APIs section!

### NonlinearSolve.jl

These are the core solvers, which excel at large-scale problems that need advanced
linear solver, automatic differentiation, abstract array types, GPU,
sparse/structured matrix support, etc. These methods support the largest set of types and
features, but have a bit of overhead on very small problems.

  - [`NewtonRaphson()`](@ref): A Newton-Raphson method with swappable nonlinear solvers and
    autodiff methods for high performance on large and sparse systems. Supports Newton-Krylov
    methods with adaptive forcing via [`EisenstatWalkerForcing2`](@ref).
  - [`TrustRegion()`](@ref): A Newton Trust Region dogleg method with swappable nonlinear
    solvers and autodiff methods for high performance on large and sparse systems.
  - [`LevenbergMarquardt()`](@ref): An advanced Levenberg-Marquardt implementation with the
    improvements suggested in the [transtrum2012improvements](@citet). Designed for
    large-scale and numerically-difficult nonlinear systems.
  - [`PseudoTransient()`](@ref): A pseudo-transient method which mixes the stability of
    Euler-type stepping with the convergence speed of a Newton method. Good for highly
    unstable systems.
  - [`RobustMultiNewton()`](@ref): A polyalgorithm that mixes highly robust methods (line
    searches and trust regions) in order to be as robust as possible for difficult problems.
    If this method fails to converge, then one can be pretty certain that most (all?) other
    choices would likely fail.
  - [`FastShortcutNonlinearPolyalg()`](@ref): The default method. A polyalgorithm that mixes
    fast methods with fallbacks to robust methods to allow for solving easy problems quickly
    without sacrificing robustness on the hard problems.
  - [`Broyden()`](@ref): Generalization of Broyden's Quasi-Newton Method with Line Search
    and Automatic Jacobian Resetting. This is a fast method but unstable when the condition
    number of the Jacobian matrix is sufficiently large.
  - [`Klement()`](@ref): Generalization of Klement's Quasi-Newton Method with Line Search
    and Automatic Jacobian Resetting. This is a fast method but unstable when the condition
    number of the Jacobian matrix is sufficiently large.
  - [`LimitedMemoryBroyden()`](@ref): An advanced version of
    [`SimpleLimitedMemoryBroyden`](@ref) which uses a limited memory Broyden method. This is
    a fast method but unstable when the condition number of the Jacobian matrix is
    sufficiently large. It is recommended to use [`Broyden`](@ref) or [`Klement`](@ref)
    instead unless the memory usage is a concern.

### SimpleNonlinearSolve.jl

These methods are included with NonlinearSolve.jl by default, though SimpleNonlinearSolve.jl
can be used directly to reduce dependencies and improve load times.
SimpleNonlinearSolve.jl's methods excel at small problems and problems defined with static
arrays.

  - [`SimpleNewtonRaphson()`](@ref): A simplified implementation of the Newton-Raphson
    method.
  - [`SimpleBroyden()`](@ref): The classic Broyden's quasi-Newton method.
  - [`SimpleLimitedMemoryBroyden()`](@ref): A low-memory Broyden implementation, similar to
    L-BFGS. This method is common in machine learning contexts but is known to be unstable
    in comparison to many other choices.
  - [`SimpleKlement()`](@ref): A quasi-Newton method due to Klement. It's supposed to be
    more efficient than Broyden's method, and it seems to be in the cases that have been
    tried, but more benchmarking is required.
  - [`SimpleTrustRegion()`](@ref): A dogleg trust-region Newton method. Improved globalizing
    stability for more robust fitting over basic Newton methods, though potentially with a
    cost.
  - [`SimpleDFSane()`](@ref): A low-overhead implementation of the df-sane method for
    solving large-scale nonlinear systems of equations.
  - [`SimpleHalley()`](@ref): A low-overhead implementation of the Halley method. This is a
    higher order method and thus can converge faster to low tolerances than a Newton method.
    Requires higher order derivatives, so best used when automatic differentiation is
    available.

!!! note
    
    When used with certain types for the states `u` such as a `Number` or `StaticArray`,
    these solvers are very efficient and non-allocating. These implementations are thus
    well-suited for small systems of equations.

### SteadyStateDiffEq.jl

SteadyStateDiffEq.jl uses ODE solvers to iteratively approach the steady state. It is a
very stable method for solving nonlinear systems with stable equilibrium points, though
often more computationally expensive than direct methods.

  - [`DynamicSS()`](@ref): Uses an ODE solver to find the steady state. Automatically
    terminates when close to the steady state.
  - [`SSRootfind()`](@ref): Uses a NonlinearSolve compatible solver to find the steady
    state.

### NLsolve.jl

This is a wrapper package for importing solvers from NLsolve.jl into the SciML interface.

  - [`NLsolveJL()`](@ref): A wrapper for
    [NLsolve.jl](https://github.com/JuliaNLSolvers/NLsolve.jl)

Submethod choices for this algorithm include:

  - `:anderson`: Anderson-accelerated fixed-point iteration
  - `:newton`: Classical Newton method with an optional line search
  - `:trust_region`: Trust region Newton method (the default choice)

### MINPACK.jl

MINPACK.jl is a wrapper package for bringing the Fortran solvers from MINPACK. However, our
benchmarks reveal that these methods are rarely competitive with our native solvers. Thus,
our recommendation is to use these only for benchmarking and debugging purposes.

  - [`CMINPACK()`](@ref): A wrapper for using the classic MINPACK method through
    [MINPACK.jl](https://github.com/sglyon/MINPACK.jl)

Submethod choices for this algorithm include:

  - `:hybr`: Modified version of Powell's algorithm.
  - `:lm`: Levenberg-Marquardt.
  - `:lmdif`: Advanced Levenberg-Marquardt
  - `:hybrd`: Advanced modified version of Powell's algorithm

### Sundials.jl

Sundials.jl are a classic set of C/Fortran methods which are known for good scaling of the
Newton-Krylov form. However, KINSOL is known to be less stable than some other
implementations.

  - [`KINSOL()`](@ref): The KINSOL method of the SUNDIALS C library

### SIAMFANLEquations.jl

SIAMFANLEquations.jl is a wrapper for the methods in the SIAMFANLEquations.jl library.

  - [`SIAMFANLEquationsJL()`](@ref): A wrapper for using the methods in
    [SIAMFANLEquations.jl](https://github.com/ctkelley/SIAMFANLEquations.jl)

Other solvers listed in [Fixed Point Solvers](@ref fixed_point_methods_full_list),
[FastLevenbergMarquardt.jl](@ref fastlm_wrapper_summary) and
[LeastSquaresOptim.jl](@ref lso_wrapper_summary) can also solve nonlinear systems.

### NLSolvers.jl

This is a wrapper package for importing solvers from NLSolvers.jl into the SciML interface.

  - [`NLSolversJL()`](@ref): A wrapper for
    [NLSolvers.jl](https://github.com/JuliaNLSolvers/NLSolvers.jl)

For a list of possible solvers see the [NLSolvers.jl documentation](https://julianlsolvers.github.io/NLSolvers.jl/)

### PETSc.jl

This is a wrapper package for importing solvers from PETSc.jl into the SciML interface.

  - [`PETScSNES()`](@ref): A wrapper for
    [PETSc.jl](https://github.com/JuliaParallel/PETSc.jl)

For a list of possible solvers see the [PETSc.jl documentation](https://petsc.org/release/manual/snes/)

### SciPy (Python via PythonCall)

These wrappers let you use the algorithms from
[`scipy.optimize`](https://docs.scipy.org/doc/scipy/reference/optimize.html)
without leaving Julia.  SciPy is loaded lazily through PythonCall, so these
methods are available whenever the `scipy` Python package can be imported.

  - [`SciPyRoot()`](@ref): wrapper for `scipy.optimize.root` (vector problems)
  - [`SciPyRootScalar()`](@ref): wrapper for `scipy.optimize.root_scalar` (scalar/bracketed problems)

# BracketingNonlinearSolve.jl

These methods can be used independently of the rest of NonlinearSolve.jl

```@index
Pages = ["bracketingnonlinearsolve.md"]
```

## Interval Methods

These methods are suited for interval (scalar) root-finding problems,
i.e. [`IntervalNonlinearProblem`](@ref).

```@docs
Alefeld
Bisection
Brent
Falsi
ITP
ModAB
Muller
Ridder
```

# Sundials.jl

This is a wrapper package for importing solvers from Sundials into the SciML interface.
Note that these solvers do not come by default, and thus one needs to install the package
before using these solvers:

```julia
import Pkg
Pkg.add("Sundials")
import Sundials
```

These methods can be used independently of the rest of NonlinearSolve.jl.

## Solver API

```@docs
KINSOL
```

```@meta
CurrentModule = SciMLJacobianOperators
```

# SciMLJacobianOperators.jl

This is a subpackage on NonlinearSolve providing a general purpose JacVec and VecJac
operator built on top on DifferentiationInterface.jl.

```julia
import Pkg
Pkg.add("SciMLJacobianOperators")
import SciMLJacobianOperators
```

## Jacobian API

```@docs
JacobianOperator
VecJacOperator
JacVecOperator
```

## Stateful Operators

```@docs
StatefulJacobianOperator
StatefulJacobianNormalFormOperator
```

# [Optimizing a Parameterized ODE](@id optimizing-parameterized-ode)

Let us fit a parameterized ODE to some data. We will use the Lotka-Volterra model as an
example. We will use Single Shooting to fit the parameters.

```@example parameterized_ode
import OrdinaryDiffEqTsit5 as ODE
import NonlinearSolve as NLS
import Plots
```

Let us simulate some real data from the Lotka-Volterra model.

```@example parameterized_ode
function lotka_volterra!(du, u, p, t)
    x, y = u
    α, β, δ, γ = p
    du[1] = dx = α * x - β * x * y
    du[2] = dy = -δ * y + γ * x * y
end

# Initial condition
u0 = [1.0, 1.0]

# Simulation interval and intermediary points
tspan = (0.0, 2.0)
tsteps = 0.0:0.1:10.0

# LV equation parameter. p = [α, β, δ, γ]
p = [1.5, 1.0, 3.0, 1.0]

# Setup the ODE problem, then solve
prob = ODE.ODEProblem(lotka_volterra!, u0, tspan, p)
sol = ODE.solve(prob, ODE.Tsit5(); saveat = tsteps)

# Plot the solution
Plots.plot(sol; linewidth = 3)
```

Let us now formulate the parameter estimation as a Nonlinear Least Squares Problem.

```@example parameterized_ode
function loss_function(ode_param, data)
    sol = ODE.solve(prob, ODE.Tsit5(); p = ode_param, saveat = tsteps)
    return vec(reduce(hcat, sol.u)) .- data
end

p_init = zeros(4)

nlls_prob = NLS.NonlinearLeastSquaresProblem(loss_function, p_init, vec(reduce(hcat, sol.u)))
```

Now, we can use any NLLS solver to solve this problem.

```@example parameterized_ode
res = NLS.solve(
    nlls_prob, NLS.LevenbergMarquardt(); maxiters = 1000, show_trace = Val(true),
    trace_level = NLS.TraceWithJacobianConditionNumber(25))
nothing # hide
```

```@example parameterized_ode
res
```

We can also use Trust Region methods.

```@example parameterized_ode
res = NLS.solve(nlls_prob, NLS.TrustRegion(); maxiters = 1000, show_trace = Val(true),
    trace_level = NLS.TraceWithJacobianConditionNumber(25))
nothing # hide
```

```@example parameterized_ode
res
```

Let's plot the solution.

```@example parameterized_ode
prob2 = ODE.remake(prob; tspan = (0.0, 10.0))
sol_fit = ODE.solve(prob2, ODE.Tsit5(); p = res.u)
sol_true = ODE.solve(prob2, ODE.Tsit5(); p = p)
Plots.plot(sol_true; linewidth = 3)
Plots.plot!(sol_fit; linewidth = 3, linestyle = :dash)
```

# [Nonlinear Solver Iterator Interface](@id iterator)

There is an iterator form of the nonlinear solver which somewhat mirrors the DiffEq
integrator interface:

```@example iterator_interface
import NonlinearSolve as NLS

f(u, p) = u .* u .- 2.0
u0 = 1.5
probB = NLS.NonlinearProblem(f, u0)

nlcache = NLS.init(probB, NLS.NewtonRaphson())
```

`init` takes the same keyword arguments as [`solve`](@ref solver_options), but it returns a
cache object that satisfies `typeof(nlcache) <: AbstractNonlinearSolveCache` and can be used
to iterate the solver.

The iterator interface supports:

```@docs
step!(nlcache::NonlinearSolveBase.AbstractNonlinearSolveCache, args...; kwargs...)
```

We can perform 10 steps of the Newton-Raphson solver with the following:

```@example iterator_interface
for i in 1:10
    NLS.step!(nlcache)
end
```

We currently don't implement a `Base.iterate` interface but that will be added in the
future.
